# This is an automatically generated R code. Don't edit.
# Generated by 
# /home/sokol/.local/bin/ftbl2optR.py --tblimit 0 --ropts "TIMEIT=TRUE" e_coli.ftbl
# at Thu Nov  7 14:58:06 2019.

# Copyright 2011-2019, INRA, France.

# working dir
dirw="/home/sokol/insa/sysbio/dev/ftbl2sys/tmp/test"

# installation dir (where influx_si/R/*.R live)
dirr="/home/sokol/.local/lib/python3.7/site-packages/influx_si/R"
# short base name of the FTBL (withount '.ftbl')
baseshort="e_coli"

fcerr=file(file.path(dirw, sprintf("%s.err", baseshort)), "ab")
fclog=file(file.path(dirw, sprintf("%s.log", baseshort)), "ab")

options(warn=1)
options(digits.secs=2)

case_i=F

if (length(find("bitwAnd"))==0L) {
   suppressPackageStartupMessages(library(bitops))
   bitwAnd=bitAnd
}
source(file.path(dirr, "libs.R"))

# define matprod for simple_triplet_matrix
`%stm%` = slam::matprod_simple_triplet_matrix

# default options
version=FALSE
noopt=FALSE
noscale=FALSE
meth="nlsic"
fullsys=FALSE
emu=FALSE
irand=FALSE
sens=""
cupx=0.999
cupn=1.e3
cupp=1.e5
clownr=0
cinout=0
clowp=1.e-8
np=0
ln=FALSE
tikhreg=FALSE
sln=FALSE
lim=FALSE
zc=-.Machine$double.xmax
ffguess=FALSE
fdfit=FALSE
addnoise=FALSE
fseries=""
iseries=""
seed=-.Machine$integer.max
excl_outliers=FALSE
TIMEIT=FALSE
prof=FALSE
time_order="1"

# get runtime arguments
TIMEIT=TRUE

# synonymous
myver=version
optimize=!noopt
method=meth
sensitive=sens
least_norm=ln
initrand=irand

vernum="5.0"

# sanity check for command line parameters
if (substring(sensitive, 1, 3)=="mc=") {
   # read the mc iteration number
   nmc=as.integer(substring(sensitive, 4))
   sensitive="mc"
} else if (sensitive=="mc") {
   nmc=10
}
# cupx==0 means no upper limit => cupx=1
cupx=ifelse(cupx, cupx, 1)
if (cupx < 0 || cupx > 1) {
   stop_mes(paste("Option '--cupx N' must have N in the interval [0,1]
",
      "Instead, the value ", cupx, " si given.", sep=""), file=fcerr)
}
if (cinout < 0) {
   stop_mes(paste("Option '--cinout N' must have N non negative
",
      "Instead, the value ", cinout, " is given.", sep=""), file=fcerr)
}
# minimization method
validmethods=list("BFGS", "Nelder-Mead", "SANN", "ipopt", "nlsic")
if (! method %in% validmethods) {
   cat(paste("Wraning: method", method, "is not known. 'nlsic' is used instead."), "\n", sep="", file=fcerr)
   method="nlsic"
}
if (method == "ipopt") {
   installed=suppressPackageStartupMessages(library(ipoptr, logical.return=T))
   if (!installed) {
      stop_mes("An optimization method ipopt is requested but available in this R installation", file=fcerr)
   }
}
if (least_norm && sln) {
   stop_mes("Options --ln and --sln cannot be activated simultaniously.", file=fcerr)
}

avaco=try(detectCores(), silent=T)
if (inherits(avaco, "try-error")) {
   avaco=NULL
}
if (np > 0L && np < 1L) {
   np=round(avaco*np)
} else if (np >= 1L) {
   np=round(np)
} else {
   np=avaco
}
if (is.null(np) || np <= 0L) {
   np=1L
}
if (sensitive=="mc") {
   np=min(np, nmc)
}
options(mc.cores=np)

if (least_norm+tikhreg+lim > 1) {
   stop_mes("Options --ln, --lim and --tikhreg cannot be activated simultaneously. Use only one of them at a time.", file=fcerr)
}
lsi_fun=lsi
if (least_norm || sln) {
   lsi_fun=lsi_ln
} else if (tikhreg) {
   lsi_fun=lsi_reg
} else if (lim) {
   suppressPackageStartupMessages(library(limSolve));
   lsi_fun=lsi_lim
}
if (zc==-.Machine$double.xmax) {
   # no zero scrossing to apply
   zerocross=F
} else {
   if (zc < 0.) {
      stop_mes(paste("Zero crossing value ZC must be non negative, instead ", zc, " is given.", sep=""), file=fcerr)
   }
   zerocross=T
}
if (seed==-.Machine$integer.max) {
   # no seed to apply
   set_seed=F
} else {
   set_seed=T
   set.seed(seed)
}
time_order=gsub("\\s", "", time_order) # remove spaces if any
if (!(time_order %in% c("1", "2", "1,2"))) {
   stop_mes(sprintf("time_order must be '1', '2' or '1,2'. Instead got '%s'"))
}
opts=commandArgs()
# end command line argument proceeding

# get some cumomer tools
source(file.path(dirr, "opt_cumo_tools.R"))
#loadcmp(file.path(dirr, "opt_cumo_tools.Rc"))

lab_resid=cumo_resid
lab_sim=param2fl_x
jx_f=new.env()

if (TIMEIT) {
   cat("rinit   : ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}

# R profiling
if (prof) {
   Rprof(sprintf("%s.Rprof", baseshort))
}

nm_list=list()
nb_f=list()

if (TIMEIT) {
   cat("r_flux  : ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}

# fwd-rev flux names
nm_fwrv=c("fwd.Glucupt_1", "fwd.Glucupt_U", "fwd.akgdh", "fwd.ald", "fwd.bs_DHAP", "fwd.bs_accoa", "fwd.bs_accoa_aux", "fwd.bs_akg", "fwd.bs_akg1", "fwd.bs_akg2", "fwd.bs_akg3", "fwd.bs_akg4", "fwd.bs_akg4_aux", "fwd.bs_e4p", "fwd.bs_fru6P", "fwd.bs_glc6P", "fwd.bs_oaa", "fwd.bs_oaa1", "fwd.bs_oaa1_aux", "fwd.bs_oaa2", "fwd.bs_oaa2_aux", "fwd.bs_oaa3_aux", "fwd.bs_oaa3a", "fwd.bs_oaa3b", "fwd.bs_oaa4", "fwd.bs_oaa5", "fwd.bs_oaa5_aux", "fwd.bs_oaa6", "fwd.bs_oaa6_aux", "fwd.bs_oaa7", "fwd.bs_oaa7_aux", "fwd.bs_pep", "fwd.bs_pep1", "fwd.bs_pep2", "fwd.bs_pep3_aux", "fwd.bs_pep3a", "fwd.bs_pep3b", "fwd.bs_pep4_aux", "fwd.bs_pep4a", "fwd.bs_pep4b", "fwd.bs_pep5", "fwd.bs_pep6", "fwd.bs_pep6_aux", "fwd.bs_pep7", "fwd.bs_pga", "fwd.bs_pga1", "fwd.bs_pga1_aux", "fwd.bs_pga2", "fwd.bs_pga2_aux", "fwd.bs_pga3", "fwd.bs_pga3_aux", "fwd.bs_pga_aux", "fwd.bs_pyr", "fwd.bs_pyr1", "fwd.bs_pyr1_aux", "fwd.bs_pyr2", "fwd.bs_pyr3", "fwd.bs_pyr3_aux", "fwd.bs_pyr4", "fwd.bs_pyr4_aux", "fwd.bs_rib5p", "fwd.bs_rib5p1", "fwd.bs_rib5p1_aux", "fwd.bs_rib5p2", "fwd.citsynth", "fwd.edd", "fwd.eno", "fwd.fum_a", "fwd.fum_b", "fwd.gnd", "fwd.idh", "fwd.mae", "fwd.maldh", "fwd.out_Ac", "fwd.out_FTHF", "fwd.out_co2", "fwd.pdh", "fwd.pfk", "fwd.pgi", "fwd.pgk", "fwd.ppc", "fwd.pyk", "fwd.ta", "fwd.tk1", "fwd.tk2", "fwd.zwf", "rev.Glucupt_1", "rev.Glucupt_U", "rev.akgdh", "rev.ald", "rev.bs_DHAP", "rev.bs_accoa", "rev.bs_accoa_aux", "rev.bs_akg", "rev.bs_akg1", "rev.bs_akg2", "rev.bs_akg3", "rev.bs_akg4", "rev.bs_akg4_aux", "rev.bs_e4p", "rev.bs_fru6P", "rev.bs_glc6P", "rev.bs_oaa", "rev.bs_oaa1", "rev.bs_oaa1_aux", "rev.bs_oaa2", "rev.bs_oaa2_aux", "rev.bs_oaa3_aux", "rev.bs_oaa3a", "rev.bs_oaa3b", "rev.bs_oaa4", "rev.bs_oaa5", "rev.bs_oaa5_aux", "rev.bs_oaa6", "rev.bs_oaa6_aux", "rev.bs_oaa7", "rev.bs_oaa7_aux", "rev.bs_pep", "rev.bs_pep1", "rev.bs_pep2", "rev.bs_pep3_aux", "rev.bs_pep3a", "rev.bs_pep3b", "rev.bs_pep4_aux", "rev.bs_pep4a", "rev.bs_pep4b", "rev.bs_pep5", "rev.bs_pep6", "rev.bs_pep6_aux", "rev.bs_pep7", "rev.bs_pga", "rev.bs_pga1", "rev.bs_pga1_aux", "rev.bs_pga2", "rev.bs_pga2_aux", "rev.bs_pga3", "rev.bs_pga3_aux", "rev.bs_pga_aux", "rev.bs_pyr", "rev.bs_pyr1", "rev.bs_pyr1_aux", "rev.bs_pyr2", "rev.bs_pyr3", "rev.bs_pyr3_aux", "rev.bs_pyr4", "rev.bs_pyr4_aux", "rev.bs_rib5p", "rev.bs_rib5p1", "rev.bs_rib5p1_aux", "rev.bs_rib5p2", "rev.citsynth", "rev.edd", "rev.eno", "rev.fum_a", "rev.fum_b", "rev.gnd", "rev.idh", "rev.mae", "rev.maldh", "rev.out_Ac", "rev.out_FTHF", "rev.out_co2", "rev.pdh", "rev.pfk", "rev.pgi", "rev.pgk", "rev.ppc", "rev.pyk", "rev.ta", "rev.tk1", "rev.tk2", "rev.zwf")

# edge to netflux name translator
edge2fl=c("d.n.bs_oaa2", "d.n.bs_oaa2", "d.n.bs_oaa2", "d.n.bs_oaa2", "d.n.bs_rib5p1", "d.n.bs_rib5p1", "d.n.bs_rib5p1", "d.n.citsynth", "d.n.citsynth", "d.n.citsynth", "d.n.bs_akg4_aux", "d.n.bs_oaa3b", "d.n.bs_oaa3b", "d.n.bs_oaa3b", "d.n.bs_oaa3b", "d.n.bs_akg4", "d.n.bs_akg4", "d.n.bs_akg4", "d.n.bs_pga3", "d.n.bs_pga3", "d.n.bs_pga3", "d.n.bs_pep2", "d.n.bs_pep2", "d.n.bs_pep2", "d.n.ppc", "d.n.ppc", "d.n.ppc", "c.n.bs_akg", "d.n.maldh", "c.n.bs_akg3", "c.n.bs_pyr", "c.n.bs_oaa2_aux", "d.n.bs_pyr1_aux", "d.n.pgi", "d.n.bs_pyr2", "d.n.bs_pyr2", "d.n.bs_pyr2", "d.n.bs_pyr2", "c.n.bs_rib5p", "d.n.bs_pep6", "d.n.bs_pep6", "d.n.bs_pep6", "d.n.bs_pep6", "d.n.out_FTHF", "c.n.bs_pyr3_aux", "c.n.bs_fru6P", "d.n.bs_pyr1", "c.n.bs_rib5p1_aux", "f.n.pyk", "c.n.bs_accoa", "d.n.bs_pga2", "c.n.bs_oaa5_aux", "d.n.bs_pep6_aux", "d.n.bs_pep3a", "d.n.bs_pep3a", "d.n.bs_pep3a", "d.n.bs_pep1", "d.n.bs_pep1", "d.n.bs_pep1", "d.n.eno", "d.n.bs_oaa7", "d.n.bs_pyr3", "d.n.bs_pyr3", "d.n.bs_pyr3", "d.n.bs_pyr3", "c.n.bs_oaa6_aux", "d.n.bs_oaa3a", "d.n.bs_oaa3a", "d.n.bs_oaa3a", "d.n.bs_oaa3a", "c.n.bs_oaa3_aux", "d.n.bs_oaa4", "c.n.bs_pyr4_aux", "d.n.out_co2", "c.n.bs_pga", "d.n.fum_b", "d.n.bs_oaa6", "d.n.bs_oaa6", "d.n.bs_oaa6", "d.n.bs_oaa1", "c.n.bs_pga3_aux", "c.n.bs_pep5", "d.n.bs_accoa_aux", "f.n.gnd", "f.n.gnd", "f.n.gnd", "d.n.bs_akg1", "f.n.Glucupt_1", "c.n.bs_pga1_aux", "c.n.bs_oaa", "c.n.bs_DHAP", "d.n.akgdh", "d.n.akgdh", "d.n.akgdh", "d.n.ta", "d.n.ta", "d.n.ta", "d.n.ta", "d.n.edd", "d.n.edd", "d.n.edd", "d.n.ald", "d.n.ald", "d.n.ald", "d.n.bs_pyr4", "d.n.pdh", "d.n.pdh", "d.n.pdh", "d.n.bs_e4p", "c.n.bs_pep", "d.n.idh", "d.n.idh", "d.n.idh", "d.n.mae", "d.n.mae", "d.n.mae", "c.n.bs_pep3_aux", "c.n.bs_oaa7_aux", "d.n.tk2", "d.n.tk2", "d.n.tk2", "d.n.tk2", "d.n.pgk", "c.n.bs_glc6P", "d.n.bs_pep3b", "d.n.bs_pep3b", "d.n.bs_pep3b", "c.n.bs_akg2", "c.n.bs_pep4_aux", "d.n.tk1", "d.n.tk1", "d.n.tk1", "d.n.tk1", "c.n.bs_pga2_aux", "d.n.pfk", "d.n.bs_oaa5", "d.n.bs_pep4a", "d.n.bs_pep4a", "d.n.bs_pep4a", "d.n.bs_pep4b", "d.n.bs_pep4b", "d.n.bs_pep4b", "d.n.Glucupt_U", "c.n.bs_oaa1_aux", "d.n.bs_rib5p2", "d.n.bs_pga1", "d.n.fum_a", "f.n.out_Ac", "f.n.zwf", "d.n.bs_pep7", "d.n.bs_pep7", "d.n.bs_pep7", "d.n.bs_pga_aux")
names(edge2fl)=c("Thr (bs_oaa2) bs_oaa2", "BM_Pyr (bs_oaa2) bs_oaa2", "bs_oaa2 (bs_oaa2) Ile", "bs_oaa2 (bs_oaa2) CO2", "BM_Rib5P (bs_rib5p1) bs_rib5p1", "FTHF (bs_rib5p1) bs_rib5p1", "bs_rib5p1 (bs_rib5p1) His", "AcCoA (citsynth) citsynth", "OAA (citsynth) citsynth", "citsynth (citsynth) ICit", "Arg (bs_akg4_aux) Arg_Aux", "BM_OAA (bs_oaa3b) bs_oaa3b", "BM_Pyr (bs_oaa3b) bs_oaa3b", "bs_oaa3b (bs_oaa3b) Lys", "bs_oaa3b (bs_oaa3b) CO2", "Glu (bs_akg4) bs_akg4", "CO2 (bs_akg4) bs_akg4", "bs_akg4 (bs_akg4) Arg", "Ser (bs_pga3) bs_pga3", "bs_pga3 (bs_pga3) Gly", "bs_pga3 (bs_pga3) FTHF", "BM_PEP (bs_pep2) bs_pep2", "DAHP (bs_pep2) bs_pep2", "bs_pep2 (bs_pep2) Chor", "PEP (ppc) ppc", "CO2 (ppc) ppc", "ppc (ppc) OAA", "AKG (bs_akg) BM_AKG", "Mal (maldh) OAA", "Glu (bs_akg3) Gln", "Pyr (bs_pyr) BM_Pyr", "Ile (bs_oaa2_aux) Ile_Aux", "Ala (bs_pyr1_aux) Ala_Aux", "Glc6P (pgi) Fru6P", "BM_Pyr (bs_pyr21) bs_pyr2", "BM_Pyr (bs_pyr22) bs_pyr2", "bs_pyr2 (bs_pyr2) AKV", "bs_pyr2 (bs_pyr2) CO2", "Rib5P (bs_rib5p) BM_Rib5P", "Chor (bs_pep6) bs_pep6", "BM_Rib5P (bs_pep6) bs_pep6", "bs_pep6 (bs_pep6) Trp", "bs_pep6 (bs_pep6) PyrCO2", "FTHF (out_FTHF) FTHF_out", "Leu (bs_pyr3_aux) Leu_Aux", "Fru6P (bs_fru6P) BM_Fru6P", "BM_Pyr (bs_pyr1) Ala", "His (bs_rib5p1_aux) His_Aux", "PEP (pyk) Pyr", "AcCoA (bs_accoa) BM_AcCoA", "Ser (bs_pga2) Cys", "Thr (bs_oaa5_aux) Thr_Aux", "Trp (bs_pep6_aux) Trp_Aux", "Chor (bs_pep3a) bs_pep3a", "bs_pep3a (bs_pep3a) Phe", "bs_pep3a (bs_pep3a) CO2", "BM_PEP (bs_pep1) bs_pep1", "BM_Ery4P (bs_pep1) bs_pep1", "bs_pep1 (bs_pep1) DAHP", "PGA (eno) PEP", "BM_OAA (bs_oaa7) Asn", "AKV (bs_pyr3) bs_pyr3", "BM_AcCoA (bs_pyr3) bs_pyr3", "bs_pyr3 (bs_pyr3) Leu", "bs_pyr3 (bs_pyr3) CO2", "Met (bs_oaa6_aux) Met_Aux", "BM_OAA (bs_oaa3a) bs_oaa3a", "BM_Pyr (bs_oaa3a) bs_oaa3a", "bs_oaa3a (bs_oaa3a) Lys", "bs_oaa3a (bs_oaa3a) CO2", "Lys (bs_oaa3_aux) Lys_Aux", "BM_OAA (bs_oaa4) OAA_Aux", "Val (bs_pyr4_aux) Val_Aux", "CO2 (out_co2) CO2_out", "PGA (bs_pga) BM_PGA", "Suc (fum_b) Mal", "BM_OAA (bs_oaa6) bs_oaa6", "FTHF (bs_oaa6) bs_oaa6", "bs_oaa6 (bs_oaa6) Met", "BM_OAA (bs_oaa1) Asp", "Gly (bs_pga3_aux) Gly_Aux", "BM_PEP (bs_pep5) PEP_Aux", "BM_AcCoA (bs_accoa_aux) AcCoA_Aux", "Gnt6P (gnd) gnd", "gnd (gnd) CO2", "gnd (gnd) Rib5P", "BM_AKG (bs_akg1) Glu", "Gluc_1 (Glucupt_1) Glc6P", "Ser (bs_pga1_aux) Ser_Aux", "OAA (bs_oaa) BM_OAA", "GA3P (bs_DHAP) Glp", "AKG (akgdh) akgdh", "akgdh (akgdh) Suc", "akgdh (akgdh) CO2", "GA3P (ta) ta", "Sed7P (ta) ta", "ta (ta) Ery4P", "ta (ta) Fru6P", "Gnt6P (edd) edd", "edd (edd) Pyr", "edd (edd) GA3P", "FruBP (ald) ald", "ald (ald1) GA3P", "ald (ald2) GA3P", "AKV (bs_pyr4) Val", "Pyr (pdh) pdh", "pdh (pdh) AcCoA", "pdh (pdh) CO2", "Ery4P (bs_e4p) BM_Ery4P", "PEP (bs_pep) BM_PEP", "ICit (idh) idh", "idh (idh) AKG", "idh (idh) CO2", "Mal (mae) mae", "mae (mae) Pyr", "mae (mae) CO2", "Phe (bs_pep3_aux) Phe_Aux", "Asn (bs_oaa7_aux) Asn_Aux", "Rib5P (tk2) tk2", "Ery4P (tk2) tk2", "tk2 (tk2) GA3P", "tk2 (tk2) Fru6P", "GA3P (pgk) PGA", "Glc6P (bs_glc6P) BM_Glc6P", "Chor (bs_pep3b) bs_pep3b", "bs_pep3b (bs_pep3b) Phe", "bs_pep3b (bs_pep3b) CO2", "Glu (bs_akg2) Pro", "Tyr (bs_pep4_aux) Tyr_Aux", "Rib5P (tk11) tk1", "Rib5P (tk12) tk1", "tk1 (tk1) GA3P", "tk1 (tk1) Sed7P", "Cys (bs_pga2_aux) Cys_Aux", "Fru6P (pfk) FruBP", "BM_OAA (bs_oaa5) Thr", "Chor (bs_pep4a) bs_pep4a", "bs_pep4a (bs_pep4a) Tyr", "bs_pep4a (bs_pep4a) CO2", "Chor (bs_pep4b) bs_pep4b", "bs_pep4b (bs_pep4b) Tyr", "bs_pep4b (bs_pep4b) CO2", "Gluc_U (Glucupt_U) Glc6P", "Asp (bs_oaa1_aux) Asp_Aux", "BM_Rib5P (bs_rib5p2) Ri5P_Aux", "BM_PGA (bs_pga1) Ser", "Suc (fum_a) Mal", "AcCoA (out_Ac) Acetate", "Glc6P (zwf) Gnt6P", "PyrCO2 (bs_pep7) bs_pep7", "bs_pep7 (bs_pep7) Pyr", "bs_pep7 (bs_pep7) CO2", "BM_PGA (bs_pga_aux) PGA_Aux")

# initialize the linear system Afl*flnx=bfl (0-weight cumomers)
# unknown net flux names
nm_fln=c("d.n.Glucupt_U", "d.n.akgdh", "d.n.ald", "d.n.bs_accoa_aux", "d.n.bs_akg1", "d.n.bs_akg4", "d.n.bs_akg4_aux", "d.n.bs_e4p", "d.n.bs_oaa1", "d.n.bs_oaa2", "d.n.bs_oaa3a", "d.n.bs_oaa3b", "d.n.bs_oaa4", "d.n.bs_oaa5", "d.n.bs_oaa6", "d.n.bs_oaa7", "d.n.bs_pep1", "d.n.bs_pep2", "d.n.bs_pep3a", "d.n.bs_pep3b", "d.n.bs_pep4a", "d.n.bs_pep4b", "d.n.bs_pep6", "d.n.bs_pep6_aux", "d.n.bs_pep7", "d.n.bs_pga1", "d.n.bs_pga2", "d.n.bs_pga3", "d.n.bs_pga_aux", "d.n.bs_pyr1", "d.n.bs_pyr1_aux", "d.n.bs_pyr2", "d.n.bs_pyr3", "d.n.bs_pyr4", "d.n.bs_rib5p1", "d.n.bs_rib5p2", "d.n.citsynth", "d.n.edd", "d.n.eno", "d.n.fum_a", "d.n.fum_b", "d.n.idh", "d.n.mae", "d.n.maldh", "d.n.out_FTHF", "d.n.out_co2", "d.n.pdh", "d.n.pfk", "d.n.pgi", "d.n.pgk", "d.n.ppc", "d.n.ta", "d.n.tk1", "d.n.tk2")
nb_fln=length(nm_fln)
fln=c(0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0)
names(fln)=nm_fln
# unknown xch flux names
nm_flx=c("d.x.fum_b")
nb_flx=length(nm_flx)
flx=c(0.0)
names(flx)=nm_flx
nm_fl=c(nm_fln, nm_flx)
nb_fl=nb_fln+nb_flx
fl=c(fln, flx)
# gather flux names in a list
nm_list$flnx=nm_fl
nm_list$fwrv=nm_fwrv

# carbon length of metabolites
clen=c(4,3,6,1,5,1,6,2,4,6,6,6,4,6,5,3,2,3,7,10,3,5,5,4,5,3,6,3,3,6,6,5,5,11,4,1,6,6,6,6,2,3,4,11,9,4,3,4,5,5,6,4,5,5,1,3,4,4,2,3,2,6,6,3,3,3,7,4,6,9,4,6,5,9,9,3,6,4,5,2,3)
names(clen)=c("Thr","BM_Pyr","Ile","CO2","BM_Rib5P","FTHF","His","AcCoA","OAA","ICit","Arg","Arg_Aux","BM_OAA","Lys","Glu","Ser","Gly","BM_PEP","DAHP","Chor","PEP","AKG","BM_AKG","Mal","Gln","Pyr","Ile_Aux","Ala","Ala_Aux","Glc6P","Fru6P","AKV","Rib5P","Trp","PyrCO2","FTHF_out","Leu","Leu_Aux","BM_Fru6P","His_Aux","BM_AcCoA","Cys","Thr_Aux","Trp_Aux","Phe","BM_Ery4P","PGA","Asn","Met","Met_Aux","Lys_Aux","OAA_Aux","Val","Val_Aux","CO2_out","BM_PGA","Suc","Asp","Gly_Aux","PEP_Aux","AcCoA_Aux","Gnt6P","Gluc_1","Ser_Aux","GA3P","Glp","Sed7P","Ery4P","FruBP","Phe_Aux","Asn_Aux","BM_Glc6P","Pro","Tyr","Tyr_Aux","Cys_Aux","Gluc_U","Asp_Aux","Ri5P_Aux","Acetate","PGA_Aux")

# metabolite pools are : all (poolall) which is divided in free (poolf) and
# constrained (poolc)

# constrained pool
poolc=c()
nm_poolc=c()
if (length(nm_poolc)) {
   names(nm_poolc)=substring(nm_poolc, 4)
}
names(poolc)=nm_poolc

# starting values for free pool (the same number and the same alphabetic order than free growth fluxes, if present)
poolf=c()
nm_poolf=c()
if (length(nm_poolf)) {
   names(nm_poolf)=substring(nm_poolf, 4)
}
names(poolf)=nm_poolf
nb_poolf=length(poolf)
nb_f$nb_poolf=nb_poolf

nm_poolall=c(nm_poolf, nm_poolc)
poolall=as.numeric(c(poolf, poolc))
names(poolall)=nm_poolall
pool=poolall
nm_list$poolf=nm_poolf
nm_list$poolc=nm_poolc
nm_list$poolall=nm_poolall

# flux matrix
nb_flr=55
if (nb_fl) {
   Afl=matrix(0, nrow=nb_flr, ncol=nb_fl)
   Afl[1, c(10, 14)]=c(-1.0, 1.0)
   Afl[2, c(10, 11, 12, 30, 32)]=c(-1.0, -1.0, -1.0, -1.0, -2.0)
   Afl[3, c(10)]=c(1.0)
   Afl[4, c(2, 6, 10, 11, 12, 19, 20, 21, 22, 25, 32, 33, 42, 43, 46, 47, 51)]=c(1.0, -1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, -1.0, 1.0, -1.0)
   Afl[5, c(23, 35, 36)]=c(-1.0, -1.0, -1.0)
   Afl[6, c(15, 28, 35, 45)]=c(-1.0, 1.0, -1.0, -1.0)
   Afl[7, c(35)]=c(1.0)
   Afl[8, c(37, 47)]=c(-1.0, 1.0)
   Afl[9, c(37, 44, 51)]=c(-1.0, 1.0, 1.0)
   Afl[10, c(37, 42)]=c(1.0, -1.0)
   Afl[11, c(6, 7)]=c(1.0, -1.0)
   Afl[12, c(9, 11, 12, 13, 14, 15, 16)]=c(-1.0, -1.0, -1.0, -1.0, -1.0, -1.0, -1.0)
   Afl[13, c(11, 12)]=c(1.0, 1.0)
   Afl[14, c(5, 6)]=c(1.0, -1.0)
   Afl[15, c(26, 27, 28)]=c(1.0, -1.0, -1.0)
   Afl[16, c(28)]=c(1.0)
   Afl[17, c(17, 18)]=c(-1.0, -1.0)
   Afl[18, c(17, 18)]=c(1.0, -1.0)
   Afl[19, c(18, 19, 20, 21, 22, 23)]=c(1.0, -1.0, -1.0, -1.0, -1.0, -1.0)
   Afl[20, c(39, 51)]=c(1.0, -1.0)
   Afl[21, c(2, 42)]=c(-1.0, 1.0)
   Afl[22, c(5)]=c(-1.0)
   Afl[23, c(40, 41, 43, 44)]=c(1.0, 1.0, -1.0, -1.0)
   Afl[24, c(25, 38, 43, 47)]=c(1.0, 1.0, 1.0, -1.0)
   Afl[25, c(30, 31)]=c(1.0, -1.0)
   Afl[26, c(1, 49)]=c(1.0, -1.0)
   Afl[27, c(48, 49, 52, 54)]=c(-1.0, 1.0, 1.0, 1.0)
   Afl[28, c(32, 33, 34)]=c(1.0, -1.0, -1.0)
   Afl[29, c(53, 54)]=c(-2.0, -1.0)
   Afl[30, c(23, 24)]=c(1.0, -1.0)
   Afl[31, c(23, 25)]=c(1.0, -1.0)
   Afl[32, c(33)]=c(1.0)
   Afl[33, c(4, 33)]=c(-1.0, -1.0)
   Afl[34, c(27)]=c(1.0)
   Afl[35, c(19, 20)]=c(1.0, 1.0)
   Afl[36, c(8, 17)]=c(1.0, -1.0)
   Afl[37, c(39, 50)]=c(-1.0, 1.0)
   Afl[38, c(16)]=c(1.0)
   Afl[39, c(15)]=c(1.0)
   Afl[40, c(34)]=c(1.0)
   Afl[41, c(26, 29)]=c(-1.0, -1.0)
   Afl[42, c(2, 40, 41)]=c(1.0, -1.0, -1.0)
   Afl[43, c(9)]=c(1.0)
   Afl[44, c(38)]=c(-1.0)
   Afl[45, c(3, 38, 50, 52, 53, 54)]=c(2.0, 1.0, -1.0, -1.0, 1.0, 1.0)
   Afl[46, c(52, 53)]=c(-1.0, 1.0)
   Afl[47, c(8, 52, 54)]=c(-1.0, 1.0, -1.0)
   Afl[48, c(3, 48)]=c(-1.0, 1.0)
   Afl[49, c(21, 22)]=c(1.0, 1.0)
   Afl[50, c(40, 41)]=c(1.0, -1.0)
   Afl[51, c(1)]=c(1.0)
   Afl[52, c(11, 12)]=c(1.0, -1.0)
   Afl[53, c(19, 20)]=c(1.0, -1.0)
   Afl[54, c(21, 22)]=c(1.0, -1.0)
   Afl[55, c(55)]=c(-1.0)
} else {
   Afl=matrix(0., nb_fl, nb_fl)
}
dimnames(Afl)=list(c("Thr", "BM_Pyr", "Ile", "CO2", "BM_Rib5P", "FTHF", "His", "AcCoA", "OAA", "ICit", "Arg", "BM_OAA", "Lys", "Glu", "Ser", "Gly", "BM_PEP", "DAHP", "Chor", "PEP", "AKG", "BM_AKG", "Mal", "Pyr", "Ala", "Glc6P", "Fru6P", "AKV", "Rib5P", "Trp", "PyrCO2", "Leu", "BM_AcCoA", "Cys", "Phe", "BM_Ery4P", "PGA", "Asn", "Met", "Val", "BM_PGA", "Suc", "Asp", "Gnt6P", "GA3P", "Sed7P", "Ery4P", "FruBP", "Tyr", "eq net: fum_a-fum_b=0: 588", "eq net: Glucupt_1+Glucupt_U=1: 589", "eq net: bs_oaa3a-bs_oaa3b=0: 590", "eq net: bs_pep3a-bs_pep3b=0: 591", "eq net: bs_pep4a-bs_pep4b=0: 592", "eq xch: fum_a-fum_b=0: 597"), nm_fl)
#browser()
# prepare param (\Theta) vector
# order: free flux net, free flux xch, scale label, scale mass, scale peak
param=numeric(0)
nm_par=c()
# free net fluxes
nb_ffn=5
nm_ffn=c("f.n.Glucupt_1", "f.n.gnd", "f.n.out_Ac", "f.n.pyk", "f.n.zwf")
# starting values for iterations
param=c(param, c(0.7, 0.15062, 0.213, 1.4, 0.2))
if (nb_ffn) {
   nm_par=c(nm_par, nm_ffn)
}
# free xch fluxes
nb_ffx=7
nm_ffx=c("f.x.ald", "f.x.eno", "f.x.fum_a", "f.x.ppc", "f.x.ta", "f.x.tk1", "f.x.tk2")
# starting values for iterations
param=c(param, c(0.413926, 0.800962, 0.395958, 0.256772, 0.359468, 0.166316, 0.00211559))
if (nb_ffx) {
   nm_par=c(nm_par, nm_ffx)
}
names(param)=nm_par
ff=param
nm_ff=c(nm_ffn, nm_ffx)
nm_list$ff=nm_ff
nb_param=length(param)
# scaling factors are added to param later

nb_ff=nb_ffn+nb_ffx

# constrained fluxes
# net
nb_fcn=27
nm_fcn=c("c.n.bs_DHAP", "c.n.bs_accoa", "c.n.bs_akg", "c.n.bs_akg2", "c.n.bs_akg3", "c.n.bs_fru6P", "c.n.bs_glc6P", "c.n.bs_oaa", "c.n.bs_oaa1_aux", "c.n.bs_oaa2_aux", "c.n.bs_oaa3_aux", "c.n.bs_oaa5_aux", "c.n.bs_oaa6_aux", "c.n.bs_oaa7_aux", "c.n.bs_pep", "c.n.bs_pep3_aux", "c.n.bs_pep4_aux", "c.n.bs_pep5", "c.n.bs_pga", "c.n.bs_pga1_aux", "c.n.bs_pga2_aux", "c.n.bs_pga3_aux", "c.n.bs_pyr", "c.n.bs_pyr3_aux", "c.n.bs_pyr4_aux", "c.n.bs_rib5p", "c.n.bs_rib5p1_aux")
fcn=c(0.0068, 0.1565, 0.0571, 0.0111, 0.0132, 0.0038, 0.0109, 0.0947, 0.0121, 0.0146, 0.0173, 0.0128, 0.0077, 0.0121, 0.0381, 0.0093, 0.0069, 0.0027, 0.0791, 0.0109, 0.0046, 0.0308, 0.1501, 0.0227, 0.0213, 0.0476, 0.0048)
# xch
nb_fcx=78
nm_fcx=c("c.x.Glucupt_1", "c.x.Glucupt_U", "c.x.akgdh", "c.x.bs_DHAP", "c.x.bs_accoa", "c.x.bs_accoa_aux", "c.x.bs_akg", "c.x.bs_akg1", "c.x.bs_akg2", "c.x.bs_akg3", "c.x.bs_akg4", "c.x.bs_akg4_aux", "c.x.bs_e4p", "c.x.bs_fru6P", "c.x.bs_glc6P", "c.x.bs_oaa", "c.x.bs_oaa1", "c.x.bs_oaa1_aux", "c.x.bs_oaa2", "c.x.bs_oaa2_aux", "c.x.bs_oaa3_aux", "c.x.bs_oaa3a", "c.x.bs_oaa3b", "c.x.bs_oaa4", "c.x.bs_oaa5", "c.x.bs_oaa5_aux", "c.x.bs_oaa6", "c.x.bs_oaa6_aux", "c.x.bs_oaa7", "c.x.bs_oaa7_aux", "c.x.bs_pep", "c.x.bs_pep1", "c.x.bs_pep2", "c.x.bs_pep3_aux", "c.x.bs_pep3a", "c.x.bs_pep3b", "c.x.bs_pep4_aux", "c.x.bs_pep4a", "c.x.bs_pep4b", "c.x.bs_pep5", "c.x.bs_pep6", "c.x.bs_pep6_aux", "c.x.bs_pep7", "c.x.bs_pga", "c.x.bs_pga1", "c.x.bs_pga1_aux", "c.x.bs_pga2", "c.x.bs_pga2_aux", "c.x.bs_pga3", "c.x.bs_pga3_aux", "c.x.bs_pga_aux", "c.x.bs_pyr", "c.x.bs_pyr1", "c.x.bs_pyr1_aux", "c.x.bs_pyr2", "c.x.bs_pyr3", "c.x.bs_pyr3_aux", "c.x.bs_pyr4", "c.x.bs_pyr4_aux", "c.x.bs_rib5p", "c.x.bs_rib5p1", "c.x.bs_rib5p1_aux", "c.x.bs_rib5p2", "c.x.citsynth", "c.x.edd", "c.x.gnd", "c.x.idh", "c.x.mae", "c.x.maldh", "c.x.out_Ac", "c.x.out_FTHF", "c.x.out_co2", "c.x.pdh", "c.x.pfk", "c.x.pgi", "c.x.pgk", "c.x.pyk", "c.x.zwf")
fcx=c(0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.011799, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.647115, 0.0, 0.0, 0.0, 0.0322745, 0.0, 0.752386, 0.984718, 0.0109591, 0.0)
fc=c(fcn, fcx)
nm_fc=c(nm_fcn, nm_fcx)
names(fc)=nm_fc
nb_fc=nb_fcn+nb_fcx

# variable growth fluxes (constant are already accounted in constrained fluxes)
nb_fgr=0
nm_fgr=c()
fgr=c()
nm_list$fgr=nm_fgr
nb_f$nb_fgr=nb_fgr

# total flux vector fallnx dimension
nb_fallnx=nb_fl+nb_ff+nb_fc+nb_fgr+nb_fgr
nb_fwrv=nb_fallnx

# net dependent and free fluxes
nm_dfn=c(nm_fln, nm_ffn)
names(nm_dfn)=substring(nm_dfn, 5)

# all flux cardinals
nb_f=append(nb_f, list(nb_fln=nb_fln, nb_flx=nb_flx, nb_fl=nb_fl,
   nb_ffn=nb_ffn, nb_ffx=nb_ffx, nb_ff=nb_ff,
   nb_fcn=nb_fcn, nb_fcx=nb_fcx, nb_fc=nb_fc,
   nb_fallnx=nb_fallnx, nb_fwrv=nb_fwrv,
   nb_fgr=nb_fgr,
   include_growth_flux=FALSE,
   mu=NULL))

# prepare p2bfl, c2bfl, g2bfl, cnst2bfl matrices such that p2bfl%*%param[1:nb_ff]+
# c2bfl%*%fc+g2bfl%*%fgr+cnst2bfl=bfl
# replace f.[nx].flx by corresponding param coefficient
p2bfl=simple_triplet_zero_matrix(nrow=nb_flr, ncol=nb_ff)
# replace c.[nx].flx by corresponding fc coefficient
c2bfl=simple_triplet_zero_matrix(nrow=nb_flr, ncol=nb_fc)
# variable growth fluxes
g2bfl=simple_triplet_zero_matrix(nrow=nb_flr, ncol=nb_fgr)
cnst2bfl=numeric(nb_flr); # may be coming from equalities
colnames(p2bfl)=nm_par
colnames(c2bfl)=nm_fc
colnames(g2bfl)=nm_fgr

c2bfl[1, pmatch(c("c.n.bs_oaa5_aux"), nm_fc)]=c(1.0);

c2bfl[2, pmatch(c("c.n.bs_pyr"), nm_fc)]=c(-1.0);

c2bfl[3, pmatch(c("c.n.bs_oaa2_aux"), nm_fc)]=c(1.0);

p2bfl[4, pmatch(c("f.n.gnd"), nm_par)]=c(-1.0);

c2bfl[5, pmatch(c("c.n.bs_rib5p"), nm_fc)]=c(-1.0);

c2bfl[7, pmatch(c("c.n.bs_rib5p1_aux"), nm_fc)]=c(1.0);

p2bfl[8, pmatch(c("f.n.out_Ac"), nm_par)]=c(1.0);
c2bfl[8, pmatch(c("c.n.bs_accoa"), nm_fc)]=c(1.0);

c2bfl[9, pmatch(c("c.n.bs_oaa"), nm_fc)]=c(1.0);

c2bfl[12, pmatch(c("c.n.bs_oaa"), nm_fc)]=c(-1.0);

c2bfl[13, pmatch(c("c.n.bs_oaa3_aux"), nm_fc)]=c(1.0);

c2bfl[14, pmatch(c("c.n.bs_akg3", "c.n.bs_akg2"), nm_fc)]=c(1.0, 1.0);

c2bfl[15, pmatch(c("c.n.bs_pga1_aux"), nm_fc)]=c(1.0);

c2bfl[16, pmatch(c("c.n.bs_pga3_aux"), nm_fc)]=c(1.0);

c2bfl[17, pmatch(c("c.n.bs_pep5", "c.n.bs_pep"), nm_fc)]=c(1.0, -1.0);

p2bfl[20, pmatch(c("f.n.pyk"), nm_par)]=c(1.0);
c2bfl[20, pmatch(c("c.n.bs_pep"), nm_fc)]=c(1.0);

c2bfl[21, pmatch(c("c.n.bs_akg"), nm_fc)]=c(1.0);

c2bfl[22, pmatch(c("c.n.bs_akg"), nm_fc)]=c(-1.0);

p2bfl[24, pmatch(c("f.n.pyk"), nm_par)]=c(-1.0);
c2bfl[24, pmatch(c("c.n.bs_pyr"), nm_fc)]=c(1.0);

p2bfl[26, pmatch(c("f.n.zwf", "f.n.Glucupt_1"), nm_par)]=c(1.0, -1.0);
c2bfl[26, pmatch(c("c.n.bs_glc6P"), nm_fc)]=c(1.0);

c2bfl[27, pmatch(c("c.n.bs_fru6P"), nm_fc)]=c(1.0);

p2bfl[29, pmatch(c("f.n.gnd"), nm_par)]=c(-1.0);
c2bfl[29, pmatch(c("c.n.bs_rib5p"), nm_fc)]=c(1.0);

c2bfl[32, pmatch(c("c.n.bs_pyr3_aux"), nm_fc)]=c(1.0);

c2bfl[33, pmatch(c("c.n.bs_accoa"), nm_fc)]=c(-1.0);

c2bfl[34, pmatch(c("c.n.bs_pga2_aux"), nm_fc)]=c(1.0);

c2bfl[35, pmatch(c("c.n.bs_pep3_aux"), nm_fc)]=c(1.0);

c2bfl[37, pmatch(c("c.n.bs_pga"), nm_fc)]=c(1.0);

c2bfl[38, pmatch(c("c.n.bs_oaa7_aux"), nm_fc)]=c(1.0);

c2bfl[39, pmatch(c("c.n.bs_oaa6_aux"), nm_fc)]=c(1.0);

c2bfl[40, pmatch(c("c.n.bs_pyr4_aux"), nm_fc)]=c(1.0);

c2bfl[41, pmatch(c("c.n.bs_pga"), nm_fc)]=c(-1.0);

c2bfl[43, pmatch(c("c.n.bs_oaa1_aux"), nm_fc)]=c(1.0);

p2bfl[44, pmatch(c("f.n.gnd", "f.n.zwf"), nm_par)]=c(1.0, -1.0);

c2bfl[45, pmatch(c("c.n.bs_DHAP"), nm_fc)]=c(1.0);

c2bfl[49, pmatch(c("c.n.bs_pep4_aux"), nm_fc)]=c(1.0);


p2bfl[51, pmatch(c("f.n.Glucupt_1"), nm_par)]=c(-1.0);
cnst2bfl[51]=1;




p2bfl[55, pmatch(c("f.x.fum_a"), nm_par)]=c(-1.0);

bp=as.numeric(c2bfl%stm%fc+cnst2bfl)

if (ffguess) {
   # make an automatic guess for free/dependent flux partition
   afd=as.matrix(cBind(Afl, -p2bfl))
   qafd=qr(afd, LAPACK=T)
   d=abs(diag(qafd$qr))
   rank=sum(d > d[1]*1.e-10)
   qrow=qr(t(afd))
   rankr=qrow$rank
   if (rank != rankr) {
      mes="Weird error: column and row ranks are not equal.\n"
      stop_mes(mes, file=fcerr)
   }
   irows=qrow$pivot[seq_len(rankr)]
   if (rank==0) {
      stop_mes("Error: No free/dependent flux partition could be made. Stoechiometric matrix has rank=0.\n", file=fcerr)
   }
   Afl=afd[irows, qafd$pivot[1L:rank], drop=FALSE]
   ka=kappa(Afl)
   if (ka > 1.e7) {
      mes=sprintf("Error: No working free/dependent flux partition could be proposed. Stoechiometric matrix has condition number %g.\n", ka)
      stop_mes(mes, file=fcerr)
   }
   p2bfl=-as.simple_triplet_matrix(afd[irows, qafd$pivot[-seq_len(rank)], drop=FALSE])
   c2bfl=c2bfl[irows, , drop=FALSE]
   g2bfl=g2bfl[irows, , drop=FALSE]
   cnst2bfl=cnst2bfl[irows]
   bp=bp[irows]
   
   # replace names
   nm_fl=sub("f.", "d.", colnames(Afl), fixed=T)
   colnames(Afl)=nm_fl # both net and xch
   nm_fln=sort(grep("^d.n.", nm_fl, v=T))
   nm_flx=sort(grep("^d.x.", nm_fl, v=T))
   nm_fl=c(nm_fln, nm_flx)
   Afl=Afl[, nm_fl, drop=FALSE]
   
   nm_ff=sub("d.", "f.", colnames(p2bfl), fixed=T) # both net and xch
   colnames(p2bfl)=nm_ff
   nm_ffn=sort(grep("^f.n.", nm_ff, v=T))
   nm_ffx=sort(grep("^f.x.", nm_ff, v=T))
   nm_ff=c(nm_ffn, nm_ffx)
   p2bfl=p2bfl[, nm_ff, drop=FALSE]
   
   # remake param vector
   if (!fdfit)
      param=c(runif(length(nm_ff)), if (nb_ff == 0) param else param[-seq_len(nb_ff)])
   names(param)[seq(along=nm_ff)]=nm_ff
#browser()
}
nm_list$flnx=nm_fl
nm_fallnx=c(nm_fln, nm_ffn, nm_fcn, nm_fgr, nm_flx, nm_ffx, nm_fcx, sub(".n.", ".x.", nm_fgr, fixed=T))
nm_list$fallnx=nm_fallnx
nm_net=c(nm_fln, nm_ffn, nm_fcn)
names(nm_net)=substring(nm_net, 5)
nm_xch=c(nm_flx, nm_ffx, nm_fcx)
names(nm_xch)=substring(nm_xch, 5)
edge2fl[]=nm_net[substring(edge2fl, 5)]
nm_list$ff=nm_ff

# accounting numbers
nb_flr=nrow(Afl)
nb_param=length(param)
nb_ffn=length(nm_ffn)
nb_ffx=length(nm_ffx)
nb_ff=nb_ffn+nb_ffx
nb_fln=length(nm_fln)
nb_flx=length(nm_flx)
nb_fl=nb_fln+nb_flx
nm_par=names(param)

for (item in c("nb_fln", "nb_flx", "nb_fl", "nb_ffn", "nb_ffx", "nb_ff")) {
   nb_f[item]=get(item)
}
# translation from n-x to fw-rv
sh_fwrv=substring(nm_fwrv[1:(nb_fwrv/2)], 5)
sh_nx=substring(nm_fallnx, 2)
nb_f$inet2ifwrv=pmatch(paste(".n.", sh_fwrv, sep=""), sh_nx)
nb_f$ixch2ifwrv=pmatch(paste(".x.", sh_fwrv, sep=""), sh_nx)
#nb_f$inet2ifwrv=sapply(nm_fwrv[1:(nb_fwrv/2)], function(f) grep(sprintf("^.\\.n\\.%s$", substring(f, 5)), nm_fallnx))
#nb_f$ixch2ifwrv=sapply(nm_fwrv[1:(nb_fwrv/2)], function(f) grep(sprintf("^.\\.x\\.%s$", substring(f, 5)), nm_fallnx))

if (TIMEIT) {
   cat("Afl qr(): ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}

qrAfl=qr(Afl, LAPACK=T)
d=abs(diag(qrAfl$qr))
qrAfl$rank=sum(d > d[1]*1.e-10)
rank=qrAfl$rank
aful=as.matrix(cBind(Afl, -p2bfl, -c2bfl))
qrow=qr(t(aful))
rankr=qrow$rank
#browser()
# first check the presence of lindep rows
if (nrow(Afl) > rankr) {
   prop=sprintf("Error: Among %d equations (rows), %d are redundant and must be eliminated by hand.\n", nrow(Afl), nrow(Afl)-rankr)
   prop=paste(prop, "Candidate(s) for elimination is (are):\n",
      paste(rownames(Afl)[qrow$pivot[-(1:rankr)]], sep="", collapse="\n"),
               "\n", sep="")
   stop_mes(prop, file=fcerr)
}
if (nrow(Afl) != rank || nrow(Afl) != ncol(Afl)) {
   #write.table(Afl)
   mes=NULL
   if (nrow(Afl) <= rank) {
      mes=paste("Candidate(s) for free or constrained flux(es):\n",
         paste(colnames(Afl)[-qrAfl$pivot[1L:nrow(Afl)]], collapse="\n"),
         "\nFor this choice, condition number of stoechiometric matrix will be ",
         kappa(Afl[,qrAfl$pivot[1L:nrow(Afl)],drop=FALSE]), "\n", sep="")
   } else if (nrow(Afl) > rank) {
      nextra=nrow(Afl)-rank
      comb=combn(c(nm_ffn, colnames(Afl)[-qrAfl$pivot[1L:rank]]), nextra)
      aextra=cBind(Afl[,-qrAfl$pivot[1L:rank],drop=FALSE], -p2bfl)
      colnames(aextra)=c(colnames(Afl)[-qrAfl$pivot[1L:rank]], colnames(p2bfl))
      ara=Afl[,qrAfl$pivot[1L:rank],drop=FALSE]
      i=which.min(apply(comb, 2, function(i) kappa(cBind(ara, aextra[,i]))))[1L]
      nm_tmp=comb[,i]
      ka=kappa(cBind(ara, aextra[,nm_tmp]))
      if (ka < 1.e7) {
         prop=paste("Proposal to declare dependent flux(es) is:\n",
            paste(nm_tmp, collapse="\n"), "\n", sep="")
         if (rank < ncol(Afl)) {
            prop=prop%s+%"While the following dependent flux(es) should be declared free or constrained:\n"%s+%join("\n", colnames(Afl)[-qrAfl$pivot[1L:rank]])%s+%"\n"
         }
         prop=paste(prop, "For this choice, condition number of stoechiometric matrix will be ", ka, "\n", sep="")
      } else {
         # add constraint fluxes to candidate list
         if (nb_fcn > 0) {
            aextra=as.matrix(cBind(Afl[,-qrAfl$pivot[1L:rank],drop=FALSE], -p2bfl, -c2bfl))
            colnames(aextra)=c(colnames(Afl)[-qrAfl$pivot[1L:rank]], colnames(p2bfl), colnames(c2bfl))
         }
         aextended=aful
         qae=qr(aextended, LAPACK=T)
         d=abs(diag(qae$qr))
         ranke=sum(d > d[1L]*1.e-10)
         if (ranke == nrow(Afl)) {
            prop=paste("Proposal to declare dependent flux(es) is:\n",
            join("\n", colnames(aextended)[qae$pivot[1L:ranke]]), "\n",
            "while free and constrained fluxes should be:\n",
            join("\n", colnames(aextended)[-qae$pivot[1L:ranke]]), "\n",
            sep="")
            ka=kappa(aextended[,qae$pivot[1L:ranke]])
            prop=paste(prop, "For this choice, condition number of stoechiometric matrix will be ", ka, "\n", sep="")
         } else {
            prop="No proposal for partition dependent/free fluxes could be made.\n"
         }
      }
      mes=paste("There is (are) probably ", nextra,
         " extra free flux(es) among the following:\n",
         paste(nm_ffn, collapse="\n"), "\n",
         prop,
         sep="")
   }
   stop_mes(paste("Flux matrix is not square or is singular: (", nrow(Afl), "eq x ", ncol(Afl), "unk)\n",
      "You have to change your choice of free fluxes in the 'e_coli.ftbl' file.\n",
      mes, sep=""), file=fcerr)
}

# make sure that free params choice leads to not singular matrix
if (qrAfl$rank != nb_fl) {
   #write.table(Afl)
   # make a suggestion of new free fluxes
   A=cBind(Afl, -p2bfl, -c2bfl)
   colnames(A)=c(colnames(Afl), nm_ff, nm_fc)
   qa=qr(A, LAPACK=T)
   d=diag(qa$qr)
   qa$rank=sum(abs(d)>=abs(d[1]*1.e-10))
   
   mes=paste("Error: Dependent flux matrix is singular.\n",
      "Change your partition on free/dependent/constrained fluxes in the 'e_coli.ftbl' file.\n",
      "Can not resolve dependent fluxe(s):\n",
      paste(colnames(Afl)[-qrAfl$pivot[(1:qrAfl$rank)]], collapse="\n"),
      sep="")
   if (qa$rank==nb_fl) {
      mes=paste(mes,
      "\n\nSuggested dependent fluxes:\n",
      paste(colnames(A)[qa$pivot[(1:qa$rank)]], collapse="\n"),
      "\n\nWhich would give the following free and constrained fluxes:\n",
      paste(colnames(A)[-qa$pivot[(1:qa$rank)]], collapse="\n"), "\n",
      sep="")
   } else {
      mes=paste(mes, "\nNo suggested free fluxes could be found", sep="")
   }
   stop_mes(mes, file=fcerr)
}

# inverse flux matrix
invAfl=solve(qrAfl)

if (fdfit) {
#browser()
   # choose free fluxe values such that they fit starting values from ftbl
   #dep=invAfl%*%(p2bfl%*%ff+bp)
   #ff=ff
   ff=qr.solve(rbind(invAfl%stm%p2bfl, diag(ncol(p2bfl))), c(fl-invAfl%*%bp, param))
}
# intermediate jacobian
if (TIMEIT) {
   cat("dfl_dffg: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}

dfl_dffg=invAfl%stm%p2bfl
if (nb_fgr > 0L) {
   dfl_dffg=cBind(dfl_dffg, invAfl%stm%g2bfl)
}
dimnames(dfl_dffg)=list(nm_fl, c(nm_ff, nm_fgr))
dfl_dffg[abs(dfl_dffg) < 1.e-14]=0.
nb_f$dfl_dffg=as.simple_triplet_matrix(dfl_dffg)

# prepare mf, md, mc and mg matrices
# such that mf%*%ff+md%*%fl+mc%*%fc+mg%*%fgr gives fallnx
# here ff free fluxes (param), fl are dependent fluxes, fc are constrained
# fluxes and fgr are variable growth fluxes
mf=matrix(0., nb_fallnx, nb_ff)
dimnames(mf)=list(nm_fallnx, nm_ff)
md=matrix(0., nb_fallnx, nb_fl)
dimnames(md)=list(nm_fallnx, nm_fl)
mc=matrix(0., nb_fallnx, nb_fc)
dimnames(mc)=list(nm_fallnx, nm_fc)
mg=matrix(0., nb_fallnx, nb_fgr)
dimnames(mg)=list(nm_fallnx, nm_fgr)

if (nb_ff > 0) {
   mf[nm_ff, nm_ff]=diag(1., nb_ff)
}
if (nb_fl > 0) {
   md[nm_fl, nm_fl]=diag(1., nb_fl)
}
if (nb_fc > 0) {
   mc[nm_fc, nm_fc]=diag(1., nb_fc)
}
if (nb_fgr > 0) {
   mg[nm_fgr, nm_fgr]=diag(1., nb_fgr)
}

# sparse matrix static parts
# $varname fields:
#  ind_fa - flux index in a_pre$vfwrv[ind_fa]
#  a_pre - sparse matrix whose colsum() gives the a$v vector
#  prodx - dense matrix whose colprod() will give x[ind_x1]*x[ind_x2]*...
#  ind_fb - flux index in b_pre$v=fwrv[ind_fb1]*colprod(prodx)
#  ind_b - dense matrix of indexes for  b_pre$v=f[ind_b[,"indf"]*x[ind_b[,2+1]]*x[ind_b[,2+2]], ...]
#  b_pre - sparse matrix whose colsum gives b@x

#  a - unsigned sparse cumomer A matrix (off-diagonal part)
#  b - unsigned sparse vector of right hand side

if (TIMEIT) {
   cat("spAbr   : ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}

nb_fwrv=172
nb_w=6
spAbr=list()

if (TIMEIT) {
   cat("weight 1: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}
w=1
nb_c=231
ba_x=127; # base of cumomer indexes in incu vector
l=new.env()
l$w=w
l$nb_c=nb_c
l$nb_fwrv=nb_fwrv
l$nb_cl=0 # number of lighter cumomers
maxprod=1
if (nb_c > 0) {
   # matrix a
   ind_a=matrix(as.integer(c(79, 0, 0, 83, 0, 0, 85, 0, 0, 164, 0, 0, 79, 0, 14, 83, 0, 49, 85, 0, 66, 164, 0, 21, 65, 1, 1, 157, 1, 1, 65, 1, 62, 157, 1, 71, 70, 2, 2, 147, 2, 2, 171, 2, 2, 170, 2, 2, 170, 2, 2, 70, 2, 6, 147, 2, 101, 171, 2, 50, 170, 2, 50, 170, 2, 102, 79, 3, 3, 83, 3, 3, 85, 3, 3, 164, 3, 3, 79, 3, 7, 83, 3, 51, 85, 3, 61, 164, 3, 33, 79, 4, 4, 83, 4, 4, 85, 4, 4, 164, 4, 4, 79, 4, 23, 83, 4, 50, 85, 4, 64, 164, 4, 10, 78, 5, 5, 90, 5, 5, 78, 5, 32, 90, 5, 51, 86, 6, 6, 156, 6, 6, 152, 6, 6, 86, 6, 23, 156, 6, 2, 152, 6, 50, 165, 7, 7, 172, 7, 7, 2, 7, 7, 1, 7, 7, 165, 7, 3, 172, 7, 30, 79, 8, 8, 83, 8, 8, 85, 8, 8, 164, 8, 8, 79, 8, 34, 83, 8, 54, 85, 8, 15, 164, 8, 38, 86, 9, 9, 156, 9, 9, 152, 9, 9, 86, 9, 18, 156, 9, 22, 152, 9, 52, 78, 10, 10, 90, 10, 10, 78, 10, 4, 90, 10, 50, 67, 11, 11, 167, 11, 11, 118, 11, 11, 168, 11, 11, 67, 11, 29, 167, 11, 60, 118, 11, 103, 168, 11, 55, 165, 12, 12, 172, 12, 12, 2, 12, 12, 1, 12, 12, 165, 12, 27, 172, 12, 35, 65, 13, 13, 157, 13, 13, 65, 13, 46, 157, 13, 70, 165, 14, 14, 172, 14, 14, 2, 14, 14, 1, 14, 14, 165, 14, 0, 172, 14, 42, 70, 15, 15, 147, 15, 15, 171, 15, 15, 170, 15, 15, 170, 15, 15, 70, 15, 35, 147, 15, 104, 171, 15, 8, 170, 15, 54, 170, 15, 56, 3, 16, 16, 155, 16, 16, 154, 16, 16, 3, 16, 70, 155, 16, 105, 154, 16, 106, 65, 17, 17, 157, 17, 17, 65, 17, 60, 157, 17, 45, 165, 18, 18, 172, 18, 18, 2, 18, 18, 1, 18, 18, 165, 18, 32, 172, 18, 9, 67, 19, 19, 167, 19, 19, 118, 19, 19, 168, 19, 19, 67, 19, 26, 167, 19, 65, 118, 19, 88, 168, 19, 53, 86, 20, 20, 156, 20, 20, 152, 20, 20, 86, 20, 34, 156, 20, 45, 152, 20, 55, 78, 21, 21, 90, 21, 21, 78, 21, 0, 90, 21, 49, 70, 22, 22, 147, 22, 22, 171, 22, 22, 170, 22, 22, 170, 22, 22, 70, 22, 9, 147, 22, 107, 171, 22, 27, 170, 22, 48, 170, 22, 108, 165, 23, 23, 172, 23, 23, 2, 23, 23, 1, 23, 23, 165, 23, 4, 172, 23, 6, 70, 24, 24, 147, 24, 24, 171, 24, 24, 170, 24, 24, 170, 24, 24, 70, 24, 42, 147, 24, 109, 171, 24, 49, 170, 24, 49, 170, 24, 110, 65, 25, 25, 157, 25, 25, 65, 25, 59, 157, 25, 72, 80, 26, 26, 131, 26, 26, 153, 26, 26, 80, 26, 50, 131, 26, 111, 153, 26, 19, 79, 27, 27, 83, 27, 27, 85, 27, 27, 164, 27, 27, 79, 27, 12, 83, 27, 48, 85, 27, 22, 164, 27, 44, 3, 28, 28, 155, 28, 28, 154, 28, 28, 3, 28, 73, 155, 28, 112, 154, 28, 113, 80, 29, 29, 131, 29, 29, 153, 29, 29, 80, 29, 51, 131, 29, 114, 153, 29, 11, 86, 30, 30, 156, 30, 30, 152, 30, 30, 86, 30, 7, 156, 30, 31, 152, 30, 51, 70, 31, 31, 147, 31, 31, 171, 31, 31, 170, 31, 31, 170, 31, 31, 70, 31, 30, 147, 31, 115, 171, 31, 51, 170, 31, 51, 170, 31, 116, 79, 32, 32, 83, 32, 32, 85, 32, 32, 164, 32, 32, 79, 32, 18, 83, 32, 56, 85, 32, 63, 164, 32, 5, 78, 33, 33, 90, 33, 33, 78, 33, 3, 90, 33, 51, 165, 34, 34, 172, 34, 34, 2, 34, 34, 1, 34, 34, 165, 34, 8, 172, 34, 20, 86, 35, 35, 156, 35, 35, 152, 35, 35, 86, 35, 12, 156, 35, 15, 152, 35, 53, 3, 36, 36, 155, 36, 36, 154, 36, 36, 3, 36, 69, 155, 36, 113, 154, 36, 112, 65, 37, 37, 157, 37, 37, 65, 37, 47, 157, 37, 73, 78, 38, 38, 90, 38, 38, 78, 38, 8, 90, 38, 49, 65, 39, 39, 157, 39, 39, 65, 39, 65, 157, 39, 69, 3, 40, 40, 155, 40, 40, 154, 40, 40, 3, 40, 72, 155, 40, 106, 154, 40, 105, 80, 41, 41, 131, 41, 41, 153, 41, 41, 80, 41, 49, 131, 41, 117, 153, 41, 43, 86, 42, 42, 156, 42, 42, 152, 42, 42, 86, 42, 14, 156, 42, 24, 152, 42, 49, 67, 43, 43, 167, 43, 43, 118, 43, 43, 168, 43, 43, 67, 43, 41, 167, 43, 59, 118, 43, 58, 168, 43, 52, 78, 44, 44, 90, 44, 44, 78, 44, 27, 90, 44, 50, 71, 45, 45, 44, 45, 45, 36, 45, 45, 40, 45, 45, 37, 45, 45, 39, 45, 45, 3, 45, 45, 77, 45, 45, 72, 45, 45, 23, 45, 45, 20, 45, 45, 56, 45, 45, 57, 45, 45, 70, 45, 45, 24, 45, 45, 98, 45, 45, 167, 45, 45, 71, 45, 17, 44, 45, 68, 36, 45, 118, 40, 45, 118, 37, 45, 118, 39, 45, 118, 3, 45, 71, 77, 45, 55, 72, 45, 106, 23, 45, 87, 20, 45, 87, 56, 45, 87, 57, 45, 119, 70, 45, 20, 24, 45, 120, 98, 45, 121, 167, 45, 62, 77, 46, 46, 92, 46, 46, 151, 46, 46, 77, 46, 53, 92, 46, 122, 151, 46, 13, 77, 47, 47, 92, 47, 47, 151, 47, 47, 77, 47, 52, 92, 47, 123, 151, 47, 37, 84, 48, 48, 169, 48, 48, 84, 48, 22, 169, 48, 27, 4, 49, 49, 4, 49, 49, 84, 49, 49, 85, 49, 49, 66, 49, 49, 169, 49, 49, 166, 49, 49, 4, 49, 38, 4, 49, 21, 84, 49, 24, 85, 49, 24, 66, 49, 42, 169, 49, 0, 166, 49, 41, 4, 50, 50, 4, 50, 50, 84, 50, 50, 85, 50, 50, 66, 50, 50, 169, 50, 50, 166, 50, 50, 4, 50, 44, 4, 50, 10, 84, 50, 2, 85, 50, 2, 66, 50, 6, 169, 50, 4, 166, 50, 26, 4, 51, 51, 4, 51, 51, 84, 51, 51, 85, 51, 51, 66, 51, 51, 169, 51, 51, 166, 51, 51, 4, 51, 5, 4, 51, 33, 84, 51, 31, 85, 51, 31, 66, 51, 30, 169, 51, 3, 166, 51, 29, 44, 52, 52, 82, 52, 52, 72, 52, 52, 66, 52, 52, 139, 52, 52, 163, 52, 52, 44, 52, 124, 82, 52, 43, 72, 52, 113, 66, 52, 9, 139, 52, 75, 163, 52, 47, 44, 53, 53, 82, 53, 53, 72, 53, 53, 66, 53, 53, 139, 53, 53, 163, 53, 53, 44, 53, 125, 82, 53, 19, 72, 53, 112, 66, 53, 35, 139, 53, 74, 163, 53, 46, 84, 54, 54, 169, 54, 54, 84, 54, 15, 169, 54, 8, 44, 55, 55, 82, 55, 55, 72, 55, 55, 66, 55, 55, 139, 55, 55, 163, 55, 55, 44, 55, 126, 82, 55, 11, 72, 55, 105, 66, 55, 20, 139, 55, 87, 163, 55, 45, 84, 56, 56, 169, 56, 56, 84, 56, 15, 169, 56, 32, 17, 57, 57, 109, 57, 57, 110, 57, 57, 112, 57, 57, 116, 57, 57, 114, 57, 57, 104, 57, 57, 17, 57, 62, 109, 57, 82, 110, 57, 82, 112, 57, 127, 116, 57, 128, 114, 57, 129, 104, 57, 130, 32, 58, 58, 120, 58, 58, 119, 58, 58, 32, 58, 43, 120, 58, 131, 119, 58, 132, 81, 59, 59, 73, 59, 59, 103, 59, 59, 151, 59, 59, 81, 59, 43, 73, 59, 113, 103, 59, 133, 151, 59, 25, 81, 60, 60, 73, 60, 60, 103, 60, 60, 151, 60, 60, 81, 60, 11, 73, 60, 105, 103, 60, 120, 151, 60, 17, 83, 61, 61, 171, 61, 61, 100, 61, 61, 83, 61, 116, 171, 61, 3, 100, 61, 99, 81, 62, 62, 73, 62, 62, 103, 62, 62, 151, 62, 62, 81, 62, 45, 73, 62, 106, 103, 62, 57, 151, 62, 1, 83, 63, 63, 171, 63, 63, 100, 63, 63, 83, 63, 108, 171, 63, 32, 100, 63, 100, 83, 64, 64, 171, 64, 64, 100, 64, 64, 83, 64, 102, 171, 64, 4, 100, 64, 98, 81, 65, 65, 73, 65, 65, 103, 65, 65, 151, 65, 65, 81, 65, 19, 73, 65, 112, 103, 65, 134, 151, 65, 39, 83, 66, 66, 171, 66, 66, 100, 66, 66, 83, 66, 110, 171, 66, 0, 100, 66, 89, 50, 67, 67, 114, 67, 67, 148, 67, 67, 50, 67, 135, 114, 67, 136, 148, 67, 137, 42, 68, 68, 130, 68, 68, 42, 68, 118, 130, 68, 45, 71, 69, 69, 94, 69, 69, 89, 69, 69, 71, 69, 39, 94, 69, 138, 89, 69, 36, 71, 70, 70, 94, 70, 70, 89, 70, 70, 71, 70, 13, 94, 70, 139, 89, 70, 16, 71, 71, 71, 94, 71, 71, 89, 71, 71, 71, 71, 1, 94, 71, 140, 89, 71, 45, 71, 72, 72, 94, 72, 72, 89, 72, 72, 71, 72, 25, 94, 72, 141, 89, 72, 40, 71, 73, 73, 94, 73, 73, 89, 73, 73, 71, 73, 37, 94, 73, 142, 89, 73, 28, 53, 74, 74, 142, 74, 74, 142, 74, 74, 140, 74, 74, 109, 74, 74, 106, 74, 74, 110, 74, 74, 53, 74, 53, 142, 74, 143, 142, 74, 76, 140, 74, 144, 109, 74, 77, 106, 74, 78, 110, 74, 145, 53, 75, 75, 142, 75, 75, 142, 75, 75, 140, 75, 75, 109, 75, 75, 106, 75, 75, 110, 75, 75, 53, 75, 52, 142, 75, 146, 142, 75, 79, 140, 75, 147, 109, 75, 80, 106, 75, 81, 110, 75, 148, 56, 76, 76, 143, 76, 76, 145, 76, 76, 56, 76, 74, 143, 76, 149, 145, 76, 150, 23, 77, 77, 24, 77, 77, 23, 77, 74, 24, 77, 134, 20, 78, 78, 20, 78, 74, 56, 79, 79, 143, 79, 79, 145, 79, 79, 56, 79, 75, 143, 79, 151, 145, 79, 152, 23, 80, 80, 24, 80, 80, 23, 80, 75, 24, 80, 133, 20, 81, 81, 20, 81, 75, 23, 82, 82, 24, 82, 82, 23, 82, 57, 24, 82, 57, 57, 83, 83, 57, 83, 143, 57, 84, 84, 57, 84, 146, 50, 85, 85, 50, 85, 153, 50, 86, 86, 50, 86, 154, 53, 87, 87, 142, 87, 87, 142, 87, 87, 109, 87, 87, 106, 87, 87, 140, 87, 87, 110, 87, 87, 53, 87, 55, 142, 87, 119, 142, 87, 45, 109, 87, 45, 106, 87, 45, 140, 87, 155, 110, 87, 156, 32, 88, 88, 120, 88, 88, 119, 88, 88, 32, 88, 19, 120, 88, 157, 119, 88, 158, 14, 89, 89, 119, 89, 89, 14, 89, 66, 119, 89, 159, 42, 90, 90, 42, 90, 160, 36, 91, 91, 37, 91, 91, 36, 91, 160, 37, 91, 161, 36, 92, 92, 37, 92, 92, 36, 92, 161, 37, 92, 160, 40, 93, 93, 39, 93, 93, 40, 93, 161, 39, 93, 160, 40, 94, 94, 39, 94, 94, 40, 94, 160, 39, 94, 161, 42, 95, 95, 42, 95, 162, 36, 96, 96, 37, 96, 96, 36, 96, 162, 37, 96, 162, 40, 97, 97, 39, 97, 97, 40, 97, 162, 39, 97, 162, 14, 98, 98, 119, 98, 98, 14, 98, 64, 119, 98, 163, 14, 99, 99, 119, 99, 99, 14, 99, 61, 119, 99, 164, 14, 100, 100, 119, 100, 100, 14, 100, 63, 119, 100, 165, 61, 101, 101, 128, 101, 101, 148, 101, 101, 61, 101, 2, 128, 101, 166, 148, 101, 167, 84, 102, 102, 169, 102, 102, 84, 102, 2, 169, 102, 64, 32, 103, 103, 120, 103, 103, 119, 103, 103, 32, 103, 11, 120, 103, 168, 119, 103, 169, 61, 104, 104, 128, 104, 104, 148, 104, 104, 61, 104, 15, 128, 104, 170, 148, 104, 171, 69, 105, 105, 68, 105, 105, 159, 105, 105, 158, 105, 105, 69, 105, 16, 68, 105, 40, 159, 105, 60, 158, 105, 55, 69, 106, 106, 68, 106, 106, 159, 106, 106, 158, 106, 106, 69, 106, 40, 68, 106, 16, 159, 106, 62, 158, 106, 45, 61, 107, 107, 128, 107, 107, 148, 107, 107, 61, 107, 22, 128, 107, 172, 148, 107, 173, 84, 108, 108, 169, 108, 108, 84, 108, 22, 169, 108, 63, 61, 109, 109, 128, 109, 109, 148, 109, 109, 61, 109, 24, 128, 109, 174, 148, 109, 175, 84, 110, 110, 169, 110, 110, 84, 110, 24, 169, 110, 66, 45, 111, 111, 132, 111, 111, 45, 111, 26, 132, 111, 154, 69, 112, 112, 68, 112, 112, 159, 112, 112, 158, 112, 112, 69, 112, 28, 68, 112, 36, 159, 112, 65, 158, 112, 53, 69, 113, 113, 68, 113, 113, 159, 113, 113, 158, 113, 113, 69, 113, 36, 68, 113, 28, 159, 113, 59, 158, 113, 52, 45, 114, 114, 132, 114, 114, 45, 114, 29, 132, 114, 153, 61, 115, 115, 128, 115, 115, 148, 115, 115, 61, 115, 31, 128, 115, 176, 148, 115, 177, 84, 116, 116, 169, 116, 116, 84, 116, 31, 169, 116, 61, 45, 117, 117, 132, 117, 117, 45, 117, 41, 132, 117, 135, 34, 118, 118, 128, 118, 118, 122, 118, 118, 123, 118, 118, 125, 118, 118, 126, 118, 118, 34, 118, 169, 128, 118, 68, 122, 118, 45, 123, 118, 45, 125, 118, 45, 126, 118, 45, 56, 119, 119, 143, 119, 119, 145, 119, 119, 56, 119, 87, 143, 119, 45, 145, 119, 178, 17, 120, 120, 109, 120, 120, 112, 120, 120, 116, 120, 120, 114, 120, 120, 104, 120, 120, 110, 120, 120, 17, 120, 60, 109, 120, 156, 112, 120, 179, 116, 120, 180, 114, 120, 181, 104, 120, 182, 110, 120, 45, 12, 121, 121, 12, 121, 45, 6, 122, 122, 143, 122, 122, 6, 122, 46, 143, 122, 183, 6, 123, 123, 143, 123, 123, 6, 123, 47, 143, 123, 184, 42, 124, 124, 130, 124, 124, 42, 124, 131, 130, 124, 52, 42, 125, 125, 130, 125, 125, 42, 125, 157, 130, 125, 53, 42, 126, 126, 130, 126, 126, 42, 126, 168, 130, 126, 55, 26, 127, 127, 106, 127, 127, 26, 127, 57, 106, 127, 185, 30, 128, 128, 30, 128, 57, 28, 129, 129, 28, 129, 57, 18, 130, 130, 18, 130, 57, 34, 131, 131, 128, 131, 131, 122, 131, 131, 123, 131, 131, 125, 131, 131, 126, 131, 131, 34, 131, 58, 128, 131, 124, 122, 131, 186, 123, 131, 186, 125, 131, 187, 126, 131, 187, 33, 132, 132, 120, 132, 132, 33, 132, 58, 120, 132, 160, 17, 133, 133, 109, 133, 133, 112, 133, 133, 116, 133, 133, 114, 133, 133, 104, 133, 133, 110, 133, 133, 17, 133, 59, 109, 133, 148, 112, 133, 188, 116, 133, 189, 114, 133, 190, 104, 133, 191, 110, 133, 80, 17, 134, 134, 109, 134, 134, 112, 134, 134, 116, 134, 134, 114, 134, 134, 104, 134, 134, 110, 134, 134, 17, 134, 65, 109, 134, 145, 112, 134, 192, 116, 134, 193, 114, 134, 194, 104, 134, 195, 110, 134, 77, 46, 135, 135, 136, 135, 135, 134, 135, 135, 46, 135, 117, 136, 135, 67, 134, 135, 196, 28, 136, 136, 28, 136, 67, 62, 137, 137, 62, 137, 67, 8, 138, 138, 95, 138, 138, 8, 138, 69, 95, 138, 197, 8, 139, 139, 95, 139, 139, 8, 139, 70, 95, 139, 198, 8, 140, 140, 95, 140, 140, 8, 140, 71, 95, 140, 199, 8, 141, 141, 95, 141, 141, 8, 141, 72, 95, 141, 200, 8, 142, 142, 95, 142, 142, 8, 142, 73, 95, 142, 201, 56, 143, 143, 143, 143, 143, 145, 143, 143, 56, 143, 74, 143, 143, 83, 145, 143, 202, 54, 144, 144, 54, 144, 74, 23, 145, 145, 24, 145, 145, 23, 145, 134, 24, 145, 74, 56, 146, 146, 143, 146, 146, 145, 146, 146, 56, 146, 75, 143, 146, 84, 145, 146, 203, 54, 147, 147, 54, 147, 75, 23, 148, 148, 24, 148, 148, 23, 148, 133, 24, 148, 75, 57, 149, 149, 57, 149, 76, 59, 150, 150, 59, 150, 76, 57, 151, 151, 57, 151, 79, 59, 152, 152, 59, 152, 79, 46, 153, 153, 136, 153, 153, 134, 153, 153, 46, 153, 114, 136, 153, 85, 134, 153, 204, 46, 154, 154, 136, 154, 154, 134, 154, 154, 46, 154, 111, 136, 154, 86, 134, 154, 205, 54, 155, 155, 54, 155, 87, 23, 156, 156, 24, 156, 156, 23, 156, 120, 24, 156, 87, 34, 157, 157, 128, 157, 157, 122, 157, 157, 123, 157, 157, 125, 157, 157, 126, 157, 157, 34, 157, 88, 128, 157, 125, 122, 157, 206, 123, 157, 206, 125, 157, 207, 126, 157, 207, 33, 158, 158, 120, 158, 158, 33, 158, 88, 120, 158, 162, 33, 159, 159, 120, 159, 159, 33, 159, 89, 120, 159, 161, 34, 160, 160, 128, 160, 160, 122, 160, 160, 123, 160, 160, 125, 160, 160, 126, 160, 160, 34, 160, 132, 128, 160, 90, 122, 160, 91, 123, 160, 92, 125, 160, 93, 126, 160, 94, 34, 161, 161, 128, 161, 161, 122, 161, 161, 123, 161, 161, 125, 161, 161, 126, 161, 161, 34, 161, 159, 128, 161, 208, 122, 161, 92, 123, 161, 91, 125, 161, 94, 126, 161, 93, 34, 162, 162, 128, 162, 162, 122, 162, 162, 123, 162, 162, 125, 162, 162, 126, 162, 162, 34, 162, 158, 128, 162, 95, 122, 162, 96, 123, 162, 96, 125, 162, 97, 126, 162, 97, 33, 163, 163, 120, 163, 163, 33, 163, 98, 120, 163, 209, 33, 164, 164, 120, 164, 164, 33, 164, 99, 120, 164, 210, 33, 165, 165, 120, 165, 165, 33, 165, 100, 120, 165, 211, 42, 166, 166, 42, 166, 101, 62, 167, 167, 62, 167, 101, 34, 168, 168, 128, 168, 168, 122, 168, 168, 123, 168, 168, 125, 168, 168, 126, 168, 168, 34, 168, 103, 128, 168, 126, 122, 168, 212, 123, 168, 212, 125, 168, 213, 126, 168, 213, 33, 169, 169, 120, 169, 169, 33, 169, 103, 120, 169, 118, 42, 170, 170, 42, 170, 104, 62, 171, 171, 62, 171, 104, 42, 172, 172, 42, 172, 107, 62, 173, 173, 62, 173, 107, 42, 174, 174, 42, 174, 109, 62, 175, 175, 62, 175, 109, 42, 176, 176, 42, 176, 115, 62, 177, 177, 62, 177, 115, 59, 178, 178, 59, 178, 119, 26, 179, 179, 106, 179, 179, 26, 179, 120, 106, 179, 214, 30, 180, 180, 30, 180, 120, 28, 181, 181, 28, 181, 120, 18, 182, 182, 18, 182, 120, 57, 183, 183, 57, 183, 122, 57, 184, 184, 57, 184, 123, 20, 185, 185, 20, 185, 127, 36, 186, 186, 37, 186, 186, 36, 186, 131, 37, 186, 131, 40, 187, 187, 39, 187, 187, 40, 187, 131, 39, 187, 131, 26, 188, 188, 106, 188, 188, 26, 188, 133, 106, 188, 215, 30, 189, 189, 30, 189, 133, 28, 190, 190, 28, 190, 133, 18, 191, 191, 18, 191, 133, 26, 192, 192, 106, 192, 192, 26, 192, 134, 106, 192, 216, 30, 193, 193, 30, 193, 134, 28, 194, 194, 28, 194, 134, 18, 195, 195, 18, 195, 134, 48, 196, 196, 48, 196, 135, 9, 197, 197, 98, 197, 197, 9, 197, 138, 98, 197, 217, 9, 198, 198, 98, 198, 198, 9, 198, 139, 98, 198, 218, 9, 199, 199, 98, 199, 199, 9, 199, 140, 98, 199, 219, 9, 200, 200, 98, 200, 200, 9, 200, 141, 98, 200, 220, 9, 201, 201, 98, 201, 201, 9, 201, 142, 98, 201, 221, 59, 202, 202, 59, 202, 143, 59, 203, 203, 59, 203, 146, 48, 204, 204, 48, 204, 153, 48, 205, 205, 48, 205, 154, 36, 206, 206, 37, 206, 206, 36, 206, 157, 37, 206, 157, 40, 207, 207, 39, 207, 207, 40, 207, 157, 39, 207, 157, 42, 208, 208, 42, 208, 161, 34, 209, 209, 128, 209, 209, 122, 209, 209, 123, 209, 209, 125, 209, 209, 126, 209, 209, 34, 209, 163, 128, 209, 222, 122, 209, 223, 123, 209, 224, 125, 209, 225, 126, 209, 226, 34, 210, 210, 128, 210, 210, 122, 210, 210, 123, 210, 210, 125, 210, 210, 126, 210, 210, 34, 210, 164, 128, 210, 227, 122, 210, 228, 123, 210, 228, 125, 210, 229, 126, 210, 229, 34, 211, 211, 128, 211, 211, 122, 211, 211, 123, 211, 211, 125, 211, 211, 126, 211, 211, 34, 211, 165, 128, 211, 230, 122, 211, 224, 123, 211, 223, 125, 211, 226, 126, 211, 225, 36, 212, 212, 37, 212, 212, 36, 212, 168, 37, 212, 168, 40, 213, 213, 39, 213, 213, 40, 213, 168, 39, 213, 168, 20, 214, 214, 20, 214, 179, 20, 215, 215, 20, 215, 188, 20, 216, 216, 20, 216, 192, 12, 217, 217, 12, 217, 197, 12, 218, 218, 12, 218, 198, 12, 219, 219, 12, 219, 199, 12, 220, 220, 12, 220, 200, 12, 221, 221, 12, 221, 201, 42, 222, 222, 42, 222, 209, 36, 223, 223, 37, 223, 223, 36, 223, 209, 37, 223, 211, 36, 224, 224, 37, 224, 224, 36, 224, 211, 37, 224, 209, 40, 225, 225, 39, 225, 225, 40, 225, 211, 39, 225, 209, 40, 226, 226, 39, 226, 226, 40, 226, 209, 39, 226, 211, 42, 227, 227, 42, 227, 210, 36, 228, 228, 37, 228, 228, 36, 228, 210, 37, 228, 210, 40, 229, 229, 39, 229, 229, 40, 229, 210, 39, 229, 210, 42, 230, 230, 42, 230, 211)), ncol=3, byrow=T)
   colnames(ind_a)=c("indf", "ir0", "ic0")
   l$ind_a=ind_a
   
   # vector b
   ind_b=matrix(as.integer(c(2, 8, 116, 1, 8, 117, 2, 13, 118, 1, 13, 119, 2, 15, 120, 1, 15, 121, 2, 19, 122, 1, 19, 123, 2, 24, 124, 1, 24, 125, 2, 35, 126, 1, 35, 127)), ncol=2+1, byrow=T)
   colnames(ind_b)=c("indf", "irow", paste("indx", seq_len(1), sep=""))
   l$ind_b=ind_b
   
   # jacobian b_x
   imaxprod=seq_len(maxprod)
   ind_bx=c()
   for (ix in imaxprod) {
      i=ind_b[,2+ix]>ba_x # exclude from differentiation plain input entries
      tmp=ind_b[i,,drop=FALSE]
      ind_bx=rbind(ind_bx, tmp[,c(1,2,ix+2,2+imaxprod[-ix])]) # move diff var to ic1 place
   }
   if (length(ind_bx)) {
      colnames(ind_bx)=c("indf", "irow", "ic1", sprintf("indx%d", seq_len(maxprod-1)))
      ind_bx[,"ic1"]=ind_bx[,"ic1"]-ba_x
   }
   l$ind_bx=ind_bx
}
spAbr[[w]]=l

if (TIMEIT) {
   cat("weight 2: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}
w=2
nb_c=359
ba_x=127; # base of cumomer indexes in incu vector
l=new.env()
l$w=w
l$nb_c=nb_c
l$nb_fwrv=nb_fwrv
l$nb_cl=231 # number of lighter cumomers
maxprod=2
if (nb_c > 0) {
   # matrix a
   ind_a=matrix(as.integer(c(70, 0, 0, 147, 0, 0, 171, 0, 0, 170, 0, 0, 170, 0, 0, 70, 0, 22, 147, 0, 147, 171, 0, 98, 170, 0, 98, 170, 0, 148, 70, 1, 1, 147, 1, 1, 171, 1, 1, 170, 1, 1, 170, 1, 1, 70, 1, 8, 147, 1, 149, 171, 1, 103, 170, 1, 103, 170, 1, 150, 157, 2, 2, 65, 2, 2, 157, 2, 122, 157, 3, 3, 65, 3, 3, 157, 3, 119, 80, 4, 4, 131, 4, 4, 153, 4, 4, 80, 4, 98, 131, 4, 151, 153, 4, 74, 157, 5, 5, 65, 5, 5, 157, 5, 121, 79, 6, 6, 83, 6, 6, 85, 6, 6, 164, 6, 6, 79, 6, 83, 83, 6, 98, 85, 6, 114, 164, 6, 15, 79, 7, 7, 83, 7, 7, 85, 7, 7, 164, 7, 7, 79, 7, 52, 83, 7, 103, 85, 7, 111, 164, 7, 51, 86, 8, 8, 156, 8, 8, 152, 8, 8, 86, 8, 52, 156, 8, 1, 152, 8, 103, 86, 9, 9, 156, 9, 9, 152, 9, 9, 86, 9, 44, 156, 9, 23, 152, 9, 104, 165, 10, 10, 172, 10, 10, 2, 10, 10, 1, 10, 10, 165, 10, 47, 172, 10, 12, 70, 11, 11, 147, 11, 11, 170, 11, 11, 171, 11, 11, 170, 11, 11, 70, 11, 36, 147, 11, 152, 170, 11, 153, 86, 12, 12, 156, 12, 12, 152, 12, 12, 86, 12, 10, 156, 12, 29, 79, 13, 13, 164, 13, 13, 83, 13, 13, 85, 13, 13, 79, 13, 40, 164, 13, 63, 78, 14, 14, 90, 14, 14, 78, 14, 46, 90, 14, 104, 78, 15, 15, 90, 15, 15, 78, 15, 6, 90, 15, 98, 3, 16, 16, 155, 16, 16, 154, 16, 16, 3, 16, 119, 155, 16, 154, 154, 16, 155, 78, 17, 17, 90, 17, 17, 78, 17, 75, 79, 18, 18, 164, 18, 18, 83, 18, 18, 85, 18, 18, 79, 18, 33, 164, 18, 68, 86, 19, 19, 156, 19, 19, 152, 19, 19, 86, 19, 82, 156, 19, 43, 165, 20, 20, 172, 20, 20, 2, 20, 20, 1, 20, 20, 165, 20, 64, 172, 20, 87, 79, 21, 21, 164, 21, 21, 83, 21, 21, 85, 21, 21, 79, 21, 42, 164, 21, 65, 86, 22, 22, 156, 22, 22, 152, 22, 22, 86, 22, 83, 156, 22, 0, 152, 22, 98, 70, 23, 23, 147, 23, 23, 171, 23, 23, 170, 23, 23, 170, 23, 23, 70, 23, 9, 147, 23, 156, 171, 23, 104, 170, 23, 104, 170, 23, 157, 157, 24, 24, 65, 24, 24, 157, 24, 128, 80, 25, 25, 131, 25, 25, 153, 25, 25, 80, 25, 104, 131, 25, 158, 153, 25, 72, 3, 26, 26, 155, 26, 26, 154, 26, 26, 3, 26, 128, 155, 26, 155, 154, 26, 154, 157, 27, 27, 65, 27, 27, 157, 27, 125, 165, 28, 28, 172, 28, 28, 2, 28, 28, 1, 28, 28, 165, 28, 34, 172, 28, 84, 70, 29, 29, 147, 29, 29, 170, 29, 29, 171, 29, 29, 170, 29, 29, 70, 29, 12, 147, 29, 159, 170, 29, 160, 79, 30, 30, 83, 30, 30, 164, 30, 30, 85, 30, 30, 79, 30, 38, 83, 30, 99, 164, 30, 49, 79, 31, 31, 85, 31, 31, 164, 31, 31, 83, 31, 31, 79, 31, 58, 85, 31, 107, 164, 31, 92, 65, 32, 32, 157, 32, 32, 65, 32, 113, 157, 32, 120, 165, 33, 33, 172, 33, 33, 2, 33, 33, 1, 33, 33, 165, 33, 18, 172, 33, 70, 79, 34, 34, 164, 34, 34, 83, 34, 34, 85, 34, 34, 79, 34, 28, 164, 34, 77, 78, 35, 35, 90, 35, 35, 78, 35, 47, 86, 36, 36, 156, 36, 36, 152, 36, 36, 86, 36, 42, 156, 36, 11, 78, 37, 37, 90, 37, 37, 78, 37, 62, 90, 37, 103, 165, 38, 38, 172, 38, 38, 2, 38, 38, 1, 38, 38, 165, 38, 30, 172, 38, 81, 65, 39, 39, 157, 39, 39, 65, 39, 118, 165, 40, 40, 172, 40, 40, 2, 40, 40, 1, 40, 40, 165, 40, 13, 172, 40, 55, 65, 41, 41, 157, 41, 41, 165, 42, 42, 172, 42, 42, 2, 42, 42, 1, 42, 42, 165, 42, 21, 172, 42, 36, 70, 43, 43, 147, 43, 43, 170, 43, 43, 171, 43, 43, 170, 43, 43, 70, 43, 19, 147, 43, 161, 170, 43, 162, 165, 44, 44, 172, 44, 44, 2, 44, 44, 1, 44, 44, 165, 44, 46, 172, 44, 9, 3, 45, 45, 155, 45, 45, 154, 45, 45, 3, 45, 127, 155, 45, 163, 154, 45, 164, 79, 46, 46, 83, 46, 46, 85, 46, 46, 164, 46, 46, 79, 46, 44, 83, 46, 104, 85, 46, 110, 164, 46, 14, 79, 47, 47, 85, 47, 47, 164, 47, 47, 83, 47, 47, 79, 47, 10, 85, 47, 115, 164, 47, 35, 65, 48, 48, 157, 48, 48, 65, 48, 112, 157, 48, 126, 78, 49, 49, 90, 49, 49, 78, 49, 30, 90, 49, 104, 79, 50, 50, 83, 50, 50, 164, 50, 50, 85, 50, 50, 79, 50, 67, 83, 50, 101, 164, 50, 76, 78, 51, 51, 90, 51, 51, 78, 51, 7, 90, 51, 103, 165, 52, 52, 172, 52, 52, 2, 52, 52, 1, 52, 52, 165, 52, 7, 172, 52, 8, 86, 53, 53, 152, 53, 53, 156, 53, 53, 86, 53, 61, 152, 53, 106, 3, 54, 54, 155, 54, 54, 154, 54, 54, 3, 54, 124, 155, 54, 164, 154, 54, 163, 86, 55, 55, 156, 55, 55, 152, 55, 55, 86, 55, 40, 65, 56, 56, 157, 56, 56, 65, 56, 117, 3, 57, 57, 155, 57, 57, 154, 57, 57, 3, 57, 121, 155, 57, 165, 154, 57, 165, 165, 58, 58, 172, 58, 58, 2, 58, 58, 1, 58, 58, 165, 58, 31, 172, 58, 71, 86, 59, 59, 156, 59, 59, 152, 59, 59, 86, 59, 67, 156, 59, 85, 152, 59, 105, 165, 60, 60, 172, 60, 60, 2, 60, 60, 1, 60, 60, 165, 60, 75, 172, 60, 79, 165, 61, 61, 172, 61, 61, 2, 61, 61, 1, 61, 61, 165, 61, 62, 172, 61, 53, 79, 62, 62, 83, 62, 62, 85, 62, 62, 164, 62, 62, 79, 62, 61, 83, 62, 102, 85, 62, 85, 164, 62, 37, 78, 63, 63, 90, 63, 63, 78, 63, 13, 79, 64, 64, 164, 64, 64, 83, 64, 64, 85, 64, 64, 79, 64, 20, 164, 64, 93, 78, 65, 65, 90, 65, 65, 78, 65, 21, 3, 66, 66, 155, 66, 66, 154, 66, 66, 3, 66, 125, 155, 66, 166, 154, 66, 166, 165, 67, 67, 172, 67, 67, 2, 67, 67, 1, 67, 67, 165, 67, 50, 172, 67, 59, 78, 68, 68, 90, 68, 68, 78, 68, 18, 157, 69, 69, 65, 69, 69, 157, 69, 123, 86, 70, 70, 156, 70, 70, 152, 70, 70, 86, 70, 33, 86, 71, 71, 156, 71, 71, 152, 71, 71, 86, 71, 58, 156, 71, 73, 67, 72, 72, 167, 72, 72, 118, 72, 72, 168, 72, 72, 67, 72, 25, 167, 72, 109, 118, 72, 167, 168, 72, 100, 70, 73, 73, 147, 73, 73, 170, 73, 73, 171, 73, 73, 170, 73, 73, 70, 73, 71, 147, 73, 168, 170, 73, 169, 67, 74, 74, 167, 74, 74, 118, 74, 74, 168, 74, 74, 67, 74, 4, 167, 74, 118, 118, 74, 170, 168, 74, 106, 79, 75, 75, 164, 75, 75, 83, 75, 75, 85, 75, 75, 79, 75, 60, 164, 75, 17, 78, 76, 76, 90, 76, 76, 78, 76, 50, 90, 76, 98, 78, 77, 77, 90, 77, 77, 78, 77, 34, 80, 78, 78, 131, 78, 78, 153, 78, 78, 80, 78, 103, 131, 78, 171, 153, 78, 91, 86, 79, 79, 156, 79, 79, 152, 79, 79, 86, 79, 60, 156, 79, 96, 79, 80, 80, 85, 80, 80, 164, 80, 80, 83, 80, 80, 79, 80, 82, 85, 80, 116, 164, 80, 88, 86, 81, 81, 152, 81, 81, 156, 81, 81, 86, 81, 38, 152, 81, 100, 165, 82, 82, 172, 82, 82, 2, 82, 82, 1, 82, 82, 165, 82, 80, 172, 82, 19, 165, 83, 83, 172, 83, 83, 2, 83, 83, 1, 83, 83, 165, 83, 6, 172, 83, 22, 86, 84, 84, 156, 84, 84, 152, 84, 84, 86, 84, 28, 156, 84, 94, 70, 85, 85, 147, 85, 85, 171, 85, 85, 170, 85, 85, 170, 85, 85, 70, 85, 59, 147, 85, 172, 171, 85, 62, 170, 85, 102, 170, 85, 173, 65, 86, 86, 157, 86, 86, 65, 86, 97, 157, 86, 124, 86, 87, 87, 156, 87, 87, 152, 87, 87, 86, 87, 20, 78, 88, 88, 90, 88, 88, 78, 88, 80, 65, 89, 89, 157, 89, 89, 65, 89, 109, 65, 90, 90, 157, 90, 90, 67, 91, 91, 167, 91, 91, 118, 91, 91, 168, 91, 91, 67, 91, 78, 167, 91, 108, 118, 91, 174, 168, 91, 105, 78, 92, 92, 90, 92, 92, 78, 92, 31, 78, 93, 93, 90, 93, 93, 78, 93, 64, 70, 94, 94, 147, 94, 94, 170, 94, 94, 171, 94, 94, 170, 94, 94, 70, 94, 84, 147, 94, 175, 170, 94, 176, 65, 95, 95, 157, 95, 95, 65, 95, 108, 157, 95, 127, 70, 96, 96, 147, 96, 96, 170, 96, 96, 171, 96, 96, 170, 96, 96, 70, 96, 79, 147, 96, 177, 170, 96, 178, 77, 97, 97, 92, 97, 97, 151, 97, 97, 77, 97, 105, 92, 97, 179, 151, 97, 86, 4, 98, 98, 4, 98, 98, 84, 98, 98, 85, 98, 98, 66, 98, 98, 169, 98, 98, 166, 98, 98, 4, 98, 76, 4, 98, 15, 84, 98, 0, 85, 98, 0, 66, 98, 22, 169, 98, 6, 166, 98, 4, 169, 99, 99, 84, 99, 99, 169, 99, 30, 44, 100, 100, 82, 100, 100, 72, 100, 100, 66, 100, 100, 139, 100, 100, 163, 100, 100, 44, 100, 180, 82, 100, 72, 72, 100, 155, 66, 100, 81, 139, 100, 138, 169, 101, 101, 84, 101, 101, 169, 101, 50, 84, 102, 102, 169, 102, 102, 84, 102, 85, 169, 102, 62, 4, 103, 103, 4, 103, 103, 84, 103, 103, 85, 103, 103, 66, 103, 103, 169, 103, 103, 166, 103, 103, 4, 103, 37, 4, 103, 51, 84, 103, 1, 85, 103, 1, 66, 103, 8, 169, 103, 7, 166, 103, 78, 4, 104, 104, 4, 104, 104, 84, 104, 104, 85, 104, 104, 66, 104, 104, 169, 104, 104, 166, 104, 104, 4, 104, 49, 4, 104, 14, 84, 104, 23, 85, 104, 23, 66, 104, 9, 169, 104, 46, 166, 104, 25, 44, 105, 105, 82, 105, 105, 72, 105, 105, 66, 105, 105, 139, 105, 105, 163, 105, 105, 44, 105, 181, 82, 105, 91, 72, 105, 166, 66, 105, 59, 139, 105, 129, 163, 105, 97, 44, 106, 106, 82, 106, 106, 72, 106, 106, 66, 106, 106, 139, 106, 106, 163, 106, 106, 44, 106, 182, 82, 106, 74, 72, 106, 164, 66, 106, 53, 139, 106, 137, 83, 107, 107, 171, 107, 107, 100, 107, 107, 83, 107, 169, 171, 107, 31, 100, 107, 183, 81, 108, 108, 73, 108, 108, 103, 108, 108, 151, 108, 108, 81, 108, 91, 73, 108, 166, 103, 108, 184, 151, 108, 95, 81, 109, 109, 73, 109, 109, 103, 109, 109, 151, 109, 109, 81, 109, 72, 73, 109, 155, 103, 109, 185, 151, 109, 89, 83, 110, 110, 171, 110, 110, 100, 110, 110, 83, 110, 157, 171, 110, 46, 100, 110, 186, 83, 111, 111, 171, 111, 111, 100, 111, 111, 83, 111, 150, 171, 111, 7, 100, 111, 187, 73, 112, 112, 103, 112, 112, 151, 112, 112, 81, 112, 112, 73, 112, 163, 103, 112, 188, 151, 112, 48, 73, 113, 113, 103, 113, 113, 151, 113, 113, 81, 113, 113, 73, 113, 154, 103, 113, 189, 151, 113, 32, 83, 114, 114, 171, 114, 114, 100, 114, 114, 83, 114, 148, 171, 114, 6, 100, 114, 146, 83, 115, 115, 171, 115, 115, 100, 115, 115, 83, 115, 160, 171, 115, 47, 100, 115, 145, 83, 116, 116, 171, 116, 116, 100, 116, 116, 83, 116, 162, 171, 116, 80, 100, 116, 144, 73, 117, 117, 103, 117, 117, 151, 117, 117, 81, 117, 117, 73, 117, 165, 103, 117, 190, 151, 117, 56, 81, 118, 118, 73, 118, 118, 103, 118, 118, 151, 118, 118, 81, 118, 74, 73, 118, 164, 103, 118, 191, 151, 118, 39, 71, 119, 119, 94, 119, 119, 89, 119, 119, 71, 119, 3, 94, 119, 192, 89, 119, 16, 71, 120, 120, 94, 120, 120, 89, 120, 120, 71, 120, 32, 94, 120, 193, 71, 121, 121, 94, 121, 121, 89, 121, 121, 71, 121, 5, 94, 121, 194, 89, 121, 57, 71, 122, 122, 94, 122, 122, 89, 122, 122, 71, 122, 2, 94, 122, 195, 71, 123, 123, 94, 123, 123, 89, 123, 123, 71, 123, 69, 94, 123, 196, 71, 124, 124, 94, 124, 124, 89, 124, 124, 71, 124, 86, 94, 124, 197, 89, 124, 54, 71, 125, 125, 94, 125, 125, 89, 125, 125, 71, 125, 27, 94, 125, 198, 89, 125, 66, 71, 126, 126, 94, 126, 126, 89, 126, 126, 71, 126, 48, 94, 126, 199, 71, 127, 127, 94, 127, 127, 89, 127, 127, 71, 127, 95, 94, 127, 200, 89, 127, 45, 71, 128, 128, 94, 128, 128, 89, 128, 128, 71, 128, 24, 94, 128, 201, 89, 128, 26, 53, 129, 129, 142, 129, 129, 142, 129, 129, 140, 129, 129, 109, 129, 129, 106, 129, 129, 110, 129, 129, 53, 129, 105, 142, 129, 202, 142, 129, 130, 140, 129, 203, 109, 129, 131, 106, 129, 132, 110, 129, 204, 56, 130, 130, 143, 130, 130, 145, 130, 130, 56, 130, 129, 143, 130, 205, 145, 130, 206, 23, 131, 131, 24, 131, 131, 23, 131, 129, 24, 131, 184, 20, 132, 132, 20, 132, 129, 24, 133, 133, 23, 133, 133, 24, 133, 189, 24, 134, 134, 23, 134, 134, 24, 134, 188, 57, 135, 135, 57, 135, 202, 50, 136, 136, 50, 136, 207, 53, 137, 137, 142, 137, 137, 140, 137, 137, 110, 137, 137, 142, 137, 137, 109, 137, 137, 106, 137, 137, 53, 137, 106, 142, 137, 208, 140, 137, 209, 110, 137, 210, 53, 138, 138, 142, 138, 138, 140, 138, 138, 110, 138, 138, 142, 138, 138, 109, 138, 138, 106, 138, 138, 53, 138, 100, 142, 138, 211, 140, 138, 212, 110, 138, 213, 42, 139, 139, 42, 139, 214, 36, 140, 140, 37, 140, 140, 36, 140, 214, 37, 140, 215, 36, 141, 141, 37, 141, 141, 36, 141, 215, 37, 141, 214, 40, 142, 142, 39, 142, 142, 40, 142, 215, 39, 142, 214, 40, 143, 143, 39, 143, 143, 40, 143, 214, 39, 143, 215, 14, 144, 144, 119, 144, 144, 14, 144, 116, 119, 144, 216, 14, 145, 145, 119, 145, 145, 14, 145, 115, 119, 145, 217, 14, 146, 146, 119, 146, 146, 14, 146, 114, 119, 146, 218, 61, 147, 147, 128, 147, 147, 148, 147, 147, 61, 147, 0, 128, 147, 219, 148, 147, 220, 84, 148, 148, 169, 148, 148, 84, 148, 0, 169, 148, 114, 61, 149, 149, 128, 149, 149, 148, 149, 149, 61, 149, 1, 128, 149, 221, 148, 149, 222, 84, 150, 150, 169, 150, 150, 84, 150, 1, 169, 150, 111, 45, 151, 151, 132, 151, 151, 45, 151, 4, 132, 151, 207, 61, 152, 152, 128, 152, 152, 148, 152, 152, 61, 152, 11, 128, 152, 223, 148, 152, 224, 84, 153, 153, 169, 153, 153, 84, 153, 11, 69, 154, 154, 68, 154, 154, 159, 154, 154, 158, 154, 154, 69, 154, 16, 68, 154, 26, 159, 154, 113, 69, 155, 155, 68, 155, 155, 159, 155, 155, 158, 155, 155, 69, 155, 26, 68, 155, 16, 159, 155, 109, 158, 155, 100, 61, 156, 156, 128, 156, 156, 148, 156, 156, 61, 156, 23, 128, 156, 225, 148, 156, 226, 84, 157, 157, 169, 157, 157, 84, 157, 23, 169, 157, 110, 45, 158, 158, 132, 158, 158, 45, 158, 25, 132, 158, 227, 61, 159, 159, 128, 159, 159, 148, 159, 159, 61, 159, 29, 128, 159, 228, 148, 159, 229, 84, 160, 160, 169, 160, 160, 84, 160, 29, 169, 160, 115, 61, 161, 161, 128, 161, 161, 148, 161, 161, 61, 161, 43, 128, 161, 230, 148, 161, 231, 84, 162, 162, 169, 162, 162, 84, 162, 43, 169, 162, 116, 69, 163, 163, 68, 163, 163, 159, 163, 163, 158, 163, 163, 69, 163, 45, 68, 163, 54, 159, 163, 112, 69, 164, 164, 68, 164, 164, 159, 164, 164, 158, 164, 164, 69, 164, 54, 68, 164, 45, 159, 164, 118, 158, 164, 106, 69, 165, 165, 68, 165, 165, 159, 165, 165, 158, 165, 165, 69, 165, 57, 68, 165, 57, 159, 165, 117, 69, 166, 166, 68, 166, 166, 159, 166, 166, 158, 166, 166, 69, 166, 66, 68, 166, 66, 159, 166, 108, 158, 166, 105, 32, 167, 167, 120, 167, 167, 119, 167, 167, 32, 167, 72, 120, 167, 232, 119, 167, 233, 61, 168, 168, 128, 168, 168, 148, 168, 168, 61, 168, 73, 128, 168, 234, 148, 168, 235, 84, 169, 169, 169, 169, 169, 84, 169, 73, 169, 169, 107, 32, 170, 170, 120, 170, 170, 119, 170, 170, 32, 170, 74, 120, 170, 236, 119, 170, 237, 45, 171, 171, 132, 171, 171, 45, 171, 78, 132, 171, 238, 61, 172, 172, 128, 172, 172, 148, 172, 172, 61, 172, 85, 128, 172, 239, 148, 172, 240, 84, 173, 173, 169, 173, 173, 84, 173, 85, 32, 174, 174, 120, 174, 174, 119, 174, 174, 32, 174, 91, 120, 174, 241, 119, 174, 242, 61, 175, 175, 128, 175, 175, 148, 175, 175, 61, 175, 94, 128, 175, 243, 148, 175, 244, 84, 176, 176, 169, 176, 176, 84, 176, 94, 61, 177, 177, 128, 177, 177, 148, 177, 177, 61, 177, 96, 128, 177, 245, 148, 177, 246, 84, 178, 178, 169, 178, 178, 84, 178, 96, 6, 179, 179, 143, 179, 179, 6, 179, 97, 143, 179, 247, 42, 180, 180, 130, 180, 180, 42, 180, 232, 130, 180, 100, 42, 181, 181, 130, 181, 181, 42, 181, 241, 130, 181, 105, 42, 182, 182, 130, 182, 182, 42, 182, 236, 130, 182, 106, 14, 183, 183, 119, 183, 183, 14, 183, 107, 119, 183, 248, 17, 184, 184, 109, 184, 184, 112, 184, 184, 116, 184, 184, 114, 184, 184, 104, 184, 184, 110, 184, 184, 17, 184, 108, 109, 184, 204, 112, 184, 249, 116, 184, 250, 114, 184, 251, 104, 184, 252, 110, 184, 131, 17, 185, 185, 109, 185, 185, 112, 185, 185, 116, 185, 185, 114, 185, 185, 104, 185, 185, 110, 185, 185, 17, 185, 109, 109, 185, 213, 112, 185, 253, 116, 185, 254, 114, 185, 255, 104, 185, 256, 14, 186, 186, 119, 186, 186, 14, 186, 110, 119, 186, 257, 14, 187, 187, 119, 187, 187, 14, 187, 111, 119, 187, 258, 17, 188, 188, 109, 188, 188, 112, 188, 188, 116, 188, 188, 114, 188, 188, 104, 188, 188, 110, 188, 188, 17, 188, 112, 109, 188, 259, 112, 188, 260, 116, 188, 261, 114, 188, 262, 104, 188, 263, 110, 188, 134, 17, 189, 189, 109, 189, 189, 112, 189, 189, 116, 189, 189, 114, 189, 189, 104, 189, 189, 110, 189, 189, 17, 189, 113, 109, 189, 264, 112, 189, 265, 116, 189, 266, 114, 189, 267, 104, 189, 268, 110, 189, 133, 17, 190, 190, 109, 190, 190, 112, 190, 190, 116, 190, 190, 114, 190, 190, 104, 190, 190, 110, 190, 190, 17, 190, 117, 109, 190, 269, 112, 190, 270, 116, 190, 271, 114, 190, 272, 104, 190, 273, 17, 191, 191, 109, 191, 191, 112, 191, 191, 116, 191, 191, 114, 191, 191, 104, 191, 191, 110, 191, 191, 17, 191, 118, 109, 191, 210, 112, 191, 274, 116, 191, 275, 114, 191, 276, 104, 191, 277, 8, 192, 192, 95, 192, 192, 8, 192, 119, 95, 192, 278, 8, 193, 193, 95, 193, 193, 8, 193, 120, 95, 193, 279, 8, 194, 194, 95, 194, 194, 8, 194, 121, 95, 194, 280, 8, 195, 195, 95, 195, 195, 8, 195, 122, 95, 195, 281, 8, 196, 196, 95, 196, 196, 8, 196, 123, 95, 196, 282, 8, 197, 197, 95, 197, 197, 8, 197, 124, 95, 197, 283, 8, 198, 198, 95, 198, 198, 8, 198, 125, 95, 198, 284, 8, 199, 199, 95, 199, 199, 8, 199, 126, 95, 199, 285, 8, 200, 200, 95, 200, 200, 8, 200, 127, 95, 200, 286, 8, 201, 201, 95, 201, 201, 8, 201, 128, 95, 201, 287, 56, 202, 202, 143, 202, 202, 145, 202, 202, 56, 202, 129, 143, 202, 135, 145, 202, 288, 54, 203, 203, 54, 203, 129, 23, 204, 204, 24, 204, 204, 23, 204, 184, 24, 204, 129, 57, 205, 205, 57, 205, 130, 59, 206, 206, 59, 206, 130, 46, 207, 207, 136, 207, 207, 134, 207, 207, 46, 207, 151, 136, 207, 136, 134, 207, 289, 56, 208, 208, 145, 208, 208, 143, 208, 208, 56, 208, 137, 145, 208, 290, 54, 209, 209, 54, 209, 137, 23, 210, 210, 24, 210, 210, 23, 210, 191, 24, 210, 137, 56, 211, 211, 145, 211, 211, 143, 211, 211, 56, 211, 138, 145, 211, 291, 54, 212, 212, 54, 212, 138, 23, 213, 213, 24, 213, 213, 23, 213, 185, 24, 213, 138, 34, 214, 214, 128, 214, 214, 122, 214, 214, 123, 214, 214, 125, 214, 214, 126, 214, 214, 34, 214, 242, 128, 214, 139, 122, 214, 140, 123, 214, 141, 125, 214, 142, 126, 214, 143, 34, 215, 215, 128, 215, 215, 122, 215, 215, 123, 215, 215, 125, 215, 215, 126, 215, 215, 34, 215, 292, 128, 215, 293, 122, 215, 141, 123, 215, 140, 125, 215, 143, 126, 215, 142, 33, 216, 216, 120, 216, 216, 33, 216, 144, 120, 216, 294, 33, 217, 217, 120, 217, 217, 33, 217, 145, 120, 217, 295, 33, 218, 218, 120, 218, 218, 33, 218, 146, 120, 218, 296, 42, 219, 219, 42, 219, 147, 62, 220, 220, 62, 220, 147, 42, 221, 221, 42, 221, 149, 62, 222, 222, 62, 222, 149, 42, 223, 223, 42, 223, 152, 62, 224, 224, 62, 224, 152, 42, 225, 225, 42, 225, 156, 62, 226, 226, 62, 226, 156, 46, 227, 227, 134, 227, 227, 136, 227, 227, 46, 227, 158, 134, 227, 297, 42, 228, 228, 42, 228, 159, 62, 229, 229, 62, 229, 159, 42, 230, 230, 42, 230, 161, 62, 231, 231, 62, 231, 161, 34, 232, 232, 128, 232, 232, 122, 232, 232, 123, 232, 232, 125, 232, 232, 126, 232, 232, 34, 232, 167, 128, 232, 180, 122, 232, 298, 123, 232, 298, 125, 232, 299, 126, 232, 299, 33, 233, 233, 120, 233, 233, 33, 233, 167, 120, 233, 300, 42, 234, 234, 42, 234, 168, 62, 235, 235, 62, 235, 168, 34, 236, 236, 128, 236, 236, 122, 236, 236, 123, 236, 236, 125, 236, 236, 126, 236, 236, 34, 236, 170, 128, 236, 182, 122, 236, 301, 123, 236, 301, 125, 236, 302, 126, 236, 302, 33, 237, 237, 120, 237, 237, 33, 237, 170, 120, 237, 303, 46, 238, 238, 134, 238, 238, 136, 238, 238, 46, 238, 171, 134, 238, 304, 42, 239, 239, 42, 239, 172, 62, 240, 240, 62, 240, 172, 34, 241, 241, 128, 241, 241, 122, 241, 241, 123, 241, 241, 125, 241, 241, 126, 241, 241, 34, 241, 174, 128, 241, 181, 122, 241, 305, 123, 241, 305, 125, 241, 306, 126, 241, 306, 33, 242, 242, 120, 242, 242, 33, 242, 174, 120, 242, 214, 42, 243, 243, 42, 243, 175, 62, 244, 244, 62, 244, 175, 42, 245, 245, 42, 245, 177, 62, 246, 246, 62, 246, 177, 57, 247, 247, 57, 247, 179, 33, 248, 248, 120, 248, 248, 33, 248, 183, 120, 248, 307, 26, 249, 249, 106, 249, 249, 26, 249, 184, 106, 249, 308, 30, 250, 250, 30, 250, 184, 28, 251, 251, 28, 251, 184, 18, 252, 252, 18, 252, 184, 26, 253, 253, 106, 253, 253, 26, 253, 185, 106, 253, 309, 30, 254, 254, 30, 254, 185, 28, 255, 255, 28, 255, 185, 18, 256, 256, 18, 256, 185, 33, 257, 257, 120, 257, 257, 33, 257, 186, 120, 257, 310, 33, 258, 258, 120, 258, 258, 33, 258, 187, 120, 258, 311, 23, 259, 259, 24, 259, 259, 23, 259, 188, 26, 260, 260, 106, 260, 260, 26, 260, 188, 106, 260, 312, 30, 261, 261, 30, 261, 188, 28, 262, 262, 28, 262, 188, 18, 263, 263, 18, 263, 188, 23, 264, 264, 24, 264, 264, 23, 264, 189, 26, 265, 265, 106, 265, 265, 26, 265, 189, 106, 265, 313, 30, 266, 266, 30, 266, 189, 28, 267, 267, 28, 267, 189, 18, 268, 268, 18, 268, 189, 23, 269, 269, 24, 269, 269, 23, 269, 190, 26, 270, 270, 106, 270, 270, 26, 270, 190, 106, 270, 314, 30, 271, 271, 30, 271, 190, 28, 272, 272, 28, 272, 190, 18, 273, 273, 18, 273, 190, 26, 274, 274, 106, 274, 274, 26, 274, 191, 106, 274, 315, 30, 275, 275, 30, 275, 191, 28, 276, 276, 28, 276, 191, 18, 277, 277, 18, 277, 191, 9, 278, 278, 98, 278, 278, 9, 278, 192, 98, 278, 316, 9, 279, 279, 98, 279, 279, 9, 279, 193, 98, 279, 317, 9, 280, 280, 98, 280, 280, 9, 280, 194, 98, 280, 318, 9, 281, 281, 98, 281, 281, 9, 281, 195, 98, 281, 319, 9, 282, 282, 98, 282, 282, 9, 282, 196, 98, 282, 320, 9, 283, 283, 98, 283, 283, 9, 283, 197, 98, 283, 321, 9, 284, 284, 98, 284, 284, 9, 284, 198, 98, 284, 322, 9, 285, 285, 98, 285, 285, 9, 285, 199, 98, 285, 323, 9, 286, 286, 98, 286, 286, 9, 286, 200, 98, 286, 324, 9, 287, 287, 98, 287, 287, 9, 287, 201, 98, 287, 325, 59, 288, 288, 59, 288, 202, 48, 289, 289, 48, 289, 207, 59, 290, 290, 59, 290, 208, 59, 291, 291, 59, 291, 211, 120, 292, 292, 33, 292, 292, 120, 292, 215, 42, 293, 293, 42, 293, 215, 34, 294, 294, 128, 294, 294, 122, 294, 294, 123, 294, 294, 125, 294, 294, 126, 294, 294, 34, 294, 216, 128, 294, 326, 122, 294, 327, 123, 294, 328, 125, 294, 329, 126, 294, 330, 34, 295, 295, 128, 295, 295, 122, 295, 295, 123, 295, 295, 125, 295, 295, 126, 295, 295, 34, 295, 217, 128, 295, 331, 122, 295, 332, 123, 295, 332, 125, 295, 333, 126, 295, 333, 34, 296, 296, 128, 296, 296, 122, 296, 296, 123, 296, 296, 125, 296, 296, 126, 296, 296, 34, 296, 218, 128, 296, 334, 122, 296, 328, 123, 296, 327, 125, 296, 330, 126, 296, 329, 48, 297, 297, 48, 297, 227, 36, 298, 298, 37, 298, 298, 36, 298, 232, 37, 298, 232, 40, 299, 299, 39, 299, 299, 40, 299, 232, 39, 299, 232, 34, 300, 300, 128, 300, 300, 122, 300, 300, 123, 300, 300, 125, 300, 300, 126, 300, 300, 34, 300, 233, 36, 301, 301, 37, 301, 301, 36, 301, 236, 37, 301, 236, 40, 302, 302, 39, 302, 302, 40, 302, 236, 39, 302, 236, 34, 303, 303, 128, 303, 303, 122, 303, 303, 123, 303, 303, 125, 303, 303, 126, 303, 303, 34, 303, 237, 48, 304, 304, 48, 304, 238, 36, 305, 305, 37, 305, 305, 36, 305, 241, 37, 305, 241, 40, 306, 306, 39, 306, 306, 40, 306, 241, 39, 306, 241, 34, 307, 307, 128, 307, 307, 122, 307, 307, 123, 307, 307, 125, 307, 307, 126, 307, 307, 34, 307, 248, 128, 307, 335, 122, 307, 336, 123, 307, 337, 125, 307, 338, 126, 307, 339, 20, 308, 308, 20, 308, 249, 20, 309, 309, 20, 309, 253, 34, 310, 310, 128, 310, 310, 122, 310, 310, 123, 310, 310, 125, 310, 310, 126, 310, 310, 34, 310, 257, 128, 310, 340, 122, 310, 341, 123, 310, 342, 125, 310, 343, 126, 310, 344, 34, 311, 311, 128, 311, 311, 122, 311, 311, 123, 311, 311, 125, 311, 311, 126, 311, 311, 34, 311, 258, 128, 311, 345, 122, 311, 346, 123, 311, 347, 125, 311, 348, 126, 311, 349, 20, 312, 312, 20, 312, 260, 20, 313, 313, 20, 313, 265, 20, 314, 314, 20, 314, 270, 20, 315, 315, 20, 315, 274, 12, 316, 316, 12, 316, 278, 12, 317, 317, 12, 317, 279, 12, 318, 318, 12, 318, 280, 12, 319, 319, 12, 319, 281, 12, 320, 320, 12, 320, 282, 12, 321, 321, 12, 321, 283, 12, 322, 322, 12, 322, 284, 12, 323, 323, 12, 323, 285, 12, 324, 324, 12, 324, 286, 12, 325, 325, 12, 325, 287, 42, 326, 326, 42, 326, 294, 36, 327, 327, 37, 327, 327, 36, 327, 294, 37, 327, 296, 36, 328, 328, 37, 328, 328, 36, 328, 296, 37, 328, 294, 40, 329, 329, 39, 329, 329, 40, 329, 296, 39, 329, 294, 40, 330, 330, 39, 330, 330, 40, 330, 294, 39, 330, 296, 42, 331, 331, 42, 331, 295, 36, 332, 332, 37, 332, 332, 36, 332, 295, 37, 332, 295, 40, 333, 333, 39, 333, 333, 40, 333, 295, 39, 333, 295, 42, 334, 334, 42, 334, 296, 42, 335, 335, 42, 335, 307, 36, 336, 336, 37, 336, 336, 36, 336, 307, 37, 336, 350, 36, 337, 337, 37, 337, 337, 36, 337, 350, 37, 337, 307, 40, 338, 338, 39, 338, 338, 40, 338, 350, 39, 338, 307, 40, 339, 339, 39, 339, 339, 40, 339, 307, 39, 339, 350, 42, 340, 340, 42, 340, 310, 36, 341, 341, 37, 341, 341, 36, 341, 310, 37, 341, 351, 36, 342, 342, 37, 342, 342, 36, 342, 351, 37, 342, 310, 40, 343, 343, 39, 343, 343, 40, 343, 351, 39, 343, 310, 40, 344, 344, 39, 344, 344, 40, 344, 310, 39, 344, 351, 42, 345, 345, 42, 345, 311, 36, 346, 346, 37, 346, 346, 36, 346, 311, 37, 346, 352, 36, 347, 347, 37, 347, 347, 36, 347, 352, 37, 347, 311, 40, 348, 348, 39, 348, 348, 40, 348, 352, 39, 348, 311, 40, 349, 349, 39, 349, 349, 40, 349, 311, 39, 349, 352, 34, 350, 350, 128, 350, 350, 122, 350, 350, 123, 350, 350, 125, 350, 350, 126, 350, 350, 34, 350, 353, 128, 350, 354, 122, 350, 337, 123, 350, 336, 125, 350, 339, 126, 350, 338, 34, 351, 351, 128, 351, 351, 122, 351, 351, 123, 351, 351, 125, 351, 351, 126, 351, 351, 34, 351, 355, 128, 351, 356, 122, 351, 342, 123, 351, 341, 125, 351, 344, 126, 351, 343, 34, 352, 352, 128, 352, 352, 122, 352, 352, 123, 352, 352, 125, 352, 352, 126, 352, 352, 34, 352, 357, 128, 352, 358, 122, 352, 347, 123, 352, 346, 125, 352, 349, 126, 352, 348, 120, 353, 353, 33, 353, 353, 120, 353, 350, 42, 354, 354, 42, 354, 350, 120, 355, 355, 33, 355, 355, 120, 355, 351, 42, 356, 356, 42, 356, 351, 120, 357, 357, 33, 357, 357, 120, 357, 352, 42, 358, 358, 42, 358, 352)), ncol=3, byrow=T)
   colnames(ind_a)=c("indf", "ir0", "ic0")
   l$ind_a=ind_a
   
   # vector b
   ind_b=matrix(as.integer(c(65, 3, 174, 190, 65, 4, 175, 187, 65, 6, 174, 187, 2, 11, 86, 1, 1, 11, 87, 1, 171, 12, 179, 136, 170, 12, 179, 182, 152, 13, 180, 178, 83, 14, 179, 182, 85, 14, 143, 189, 90, 18, 178, 178, 83, 19, 178, 182, 85, 19, 143, 192, 152, 20, 180, 179, 2, 21, 88, 1, 1, 21, 89, 1, 83, 22, 179, 176, 85, 22, 150, 189, 65, 25, 174, 193, 65, 28, 175, 193, 2, 29, 90, 1, 1, 29, 91, 1, 171, 30, 178, 155, 170, 30, 178, 176, 85, 31, 143, 191, 83, 32, 177, 184, 2, 34, 92, 1, 1, 34, 93, 1, 83, 35, 177, 176, 85, 35, 150, 194, 90, 36, 179, 178, 152, 37, 181, 179, 2, 39, 94, 1, 1, 39, 95, 1, 157, 40, 197, 173, 2, 41, 96, 1, 1, 41, 97, 1, 65, 42, 174, 188, 157, 42, 198, 173, 2, 43, 98, 1, 1, 43, 99, 1, 171, 44, 179, 155, 170, 44, 179, 176, 2, 45, 100, 1, 1, 45, 101, 1, 83, 48, 178, 184, 85, 51, 150, 191, 2, 53, 102, 1, 1, 53, 103, 1, 156, 54, 173, 143, 156, 56, 173, 159, 152, 56, 183, 179, 157, 57, 199, 173, 2, 59, 104, 1, 1, 59, 105, 1, 2, 61, 106, 1, 1, 61, 107, 1, 2, 62, 108, 1, 1, 62, 109, 1, 90, 64, 177, 179, 83, 65, 177, 182, 85, 65, 143, 194, 90, 66, 178, 179, 2, 68, 110, 1, 1, 68, 111, 1, 90, 69, 177, 178, 65, 70, 175, 190, 156, 71, 173, 130, 152, 71, 183, 178, 152, 72, 180, 177, 171, 74, 177, 155, 170, 74, 177, 176, 83, 76, 178, 176, 85, 76, 150, 192, 90, 78, 178, 177, 152, 80, 181, 178, 83, 81, 179, 184, 156, 82, 173, 150, 2, 83, 112, 1, 1, 83, 113, 1, 2, 84, 114, 1, 1, 84, 115, 1, 152, 85, 181, 177, 156, 88, 173, 152, 152, 88, 183, 177, 90, 89, 179, 179, 157, 90, 200, 173, 65, 91, 175, 188, 157, 91, 201, 173, 90, 93, 179, 177, 90, 94, 177, 177, 171, 95, 177, 136, 170, 95, 177, 182, 171, 97, 178, 136, 170, 97, 178, 182, 84, 100, 143, 143, 163, 101, 175, 173, 84, 102, 150, 143, 163, 107, 174, 173, 81, 113, 171, 173, 81, 114, 147, 173, 81, 118, 139, 173, 89, 121, 164, 173, 89, 123, 144, 173, 89, 124, 156, 173, 89, 127, 168, 173, 23, 134, 185, 202, 23, 135, 185, 203, 142, 138, 204, 173, 109, 138, 205, 173, 106, 138, 206, 173, 142, 139, 207, 173, 109, 139, 208, 173, 106, 139, 209, 173, 169, 154, 189, 160, 158, 155, 181, 173, 158, 164, 180, 173, 158, 166, 183, 173, 169, 174, 191, 160, 169, 177, 194, 160, 169, 179, 192, 160, 110, 186, 208, 173, 110, 191, 210, 173, 110, 192, 205, 173, 143, 209, 211, 173, 143, 212, 212, 173, 136, 228, 213, 195, 136, 239, 214, 195, 24, 260, 185, 203, 24, 265, 185, 202, 24, 270, 185, 215, 33, 293, 216, 217, 128, 301, 218, 196, 122, 301, 219, 173, 123, 301, 220, 173, 125, 301, 221, 173, 126, 301, 222, 173, 128, 304, 223, 196, 122, 304, 224, 173, 123, 304, 224, 173, 125, 304, 225, 173, 126, 304, 225, 173, 33, 354, 186, 226, 33, 356, 186, 227, 33, 358, 186, 228)), ncol=2+2, byrow=T)
   colnames(ind_b)=c("indf", "irow", paste("indx", seq_len(2), sep=""))
   l$ind_b=ind_b
   
   # jacobian b_x
   imaxprod=seq_len(maxprod)
   ind_bx=c()
   for (ix in imaxprod) {
      i=ind_b[,2+ix]>ba_x # exclude from differentiation plain input entries
      tmp=ind_b[i,,drop=FALSE]
      ind_bx=rbind(ind_bx, tmp[,c(1,2,ix+2,2+imaxprod[-ix])]) # move diff var to ic1 place
   }
   if (length(ind_bx)) {
      colnames(ind_bx)=c("indf", "irow", "ic1", sprintf("indx%d", seq_len(maxprod-1)))
      ind_bx[,"ic1"]=ind_bx[,"ic1"]-ba_x
   }
   l$ind_bx=ind_bx
}
spAbr[[w]]=l

if (TIMEIT) {
   cat("weight 3: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}
w=3
nb_c=293
ba_x=127; # base of cumomer indexes in incu vector
l=new.env()
l$w=w
l$nb_c=nb_c
l$nb_fwrv=nb_fwrv
l$nb_cl=590 # number of lighter cumomers
maxprod=2
if (nb_c > 0) {
   # matrix a
   ind_a=matrix(as.integer(c(79, 0, 0, 164, 0, 0, 83, 0, 0, 85, 0, 0, 79, 0, 52, 164, 0, 39, 70, 1, 1, 147, 1, 1, 170, 1, 1, 171, 1, 1, 170, 1, 1, 70, 1, 35, 147, 1, 140, 170, 1, 141, 78, 2, 2, 90, 2, 2, 78, 2, 101, 78, 3, 3, 90, 3, 3, 78, 3, 22, 78, 4, 4, 90, 4, 4, 78, 4, 90, 90, 4, 116, 165, 5, 5, 172, 5, 5, 2, 5, 5, 1, 5, 5, 165, 5, 26, 172, 5, 111, 78, 6, 6, 90, 6, 6, 78, 6, 47, 78, 7, 7, 90, 7, 7, 78, 7, 78, 86, 8, 8, 156, 8, 8, 152, 8, 8, 86, 8, 81, 86, 9, 9, 156, 9, 9, 152, 9, 9, 86, 9, 86, 65, 10, 10, 157, 10, 10, 79, 11, 11, 164, 11, 11, 83, 11, 11, 85, 11, 11, 79, 11, 42, 164, 11, 106, 86, 12, 12, 156, 12, 12, 152, 12, 12, 86, 12, 93, 156, 12, 113, 152, 12, 116, 79, 13, 13, 164, 13, 13, 83, 13, 13, 85, 13, 13, 79, 13, 75, 164, 13, 49, 86, 14, 14, 156, 14, 14, 152, 14, 14, 86, 14, 42, 78, 15, 15, 90, 15, 15, 78, 15, 41, 78, 16, 16, 90, 16, 16, 78, 16, 51, 3, 17, 17, 155, 17, 17, 154, 17, 17, 3, 17, 136, 155, 17, 142, 154, 17, 143, 157, 18, 18, 65, 18, 18, 157, 18, 129, 78, 19, 19, 90, 19, 19, 78, 19, 103, 79, 20, 20, 164, 20, 20, 83, 20, 20, 85, 20, 20, 79, 20, 86, 164, 20, 74, 78, 21, 21, 90, 21, 21, 78, 21, 26, 79, 22, 22, 164, 22, 22, 83, 22, 22, 85, 22, 22, 79, 22, 100, 164, 22, 3, 78, 23, 23, 90, 23, 23, 78, 23, 99, 79, 24, 24, 164, 24, 24, 83, 24, 24, 85, 24, 24, 79, 24, 66, 164, 24, 65, 78, 25, 25, 90, 25, 25, 78, 25, 98, 90, 25, 116, 79, 26, 26, 85, 26, 26, 164, 26, 26, 83, 26, 26, 79, 26, 5, 85, 26, 124, 164, 26, 21, 157, 27, 27, 65, 27, 27, 157, 27, 132, 157, 28, 28, 65, 28, 28, 157, 28, 128, 165, 29, 29, 172, 29, 29, 2, 29, 29, 1, 29, 29, 165, 29, 36, 172, 29, 76, 86, 30, 30, 156, 30, 30, 152, 30, 30, 86, 30, 52, 156, 30, 79, 86, 31, 31, 156, 31, 31, 152, 31, 31, 86, 31, 66, 65, 32, 32, 157, 32, 32, 65, 32, 121, 157, 33, 33, 65, 33, 33, 157, 33, 127, 86, 34, 34, 156, 34, 34, 152, 34, 34, 86, 34, 97, 156, 34, 43, 86, 35, 35, 156, 35, 35, 152, 35, 35, 86, 35, 61, 156, 35, 1, 79, 36, 36, 164, 36, 36, 83, 36, 36, 85, 36, 36, 79, 36, 29, 164, 36, 45, 65, 37, 37, 157, 37, 37, 78, 38, 38, 90, 38, 38, 78, 38, 88, 78, 39, 39, 90, 39, 39, 78, 39, 0, 165, 40, 40, 172, 40, 40, 2, 40, 40, 1, 40, 40, 165, 40, 90, 172, 40, 56, 79, 41, 41, 164, 41, 41, 83, 41, 41, 85, 41, 41, 79, 41, 62, 164, 41, 15, 165, 42, 42, 172, 42, 42, 2, 42, 42, 1, 42, 42, 165, 42, 11, 172, 42, 14, 70, 43, 43, 147, 43, 43, 170, 43, 43, 171, 43, 43, 170, 43, 43, 70, 43, 34, 147, 43, 144, 170, 43, 145, 3, 44, 44, 155, 44, 44, 154, 44, 44, 3, 44, 135, 155, 44, 146, 154, 44, 147, 78, 45, 45, 90, 45, 45, 78, 45, 36, 70, 46, 46, 147, 46, 46, 170, 46, 46, 171, 46, 46, 170, 46, 46, 70, 46, 96, 147, 46, 148, 170, 46, 149, 79, 47, 47, 85, 47, 47, 164, 47, 47, 83, 47, 47, 79, 47, 48, 85, 47, 119, 164, 47, 6, 165, 48, 48, 172, 48, 48, 2, 48, 48, 1, 48, 48, 165, 48, 47, 172, 48, 94, 78, 49, 49, 90, 49, 49, 78, 49, 13, 165, 50, 50, 172, 50, 50, 2, 50, 50, 1, 50, 50, 165, 50, 101, 172, 50, 96, 79, 51, 51, 164, 51, 51, 83, 51, 51, 85, 51, 51, 79, 51, 61, 164, 51, 16, 165, 52, 52, 172, 52, 52, 2, 52, 52, 1, 52, 52, 165, 52, 0, 172, 52, 30, 86, 53, 53, 156, 53, 53, 152, 53, 53, 86, 53, 108, 65, 54, 54, 157, 54, 54, 78, 55, 55, 90, 55, 55, 78, 55, 91, 86, 56, 56, 152, 56, 56, 156, 56, 56, 86, 56, 40, 152, 56, 118, 86, 57, 57, 156, 57, 57, 152, 57, 57, 86, 57, 77, 156, 57, 60, 86, 58, 58, 156, 58, 58, 152, 58, 58, 86, 58, 87, 70, 59, 59, 147, 59, 59, 170, 59, 59, 171, 59, 59, 170, 59, 59, 70, 59, 94, 147, 59, 150, 170, 59, 151, 70, 60, 60, 147, 60, 60, 170, 60, 60, 171, 60, 60, 170, 60, 60, 70, 60, 57, 147, 60, 152, 170, 60, 153, 165, 61, 61, 172, 61, 61, 2, 61, 61, 1, 61, 61, 165, 61, 51, 172, 61, 35, 165, 62, 62, 172, 62, 62, 2, 62, 62, 1, 62, 62, 165, 62, 41, 172, 62, 67, 157, 63, 63, 65, 63, 63, 157, 63, 135, 65, 64, 64, 157, 64, 64, 65, 64, 122, 157, 64, 131, 78, 65, 65, 90, 65, 65, 78, 65, 24, 165, 66, 66, 172, 66, 66, 2, 66, 66, 1, 66, 66, 165, 66, 24, 172, 66, 31, 86, 67, 67, 156, 67, 67, 152, 67, 67, 86, 67, 62, 65, 68, 68, 157, 68, 68, 3, 69, 69, 155, 69, 69, 154, 69, 69, 3, 69, 127, 155, 69, 143, 154, 69, 142, 70, 70, 70, 147, 70, 70, 170, 70, 70, 171, 70, 70, 170, 70, 70, 70, 70, 73, 147, 70, 154, 170, 70, 155, 157, 71, 71, 65, 71, 71, 157, 71, 133, 65, 72, 72, 157, 72, 72, 86, 73, 73, 156, 73, 73, 152, 73, 73, 86, 73, 75, 156, 73, 70, 78, 74, 74, 90, 74, 74, 78, 74, 20, 165, 75, 75, 172, 75, 75, 2, 75, 75, 1, 75, 75, 165, 75, 13, 172, 75, 73, 86, 76, 76, 156, 76, 76, 152, 76, 76, 86, 76, 29, 156, 76, 105, 165, 77, 77, 172, 77, 77, 2, 77, 77, 1, 77, 77, 165, 77, 84, 172, 77, 57, 79, 78, 78, 164, 78, 78, 83, 78, 78, 85, 78, 78, 79, 78, 81, 164, 78, 7, 70, 79, 79, 147, 79, 79, 170, 79, 79, 171, 79, 79, 170, 79, 79, 70, 79, 30, 147, 79, 156, 170, 79, 157, 157, 80, 80, 65, 80, 80, 157, 80, 130, 165, 81, 81, 172, 81, 81, 2, 81, 81, 1, 81, 81, 165, 81, 78, 172, 81, 8, 165, 82, 82, 172, 82, 82, 2, 82, 82, 1, 82, 82, 165, 82, 103, 172, 82, 102, 157, 83, 83, 65, 83, 83, 157, 83, 134, 79, 84, 84, 85, 84, 84, 164, 84, 84, 83, 84, 84, 79, 84, 77, 85, 84, 125, 164, 84, 114, 65, 85, 85, 157, 85, 85, 165, 86, 86, 172, 86, 86, 2, 86, 86, 1, 86, 86, 165, 86, 20, 172, 86, 9, 165, 87, 87, 172, 87, 87, 2, 87, 87, 1, 87, 87, 165, 87, 91, 172, 87, 58, 79, 88, 88, 164, 88, 88, 83, 88, 88, 85, 88, 88, 79, 88, 97, 164, 88, 38, 3, 89, 89, 155, 89, 89, 154, 89, 89, 3, 89, 128, 155, 89, 147, 154, 89, 146, 79, 90, 90, 83, 90, 90, 164, 90, 90, 85, 90, 90, 79, 90, 40, 83, 90, 117, 164, 90, 4, 79, 91, 91, 164, 91, 91, 83, 91, 91, 85, 91, 91, 79, 91, 87, 164, 91, 55, 65, 92, 92, 157, 92, 92, 65, 92, 123, 165, 93, 93, 172, 93, 93, 2, 93, 93, 1, 93, 93, 165, 93, 98, 172, 93, 12, 86, 94, 94, 156, 94, 94, 152, 94, 94, 86, 94, 48, 156, 94, 59, 157, 95, 95, 65, 95, 95, 157, 95, 136, 86, 96, 96, 156, 96, 96, 152, 96, 96, 86, 96, 50, 156, 96, 46, 165, 97, 97, 172, 97, 97, 2, 97, 97, 1, 97, 97, 165, 97, 88, 172, 97, 34, 79, 98, 98, 83, 98, 98, 85, 98, 98, 164, 98, 98, 79, 98, 93, 83, 98, 116, 85, 98, 120, 164, 98, 25, 79, 99, 99, 164, 99, 99, 83, 99, 99, 85, 99, 99, 79, 99, 108, 164, 99, 23, 165, 100, 100, 172, 100, 100, 2, 100, 100, 1, 100, 100, 165, 100, 22, 172, 100, 109, 79, 101, 101, 164, 101, 101, 83, 101, 101, 85, 101, 101, 79, 101, 50, 164, 101, 2, 86, 102, 102, 156, 102, 102, 152, 102, 102, 86, 102, 82, 79, 103, 103, 164, 103, 103, 83, 103, 103, 85, 103, 103, 79, 103, 82, 164, 103, 19, 65, 104, 104, 157, 104, 104, 65, 104, 126, 70, 105, 105, 147, 105, 105, 170, 105, 105, 171, 105, 105, 170, 105, 105, 70, 105, 76, 147, 105, 158, 170, 105, 159, 78, 106, 106, 90, 106, 106, 78, 106, 11, 70, 107, 107, 147, 107, 107, 170, 107, 107, 171, 107, 107, 170, 107, 107, 70, 107, 111, 147, 107, 160, 170, 107, 161, 165, 108, 108, 172, 108, 108, 2, 108, 108, 1, 108, 108, 165, 108, 99, 172, 108, 53, 86, 109, 109, 156, 109, 109, 152, 109, 109, 86, 109, 100, 67, 110, 110, 167, 110, 110, 118, 110, 110, 168, 110, 110, 67, 110, 115, 167, 110, 126, 118, 110, 162, 168, 110, 118, 86, 111, 111, 156, 111, 111, 152, 111, 111, 86, 111, 5, 156, 111, 107, 65, 112, 112, 157, 112, 112, 70, 113, 113, 147, 113, 113, 171, 113, 113, 170, 113, 113, 170, 113, 113, 70, 113, 12, 147, 113, 163, 171, 113, 116, 170, 113, 116, 170, 113, 164, 78, 114, 114, 90, 114, 114, 78, 114, 84, 80, 115, 115, 131, 115, 115, 153, 115, 115, 80, 115, 116, 131, 115, 165, 153, 115, 110, 4, 116, 116, 4, 116, 116, 84, 116, 116, 85, 116, 116, 66, 116, 116, 169, 116, 116, 166, 116, 116, 4, 116, 4, 4, 116, 25, 84, 116, 113, 85, 116, 113, 66, 116, 12, 169, 116, 98, 166, 116, 115, 169, 117, 117, 84, 117, 117, 169, 117, 90, 44, 118, 118, 82, 118, 118, 72, 118, 118, 66, 118, 118, 139, 118, 118, 163, 118, 118, 44, 118, 166, 82, 118, 110, 72, 118, 142, 66, 118, 56, 139, 118, 138, 83, 119, 119, 171, 119, 119, 100, 119, 119, 83, 119, 151, 171, 119, 47, 100, 119, 139, 83, 120, 120, 171, 120, 120, 100, 120, 120, 83, 120, 164, 171, 120, 98, 100, 120, 167, 73, 121, 121, 103, 121, 121, 151, 121, 121, 81, 121, 121, 73, 121, 147, 103, 121, 168, 151, 121, 32, 73, 122, 122, 103, 122, 122, 151, 122, 122, 81, 122, 122, 73, 122, 143, 103, 122, 169, 151, 122, 64, 73, 123, 123, 103, 123, 123, 151, 123, 123, 81, 123, 123, 73, 123, 146, 103, 123, 170, 151, 123, 92, 83, 124, 124, 171, 124, 124, 100, 124, 124, 83, 124, 161, 171, 124, 26, 100, 124, 171, 83, 125, 125, 171, 125, 125, 100, 125, 125, 83, 125, 153, 171, 125, 84, 100, 125, 172, 81, 126, 126, 73, 126, 126, 103, 126, 126, 151, 126, 126, 81, 126, 110, 73, 126, 142, 103, 126, 173, 151, 126, 104, 71, 127, 127, 94, 127, 127, 89, 127, 127, 71, 127, 33, 94, 127, 174, 89, 127, 69, 71, 128, 128, 94, 128, 128, 89, 128, 128, 71, 128, 28, 94, 128, 175, 89, 128, 89, 71, 129, 129, 94, 129, 129, 89, 129, 129, 71, 129, 18, 94, 129, 176, 71, 130, 130, 94, 130, 130, 89, 130, 130, 71, 130, 80, 94, 130, 177, 71, 131, 131, 94, 131, 131, 89, 131, 131, 71, 131, 64, 94, 131, 178, 71, 132, 132, 94, 132, 132, 89, 132, 132, 71, 132, 27, 94, 132, 179, 71, 133, 133, 94, 133, 133, 89, 133, 133, 71, 133, 71, 94, 133, 180, 71, 134, 134, 94, 134, 134, 89, 134, 134, 71, 134, 83, 94, 134, 181, 71, 135, 135, 94, 135, 135, 89, 135, 135, 71, 135, 63, 94, 135, 182, 89, 135, 44, 71, 136, 136, 94, 136, 136, 89, 136, 136, 71, 136, 95, 94, 136, 183, 89, 136, 17, 24, 137, 137, 23, 137, 137, 24, 137, 169, 53, 138, 138, 142, 138, 138, 140, 138, 138, 110, 138, 138, 142, 138, 138, 109, 138, 138, 106, 138, 138, 53, 138, 118, 142, 138, 184, 140, 138, 185, 110, 138, 186, 14, 139, 139, 119, 139, 139, 14, 139, 119, 119, 139, 187, 61, 140, 140, 128, 140, 140, 148, 140, 140, 61, 140, 1, 128, 140, 188, 148, 140, 189, 84, 141, 141, 169, 141, 141, 84, 141, 1, 69, 142, 142, 68, 142, 142, 159, 142, 142, 158, 142, 142, 69, 142, 17, 68, 142, 69, 159, 142, 126, 158, 142, 118, 69, 143, 143, 68, 143, 143, 159, 143, 143, 158, 143, 143, 69, 143, 69, 68, 143, 17, 159, 143, 122, 61, 144, 144, 128, 144, 144, 148, 144, 144, 61, 144, 43, 128, 144, 190, 148, 144, 191, 84, 145, 145, 169, 145, 145, 84, 145, 43, 69, 146, 146, 68, 146, 146, 159, 146, 146, 158, 146, 146, 69, 146, 44, 68, 146, 89, 159, 146, 123, 69, 147, 147, 68, 147, 147, 159, 147, 147, 158, 147, 147, 69, 147, 89, 68, 147, 44, 159, 147, 121, 61, 148, 148, 128, 148, 148, 148, 148, 148, 61, 148, 46, 128, 148, 192, 148, 148, 193, 84, 149, 149, 169, 149, 149, 84, 149, 46, 61, 150, 150, 128, 150, 150, 148, 150, 150, 61, 150, 59, 128, 150, 194, 148, 150, 195, 84, 151, 151, 169, 151, 151, 84, 151, 59, 169, 151, 119, 61, 152, 152, 128, 152, 152, 148, 152, 152, 61, 152, 60, 128, 152, 196, 148, 152, 197, 84, 153, 153, 169, 153, 153, 84, 153, 60, 169, 153, 125, 61, 154, 154, 128, 154, 154, 148, 154, 154, 61, 154, 70, 128, 154, 198, 148, 154, 199, 84, 155, 155, 169, 155, 155, 84, 155, 70, 61, 156, 156, 128, 156, 156, 148, 156, 156, 61, 156, 79, 128, 156, 200, 148, 156, 201, 84, 157, 157, 169, 157, 157, 84, 157, 79, 61, 158, 158, 128, 158, 158, 148, 158, 158, 61, 158, 105, 128, 158, 202, 148, 158, 203, 84, 159, 159, 169, 159, 159, 84, 159, 105, 61, 160, 160, 128, 160, 160, 148, 160, 160, 61, 160, 107, 128, 160, 204, 148, 160, 205, 84, 161, 161, 169, 161, 161, 84, 161, 107, 169, 161, 124, 32, 162, 162, 120, 162, 162, 119, 162, 162, 32, 162, 110, 120, 162, 206, 119, 162, 207, 61, 163, 163, 128, 163, 163, 148, 163, 163, 61, 163, 113, 128, 163, 208, 148, 163, 209, 84, 164, 164, 169, 164, 164, 84, 164, 113, 169, 164, 120, 45, 165, 165, 132, 165, 165, 45, 165, 115, 132, 165, 210, 42, 166, 166, 130, 166, 166, 42, 166, 206, 130, 166, 118, 14, 167, 167, 119, 167, 167, 14, 167, 120, 119, 167, 211, 17, 168, 168, 109, 168, 168, 112, 168, 168, 116, 168, 168, 114, 168, 168, 104, 168, 168, 110, 168, 168, 17, 168, 121, 109, 168, 212, 112, 168, 213, 116, 168, 214, 114, 168, 215, 104, 168, 216, 17, 169, 169, 109, 169, 169, 112, 169, 169, 116, 169, 169, 114, 169, 169, 104, 169, 169, 110, 169, 169, 17, 169, 122, 109, 169, 217, 112, 169, 218, 116, 169, 219, 114, 169, 220, 104, 169, 221, 110, 169, 137, 17, 170, 170, 109, 170, 170, 112, 170, 170, 116, 170, 170, 114, 170, 170, 104, 170, 170, 110, 170, 170, 17, 170, 123, 109, 170, 222, 112, 170, 223, 116, 170, 224, 114, 170, 225, 104, 170, 226, 14, 171, 171, 119, 171, 171, 14, 171, 124, 119, 171, 227, 14, 172, 172, 119, 172, 172, 14, 172, 125, 119, 172, 228, 17, 173, 173, 109, 173, 173, 112, 173, 173, 116, 173, 173, 114, 173, 173, 104, 173, 173, 110, 173, 173, 17, 173, 126, 109, 173, 186, 112, 173, 229, 116, 173, 230, 114, 173, 231, 104, 173, 232, 8, 174, 174, 95, 174, 174, 8, 174, 127, 95, 174, 233, 8, 175, 175, 95, 175, 175, 8, 175, 128, 95, 175, 234, 8, 176, 176, 95, 176, 176, 8, 176, 129, 95, 176, 235, 8, 177, 177, 95, 177, 177, 8, 177, 130, 95, 177, 236, 8, 178, 178, 95, 178, 178, 8, 178, 131, 95, 178, 237, 8, 179, 179, 95, 179, 179, 8, 179, 132, 95, 179, 238, 8, 180, 180, 95, 180, 180, 8, 180, 133, 95, 180, 239, 8, 181, 181, 95, 181, 181, 8, 181, 134, 95, 181, 240, 8, 182, 182, 95, 182, 182, 8, 182, 135, 95, 182, 241, 8, 183, 183, 95, 183, 183, 8, 183, 136, 95, 183, 242, 56, 184, 184, 145, 184, 184, 143, 184, 184, 56, 184, 138, 145, 184, 243, 54, 185, 185, 54, 185, 138, 23, 186, 186, 24, 186, 186, 23, 186, 173, 24, 186, 138, 33, 187, 187, 120, 187, 187, 33, 187, 139, 120, 187, 244, 42, 188, 188, 42, 188, 140, 62, 189, 189, 62, 189, 140, 42, 190, 190, 42, 190, 144, 62, 191, 191, 62, 191, 144, 42, 192, 192, 42, 192, 148, 62, 193, 193, 62, 193, 148, 42, 194, 194, 42, 194, 150, 62, 195, 195, 62, 195, 150, 42, 196, 196, 42, 196, 152, 62, 197, 197, 62, 197, 152, 42, 198, 198, 42, 198, 154, 62, 199, 199, 62, 199, 154, 42, 200, 200, 42, 200, 156, 62, 201, 201, 62, 201, 156, 42, 202, 202, 42, 202, 158, 62, 203, 203, 62, 203, 158, 42, 204, 204, 42, 204, 160, 62, 205, 205, 62, 205, 160, 34, 206, 206, 128, 206, 206, 122, 206, 206, 123, 206, 206, 125, 206, 206, 126, 206, 206, 34, 206, 162, 128, 206, 166, 122, 206, 245, 123, 206, 245, 125, 206, 246, 126, 206, 246, 33, 207, 207, 120, 207, 207, 33, 207, 162, 120, 207, 247, 42, 208, 208, 42, 208, 163, 62, 209, 209, 62, 209, 163, 46, 210, 210, 134, 210, 210, 136, 210, 210, 46, 210, 165, 134, 210, 248, 33, 211, 211, 120, 211, 211, 33, 211, 167, 120, 211, 249, 23, 212, 212, 24, 212, 212, 23, 212, 168, 26, 213, 213, 106, 213, 213, 26, 213, 168, 106, 213, 250, 30, 214, 214, 30, 214, 168, 28, 215, 215, 28, 215, 168, 18, 216, 216, 18, 216, 168, 23, 217, 217, 24, 217, 217, 23, 217, 169, 26, 218, 218, 106, 218, 218, 26, 218, 169, 106, 218, 251, 30, 219, 219, 30, 219, 169, 28, 220, 220, 28, 220, 169, 18, 221, 221, 18, 221, 169, 23, 222, 222, 24, 222, 222, 23, 222, 170, 26, 223, 223, 106, 223, 223, 26, 223, 170, 106, 223, 252, 30, 224, 224, 30, 224, 170, 28, 225, 225, 28, 225, 170, 18, 226, 226, 18, 226, 170, 33, 227, 227, 120, 227, 227, 33, 227, 171, 120, 227, 253, 33, 228, 228, 120, 228, 228, 33, 228, 172, 120, 228, 254, 26, 229, 229, 106, 229, 229, 26, 229, 173, 106, 229, 255, 30, 230, 230, 30, 230, 173, 28, 231, 231, 28, 231, 173, 18, 232, 232, 18, 232, 173, 9, 233, 233, 98, 233, 233, 9, 233, 174, 98, 233, 256, 9, 234, 234, 98, 234, 234, 9, 234, 175, 98, 234, 257, 9, 235, 235, 98, 235, 235, 9, 235, 176, 98, 235, 258, 9, 236, 236, 98, 236, 236, 9, 236, 177, 98, 236, 259, 9, 237, 237, 98, 237, 237, 9, 237, 178, 98, 237, 260, 9, 238, 238, 98, 238, 238, 9, 238, 179, 98, 238, 261, 9, 239, 239, 98, 239, 239, 9, 239, 180, 98, 239, 262, 9, 240, 240, 98, 240, 240, 9, 240, 181, 98, 240, 263, 9, 241, 241, 98, 241, 241, 9, 241, 182, 98, 241, 264, 9, 242, 242, 98, 242, 242, 9, 242, 183, 98, 242, 265, 59, 243, 243, 59, 243, 184, 34, 244, 244, 128, 244, 244, 122, 244, 244, 123, 244, 244, 125, 244, 244, 126, 244, 244, 34, 244, 187, 128, 244, 266, 122, 244, 267, 123, 244, 267, 125, 244, 268, 126, 244, 268, 36, 245, 245, 37, 245, 245, 36, 245, 206, 37, 245, 206, 40, 246, 246, 39, 246, 246, 40, 246, 206, 39, 246, 206, 34, 247, 247, 128, 247, 247, 122, 247, 247, 123, 247, 247, 125, 247, 247, 126, 247, 247, 34, 247, 207, 48, 248, 248, 48, 248, 210, 34, 249, 249, 128, 249, 249, 122, 249, 249, 123, 249, 249, 125, 249, 249, 126, 249, 249, 34, 249, 211, 128, 249, 269, 122, 249, 270, 123, 249, 271, 125, 249, 272, 126, 249, 273, 20, 250, 250, 20, 250, 213, 20, 251, 251, 20, 251, 218, 20, 252, 252, 20, 252, 223, 34, 253, 253, 128, 253, 253, 122, 253, 253, 123, 253, 253, 125, 253, 253, 126, 253, 253, 34, 253, 227, 128, 253, 274, 122, 253, 275, 123, 253, 276, 125, 253, 277, 126, 253, 278, 34, 254, 254, 128, 254, 254, 122, 254, 254, 123, 254, 254, 125, 254, 254, 126, 254, 254, 34, 254, 228, 128, 254, 279, 122, 254, 280, 123, 254, 281, 125, 254, 282, 126, 254, 283, 20, 255, 255, 20, 255, 229, 12, 256, 256, 12, 256, 233, 12, 257, 257, 12, 257, 234, 12, 258, 258, 12, 258, 235, 12, 259, 259, 12, 259, 236, 12, 260, 260, 12, 260, 237, 12, 261, 261, 12, 261, 238, 12, 262, 262, 12, 262, 239, 12, 263, 263, 12, 263, 240, 12, 264, 264, 12, 264, 241, 12, 265, 265, 12, 265, 242, 42, 266, 266, 42, 266, 244, 36, 267, 267, 37, 267, 267, 36, 267, 244, 37, 267, 244, 40, 268, 268, 39, 268, 268, 40, 268, 244, 39, 268, 244, 42, 269, 269, 42, 269, 249, 36, 270, 270, 37, 270, 270, 36, 270, 249, 37, 270, 284, 36, 271, 271, 37, 271, 271, 36, 271, 284, 37, 271, 249, 40, 272, 272, 39, 272, 272, 40, 272, 284, 39, 272, 249, 40, 273, 273, 39, 273, 273, 40, 273, 249, 39, 273, 284, 42, 274, 274, 42, 274, 253, 36, 275, 275, 37, 275, 275, 36, 275, 253, 37, 275, 285, 36, 276, 276, 37, 276, 276, 36, 276, 285, 37, 276, 253, 40, 277, 277, 39, 277, 277, 40, 277, 285, 39, 277, 253, 40, 278, 278, 39, 278, 278, 40, 278, 253, 39, 278, 285, 42, 279, 279, 42, 279, 254, 36, 280, 280, 37, 280, 280, 36, 280, 254, 37, 280, 286, 36, 281, 281, 37, 281, 281, 36, 281, 286, 37, 281, 254, 40, 282, 282, 39, 282, 282, 40, 282, 286, 39, 282, 254, 40, 283, 283, 39, 283, 283, 40, 283, 254, 39, 283, 286, 34, 284, 284, 128, 284, 284, 122, 284, 284, 123, 284, 284, 125, 284, 284, 126, 284, 284, 34, 284, 287, 128, 284, 288, 122, 284, 271, 123, 284, 270, 125, 284, 273, 126, 284, 272, 34, 285, 285, 128, 285, 285, 122, 285, 285, 123, 285, 285, 125, 285, 285, 126, 285, 285, 34, 285, 289, 128, 285, 290, 122, 285, 276, 123, 285, 275, 125, 285, 278, 126, 285, 277, 34, 286, 286, 128, 286, 286, 122, 286, 286, 123, 286, 286, 125, 286, 286, 126, 286, 286, 34, 286, 291, 128, 286, 292, 122, 286, 281, 123, 286, 280, 125, 286, 283, 126, 286, 282, 120, 287, 287, 33, 287, 287, 120, 287, 284, 42, 288, 288, 42, 288, 284, 120, 289, 289, 33, 289, 289, 120, 289, 285, 42, 290, 290, 42, 290, 285, 120, 291, 291, 33, 291, 291, 120, 291, 286, 42, 292, 292, 42, 292, 286)), ncol=3, byrow=T)
   colnames(ind_a)=c("indf", "ir0", "ic0")
   l$ind_a=ind_a
   
   # vector b
   ind_b=matrix(as.integer(c(83, 1, 462, 176, 85, 1, 150, 470, 171, 2, 178, 421, 170, 2, 178, 461, 90, 3, 178, 463, 90, 4, 463, 177, 2, 6, 46, 1, 1, 6, 47, 1, 90, 7, 179, 457, 90, 8, 462, 179, 156, 9, 173, 370, 152, 9, 465, 179, 156, 10, 173, 359, 152, 10, 183, 457, 65, 11, 175, 468, 157, 11, 478, 173, 83, 12, 462, 182, 85, 12, 143, 470, 83, 14, 457, 176, 85, 14, 150, 473, 156, 15, 173, 360, 152, 15, 183, 462, 90, 16, 463, 178, 90, 17, 457, 178, 65, 19, 174, 472, 90, 20, 177, 463, 83, 21, 457, 182, 85, 21, 143, 473, 90, 22, 179, 462, 83, 23, 177, 458, 85, 23, 143, 466, 90, 24, 462, 177, 83, 25, 179, 458, 85, 25, 143, 475, 83, 27, 462, 184, 65, 28, 175, 472, 65, 29, 456, 187, 2, 30, 48, 1, 1, 30, 49, 1, 152, 31, 181, 462, 156, 32, 173, 402, 152, 32, 459, 179, 157, 33, 479, 173, 65, 34, 175, 467, 152, 35, 464, 177, 152, 36, 464, 178, 83, 37, 179, 460, 85, 37, 150, 475, 65, 38, 174, 468, 157, 38, 480, 173, 90, 39, 457, 177, 90, 40, 178, 462, 2, 41, 50, 1, 1, 41, 51, 1, 83, 42, 178, 458, 85, 42, 143, 474, 2, 43, 52, 1, 1, 43, 53, 1, 171, 44, 177, 421, 170, 44, 177, 461, 90, 46, 457, 179, 171, 47, 463, 136, 170, 47, 463, 182, 83, 48, 457, 184, 2, 49, 54, 1, 1, 49, 55, 1, 90, 50, 178, 457, 2, 51, 56, 1, 1, 51, 57, 1, 83, 52, 178, 460, 85, 52, 150, 474, 2, 53, 58, 1, 1, 53, 59, 1, 156, 54, 173, 453, 152, 54, 465, 177, 65, 55, 174, 476, 157, 55, 481, 173, 90, 56, 462, 178, 156, 57, 173, 444, 152, 58, 180, 463, 156, 59, 173, 455, 152, 59, 465, 178, 171, 60, 457, 155, 170, 60, 457, 176, 171, 61, 463, 155, 170, 61, 463, 176, 2, 62, 60, 1, 1, 62, 61, 1, 2, 63, 62, 1, 1, 63, 63, 1, 65, 64, 174, 467, 90, 66, 463, 179, 2, 67, 64, 1, 1, 67, 65, 1, 156, 68, 173, 388, 152, 68, 459, 178, 65, 69, 175, 476, 157, 69, 482, 173, 171, 71, 457, 136, 170, 71, 457, 182, 65, 72, 175, 471, 65, 73, 456, 188, 157, 73, 483, 173, 152, 74, 181, 457, 90, 75, 177, 457, 2, 76, 66, 1, 1, 76, 67, 1, 152, 77, 464, 179, 2, 78, 68, 1, 1, 78, 69, 1, 83, 79, 179, 461, 85, 79, 444, 189, 171, 80, 462, 136, 170, 80, 462, 182, 65, 81, 174, 471, 2, 82, 70, 1, 1, 82, 71, 1, 2, 83, 72, 1, 1, 83, 73, 1, 65, 84, 456, 190, 83, 85, 463, 184, 65, 86, 175, 477, 157, 86, 484, 173, 2, 87, 74, 1, 1, 87, 75, 1, 2, 88, 76, 1, 1, 88, 77, 1, 83, 89, 177, 460, 85, 89, 150, 466, 85, 91, 444, 191, 83, 92, 178, 461, 85, 92, 444, 192, 157, 93, 485, 173, 2, 94, 78, 1, 1, 94, 79, 1, 152, 95, 180, 457, 65, 96, 456, 193, 152, 97, 181, 463, 2, 98, 80, 1, 1, 98, 81, 1, 83, 100, 177, 461, 85, 100, 444, 194, 2, 101, 82, 1, 1, 101, 83, 1, 83, 102, 463, 176, 85, 102, 150, 469, 156, 103, 173, 382, 152, 103, 183, 463, 83, 104, 463, 182, 85, 104, 143, 469, 157, 105, 486, 173, 171, 106, 179, 421, 170, 106, 179, 461, 90, 107, 177, 462, 171, 108, 462, 155, 170, 108, 462, 176, 2, 109, 84, 1, 1, 109, 85, 1, 156, 110, 173, 432, 152, 110, 459, 177, 152, 112, 180, 462, 65, 113, 174, 477, 157, 113, 487, 173, 90, 115, 179, 463, 84, 118, 444, 143, 163, 119, 456, 173, 81, 122, 433, 173, 81, 123, 450, 173, 81, 124, 431, 173, 89, 130, 385, 173, 89, 131, 416, 173, 89, 132, 404, 173, 89, 133, 425, 173, 89, 134, 375, 173, 89, 135, 413, 173, 23, 138, 185, 488, 142, 139, 489, 173, 109, 139, 490, 173, 106, 139, 491, 173, 169, 142, 474, 160, 158, 144, 464, 173, 169, 146, 466, 160, 158, 147, 459, 173, 158, 148, 465, 173, 169, 150, 469, 160, 169, 156, 473, 160, 169, 158, 470, 160, 169, 160, 475, 160, 110, 169, 492, 173, 110, 171, 493, 173, 110, 174, 490, 173, 143, 185, 494, 173, 136, 211, 495, 195, 24, 213, 185, 496, 24, 218, 185, 488, 24, 223, 185, 497, 128, 248, 498, 196, 122, 248, 499, 173, 123, 248, 500, 173, 125, 248, 501, 173, 126, 248, 502, 173, 33, 288, 186, 503, 33, 290, 186, 504, 33, 292, 186, 505)), ncol=2+2, byrow=T)
   colnames(ind_b)=c("indf", "irow", paste("indx", seq_len(2), sep=""))
   l$ind_b=ind_b
   
   # jacobian b_x
   imaxprod=seq_len(maxprod)
   ind_bx=c()
   for (ix in imaxprod) {
      i=ind_b[,2+ix]>ba_x # exclude from differentiation plain input entries
      tmp=ind_b[i,,drop=FALSE]
      ind_bx=rbind(ind_bx, tmp[,c(1,2,ix+2,2+imaxprod[-ix])]) # move diff var to ic1 place
   }
   if (length(ind_bx)) {
      colnames(ind_bx)=c("indf", "irow", "ic1", sprintf("indx%d", seq_len(maxprod-1)))
      ind_bx[,"ic1"]=ind_bx[,"ic1"]-ba_x
   }
   l$ind_bx=ind_bx
}
spAbr[[w]]=l

if (TIMEIT) {
   cat("weight 4: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}
w=4
nb_c=142
ba_x=127; # base of cumomer indexes in incu vector
l=new.env()
l$w=w
l$nb_c=nb_c
l$nb_fwrv=nb_fwrv
l$nb_cl=883 # number of lighter cumomers
maxprod=2
if (nb_c > 0) {
   # matrix a
   ind_a=matrix(as.integer(c(79, 0, 0, 164, 0, 0, 83, 0, 0, 85, 0, 0, 79, 0, 50, 164, 0, 26, 78, 1, 1, 90, 1, 1, 78, 1, 22, 79, 2, 2, 164, 2, 2, 83, 2, 2, 85, 2, 2, 79, 2, 35, 164, 2, 25, 165, 3, 3, 172, 3, 3, 2, 3, 3, 1, 3, 3, 165, 3, 30, 172, 3, 14, 79, 4, 4, 164, 4, 4, 83, 4, 4, 85, 4, 4, 79, 4, 68, 164, 4, 36, 79, 5, 5, 164, 5, 5, 83, 5, 5, 85, 5, 5, 79, 5, 29, 164, 5, 61, 65, 6, 6, 157, 6, 6, 157, 7, 7, 65, 7, 7, 157, 7, 86, 165, 8, 8, 172, 8, 8, 2, 8, 8, 1, 8, 8, 165, 8, 46, 172, 8, 16, 86, 9, 9, 156, 9, 9, 152, 9, 9, 86, 9, 64, 165, 10, 10, 172, 10, 10, 2, 10, 10, 1, 10, 10, 165, 10, 76, 172, 10, 19, 165, 11, 11, 172, 11, 11, 2, 11, 11, 1, 11, 11, 165, 11, 69, 172, 11, 73, 86, 12, 12, 156, 12, 12, 152, 12, 12, 86, 12, 68, 156, 12, 51, 65, 13, 13, 157, 13, 13, 86, 14, 14, 156, 14, 14, 152, 14, 14, 86, 14, 3, 86, 15, 15, 156, 15, 15, 152, 15, 15, 86, 15, 21, 86, 16, 16, 156, 16, 16, 152, 16, 16, 86, 16, 8, 65, 17, 17, 157, 17, 17, 79, 18, 18, 164, 18, 18, 83, 18, 18, 85, 18, 18, 79, 18, 39, 164, 18, 32, 86, 19, 19, 156, 19, 19, 152, 19, 19, 86, 19, 10, 156, 19, 47, 86, 20, 20, 156, 20, 20, 152, 20, 20, 86, 20, 29, 165, 21, 21, 172, 21, 21, 2, 21, 21, 1, 21, 21, 165, 21, 62, 172, 21, 15, 79, 22, 22, 164, 22, 22, 83, 22, 22, 85, 22, 22, 79, 22, 40, 164, 22, 1, 65, 23, 23, 157, 23, 23, 65, 24, 24, 157, 24, 24, 65, 24, 81, 78, 25, 25, 90, 25, 25, 78, 25, 2, 78, 26, 26, 90, 26, 26, 78, 26, 0, 86, 27, 27, 156, 27, 27, 152, 27, 27, 86, 27, 58, 3, 28, 28, 155, 28, 28, 154, 28, 28, 3, 28, 86, 155, 28, 88, 154, 28, 88, 165, 29, 29, 172, 29, 29, 2, 29, 29, 1, 29, 29, 165, 29, 5, 172, 29, 20, 79, 30, 30, 164, 30, 30, 83, 30, 30, 85, 30, 30, 79, 30, 3, 164, 30, 37, 86, 31, 31, 156, 31, 31, 152, 31, 31, 86, 31, 45, 156, 31, 67, 78, 32, 32, 90, 32, 32, 78, 32, 18, 78, 33, 33, 90, 33, 33, 78, 33, 49, 157, 34, 34, 65, 34, 34, 157, 34, 85, 165, 35, 35, 172, 35, 35, 2, 35, 35, 1, 35, 35, 165, 35, 2, 172, 35, 42, 78, 36, 36, 90, 36, 36, 78, 36, 4, 78, 37, 37, 90, 37, 37, 78, 37, 30, 65, 38, 38, 157, 38, 38, 165, 39, 39, 172, 39, 39, 2, 39, 39, 1, 39, 39, 165, 39, 18, 172, 39, 63, 165, 40, 40, 172, 40, 40, 2, 40, 40, 1, 40, 40, 165, 40, 22, 172, 40, 60, 79, 41, 41, 164, 41, 41, 83, 41, 41, 85, 41, 41, 79, 41, 53, 164, 41, 55, 86, 42, 42, 156, 42, 42, 152, 42, 42, 86, 42, 35, 156, 42, 75, 157, 43, 43, 65, 43, 43, 157, 43, 84, 157, 44, 44, 65, 44, 44, 157, 44, 83, 165, 45, 45, 172, 45, 45, 2, 45, 45, 1, 45, 45, 165, 45, 56, 172, 45, 31, 79, 46, 46, 164, 46, 46, 83, 46, 46, 85, 46, 46, 79, 46, 8, 164, 46, 52, 70, 47, 47, 147, 47, 47, 170, 47, 47, 171, 47, 47, 170, 47, 47, 70, 47, 19, 147, 47, 89, 170, 47, 90, 78, 48, 48, 90, 48, 48, 78, 48, 76, 79, 49, 49, 164, 49, 49, 83, 49, 49, 85, 49, 49, 79, 49, 58, 164, 49, 33, 165, 50, 50, 172, 50, 50, 2, 50, 50, 1, 50, 50, 165, 50, 0, 172, 50, 80, 70, 51, 51, 147, 51, 51, 170, 51, 51, 171, 51, 51, 170, 51, 51, 70, 51, 12, 147, 51, 91, 170, 51, 92, 78, 52, 52, 90, 52, 52, 78, 52, 46, 165, 53, 53, 172, 53, 53, 2, 53, 53, 1, 53, 53, 165, 53, 41, 172, 53, 65, 78, 54, 54, 90, 54, 54, 78, 54, 56, 78, 55, 55, 90, 55, 55, 78, 55, 41, 79, 56, 56, 164, 56, 56, 83, 56, 56, 85, 56, 56, 79, 56, 45, 164, 56, 54, 79, 57, 57, 164, 57, 57, 83, 57, 57, 85, 57, 57, 79, 57, 64, 164, 57, 74, 165, 58, 58, 172, 58, 58, 2, 58, 58, 1, 58, 58, 165, 58, 49, 172, 58, 27, 65, 59, 59, 157, 59, 59, 86, 60, 60, 156, 60, 60, 152, 60, 60, 86, 60, 40, 78, 61, 61, 90, 61, 61, 78, 61, 5, 79, 62, 62, 164, 62, 62, 83, 62, 62, 85, 62, 62, 79, 62, 21, 164, 62, 72, 86, 63, 63, 156, 63, 63, 152, 63, 63, 86, 63, 39, 156, 63, 70, 165, 64, 64, 172, 64, 64, 2, 64, 64, 1, 64, 64, 165, 64, 57, 172, 64, 9, 86, 65, 65, 156, 65, 65, 152, 65, 65, 86, 65, 53, 65, 66, 66, 157, 66, 66, 70, 67, 67, 147, 67, 67, 170, 67, 67, 171, 67, 67, 170, 67, 67, 70, 67, 31, 147, 67, 93, 170, 67, 94, 165, 68, 68, 172, 68, 68, 2, 68, 68, 1, 68, 68, 165, 68, 4, 172, 68, 12, 79, 69, 69, 164, 69, 69, 83, 69, 69, 85, 69, 69, 79, 69, 11, 164, 69, 78, 70, 70, 70, 147, 70, 70, 170, 70, 70, 171, 70, 70, 170, 70, 70, 70, 70, 63, 147, 70, 95, 170, 70, 96, 157, 71, 71, 65, 71, 71, 157, 71, 87, 78, 72, 72, 90, 72, 72, 78, 72, 62, 86, 73, 73, 156, 73, 73, 152, 73, 73, 86, 73, 11, 78, 74, 74, 90, 74, 74, 78, 74, 57, 70, 75, 75, 147, 75, 75, 170, 75, 75, 171, 75, 75, 170, 75, 75, 70, 75, 42, 147, 75, 97, 170, 75, 98, 79, 76, 76, 85, 76, 76, 164, 76, 76, 83, 76, 76, 79, 76, 10, 85, 76, 82, 164, 76, 48, 65, 77, 77, 157, 77, 77, 78, 78, 78, 90, 78, 78, 78, 78, 69, 65, 79, 79, 157, 79, 79, 86, 80, 80, 156, 80, 80, 152, 80, 80, 86, 80, 50, 73, 81, 81, 103, 81, 81, 151, 81, 81, 81, 81, 81, 73, 81, 88, 103, 81, 99, 151, 81, 24, 83, 82, 82, 171, 82, 82, 100, 82, 82, 83, 82, 90, 171, 82, 76, 100, 82, 100, 71, 83, 83, 94, 83, 83, 89, 83, 83, 71, 83, 44, 94, 83, 101, 71, 84, 84, 94, 84, 84, 89, 84, 84, 71, 84, 43, 94, 84, 102, 71, 85, 85, 94, 85, 85, 89, 85, 85, 71, 85, 34, 94, 85, 103, 71, 86, 86, 94, 86, 86, 89, 86, 86, 71, 86, 7, 94, 86, 104, 89, 86, 28, 71, 87, 87, 94, 87, 87, 89, 87, 87, 71, 87, 71, 94, 87, 105, 69, 88, 88, 68, 88, 88, 159, 88, 88, 158, 88, 88, 69, 88, 28, 68, 88, 28, 159, 88, 81, 61, 89, 89, 128, 89, 89, 148, 89, 89, 61, 89, 47, 128, 89, 106, 148, 89, 107, 84, 90, 90, 169, 90, 90, 84, 90, 47, 169, 90, 82, 61, 91, 91, 128, 91, 91, 148, 91, 91, 61, 91, 51, 128, 91, 108, 148, 91, 109, 84, 92, 92, 169, 92, 92, 84, 92, 51, 61, 93, 93, 128, 93, 93, 148, 93, 93, 61, 93, 67, 128, 93, 110, 148, 93, 111, 84, 94, 94, 169, 94, 94, 84, 94, 67, 61, 95, 95, 128, 95, 95, 148, 95, 95, 61, 95, 70, 128, 95, 112, 148, 95, 113, 84, 96, 96, 169, 96, 96, 84, 96, 70, 61, 97, 97, 128, 97, 97, 148, 97, 97, 61, 97, 75, 128, 97, 114, 148, 97, 115, 84, 98, 98, 169, 98, 98, 84, 98, 75, 17, 99, 99, 109, 99, 99, 112, 99, 99, 116, 99, 99, 114, 99, 99, 104, 99, 99, 110, 99, 99, 17, 99, 81, 109, 99, 116, 112, 99, 117, 116, 99, 118, 114, 99, 119, 104, 99, 120, 14, 100, 100, 119, 100, 100, 14, 100, 82, 119, 100, 121, 8, 101, 101, 95, 101, 101, 8, 101, 83, 95, 101, 122, 8, 102, 102, 95, 102, 102, 8, 102, 84, 95, 102, 123, 8, 103, 103, 95, 103, 103, 8, 103, 85, 95, 103, 124, 8, 104, 104, 95, 104, 104, 8, 104, 86, 95, 104, 125, 8, 105, 105, 95, 105, 105, 8, 105, 87, 95, 105, 126, 42, 106, 106, 42, 106, 89, 62, 107, 107, 62, 107, 89, 42, 108, 108, 42, 108, 91, 62, 109, 109, 62, 109, 91, 42, 110, 110, 42, 110, 93, 62, 111, 111, 62, 111, 93, 42, 112, 112, 42, 112, 95, 62, 113, 113, 62, 113, 95, 42, 114, 114, 42, 114, 97, 62, 115, 115, 62, 115, 97, 23, 116, 116, 24, 116, 116, 23, 116, 99, 26, 117, 117, 106, 117, 117, 26, 117, 99, 106, 117, 127, 30, 118, 118, 30, 118, 99, 28, 119, 119, 28, 119, 99, 18, 120, 120, 18, 120, 99, 33, 121, 121, 120, 121, 121, 33, 121, 100, 120, 121, 128, 9, 122, 122, 98, 122, 122, 9, 122, 101, 98, 122, 129, 9, 123, 123, 98, 123, 123, 9, 123, 102, 98, 123, 130, 9, 124, 124, 98, 124, 124, 9, 124, 103, 98, 124, 131, 9, 125, 125, 98, 125, 125, 9, 125, 104, 98, 125, 132, 9, 126, 126, 98, 126, 126, 9, 126, 105, 98, 126, 133, 20, 127, 127, 20, 127, 117, 34, 128, 128, 128, 128, 128, 122, 128, 128, 123, 128, 128, 125, 128, 128, 126, 128, 128, 34, 128, 121, 128, 128, 134, 122, 128, 135, 123, 128, 136, 125, 128, 137, 126, 128, 138, 12, 129, 129, 12, 129, 122, 12, 130, 130, 12, 130, 123, 12, 131, 131, 12, 131, 124, 12, 132, 132, 12, 132, 125, 12, 133, 133, 12, 133, 126, 42, 134, 134, 42, 134, 128, 36, 135, 135, 37, 135, 135, 36, 135, 128, 37, 135, 139, 36, 136, 136, 37, 136, 136, 36, 136, 139, 37, 136, 128, 40, 137, 137, 39, 137, 137, 40, 137, 139, 39, 137, 128, 40, 138, 138, 39, 138, 138, 40, 138, 128, 39, 138, 139, 34, 139, 139, 128, 139, 139, 122, 139, 139, 123, 139, 139, 125, 139, 139, 126, 139, 139, 34, 139, 140, 128, 139, 141, 122, 139, 136, 123, 139, 135, 125, 139, 138, 126, 139, 137, 120, 140, 140, 33, 140, 140, 120, 140, 139, 42, 141, 141, 42, 141, 139)), ncol=3, byrow=T)
   colnames(ind_a)=c("indf", "ir0", "ic0")
   l$ind_a=ind_a
   
   # vector b
   ind_b=matrix(as.integer(c(83, 1, 457, 458, 85, 1, 143, 837, 90, 2, 462, 463, 83, 3, 834, 176, 85, 3, 150, 838, 2, 4, 16, 1, 1, 4, 17, 1, 83, 5, 463, 460, 85, 5, 150, 843, 83, 6, 177, 835, 85, 6, 444, 466, 65, 7, 175, 844, 157, 7, 845, 173, 65, 8, 456, 467, 2, 9, 18, 1, 1, 9, 19, 1, 156, 10, 173, 719, 152, 10, 836, 178, 2, 11, 20, 1, 1, 11, 21, 1, 2, 12, 22, 1, 1, 12, 23, 1, 152, 13, 464, 463, 65, 14, 456, 468, 157, 14, 846, 173, 156, 15, 173, 797, 152, 15, 465, 462, 156, 16, 173, 823, 152, 16, 836, 179, 156, 17, 173, 825, 152, 17, 459, 462, 65, 18, 174, 839, 157, 18, 847, 173, 83, 19, 457, 460, 85, 19, 150, 837, 152, 20, 180, 834, 156, 21, 173, 761, 152, 21, 836, 177, 2, 22, 24, 1, 1, 22, 25, 1, 83, 23, 463, 461, 85, 23, 444, 469, 65, 24, 174, 841, 157, 24, 848, 173, 157, 25, 849, 173, 90, 26, 178, 834, 90, 27, 463, 457, 156, 28, 173, 788, 152, 28, 465, 457, 2, 30, 26, 1, 1, 30, 27, 1, 83, 31, 462, 461, 85, 31, 444, 470, 152, 32, 464, 462, 90, 33, 457, 457, 90, 34, 462, 457, 65, 35, 174, 840, 2, 36, 28, 1, 1, 36, 29, 1, 90, 37, 457, 463, 90, 38, 462, 462, 65, 39, 175, 839, 157, 39, 850, 173, 2, 40, 30, 1, 1, 40, 31, 1, 2, 41, 32, 1, 1, 41, 33, 1, 83, 42, 463, 458, 85, 42, 143, 843, 152, 43, 181, 834, 65, 44, 456, 471, 65, 45, 456, 472, 2, 46, 34, 1, 1, 46, 35, 1, 83, 47, 462, 458, 85, 47, 143, 842, 171, 48, 834, 155, 170, 48, 834, 176, 90, 49, 179, 834, 83, 50, 457, 461, 85, 50, 444, 473, 2, 51, 36, 1, 1, 51, 37, 1, 171, 52, 463, 421, 170, 52, 463, 461, 90, 53, 463, 462, 2, 54, 38, 1, 1, 54, 39, 1, 90, 55, 457, 462, 90, 56, 463, 463, 83, 57, 462, 460, 85, 57, 150, 842, 83, 58, 178, 835, 85, 58, 444, 474, 2, 59, 40, 1, 1, 59, 41, 1, 65, 60, 175, 841, 157, 60, 851, 173, 156, 61, 173, 764, 152, 61, 465, 463, 90, 62, 834, 177, 83, 63, 179, 835, 85, 63, 444, 475, 152, 64, 464, 457, 2, 65, 42, 1, 1, 65, 43, 1, 156, 66, 173, 778, 152, 66, 459, 463, 65, 67, 456, 476, 157, 67, 852, 173, 171, 68, 462, 421, 170, 68, 462, 461, 2, 69, 44, 1, 1, 69, 45, 1, 83, 70, 834, 182, 85, 70, 143, 838, 171, 71, 457, 421, 170, 71, 457, 461, 65, 72, 175, 840, 90, 73, 834, 179, 156, 74, 173, 831, 152, 74, 183, 834, 90, 75, 834, 178, 171, 76, 834, 136, 170, 76, 834, 182, 83, 77, 834, 184, 65, 78, 174, 844, 157, 78, 853, 173, 90, 79, 177, 834, 65, 80, 456, 477, 157, 80, 854, 173, 156, 81, 173, 777, 152, 81, 459, 457, 81, 82, 828, 173, 89, 84, 735, 173, 89, 85, 807, 173, 89, 86, 762, 173, 89, 88, 787, 173, 158, 89, 836, 173, 169, 93, 843, 160, 169, 95, 842, 160, 169, 97, 837, 160, 169, 99, 838, 160, 110, 100, 855, 173, 24, 117, 185, 856, 33, 141, 186, 857)), ncol=2+2, byrow=T)
   colnames(ind_b)=c("indf", "irow", paste("indx", seq_len(2), sep=""))
   l$ind_b=ind_b
   
   # jacobian b_x
   imaxprod=seq_len(maxprod)
   ind_bx=c()
   for (ix in imaxprod) {
      i=ind_b[,2+ix]>ba_x # exclude from differentiation plain input entries
      tmp=ind_b[i,,drop=FALSE]
      ind_bx=rbind(ind_bx, tmp[,c(1,2,ix+2,2+imaxprod[-ix])]) # move diff var to ic1 place
   }
   if (length(ind_bx)) {
      colnames(ind_bx)=c("indf", "irow", "ic1", sprintf("indx%d", seq_len(maxprod-1)))
      ind_bx[,"ic1"]=ind_bx[,"ic1"]-ba_x
   }
   l$ind_bx=ind_bx
}
spAbr[[w]]=l

if (TIMEIT) {
   cat("weight 5: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}
w=5
nb_c=39
ba_x=127; # base of cumomer indexes in incu vector
l=new.env()
l$w=w
l$nb_c=nb_c
l$nb_fwrv=nb_fwrv
l$nb_cl=1025 # number of lighter cumomers
maxprod=2
if (nb_c > 0) {
   # matrix a
   ind_a=matrix(as.integer(c(79, 0, 0, 164, 0, 0, 83, 0, 0, 85, 0, 0, 79, 0, 12, 164, 0, 3, 79, 1, 1, 164, 1, 1, 83, 1, 1, 85, 1, 1, 79, 1, 2, 164, 1, 10, 165, 2, 2, 172, 2, 2, 2, 2, 2, 1, 2, 2, 165, 2, 1, 172, 2, 4, 78, 3, 3, 90, 3, 3, 78, 3, 0, 86, 4, 4, 156, 4, 4, 152, 4, 4, 86, 4, 2, 86, 5, 5, 156, 5, 5, 152, 5, 5, 86, 5, 12, 79, 6, 6, 164, 6, 6, 83, 6, 6, 85, 6, 6, 79, 6, 21, 164, 6, 25, 70, 7, 7, 147, 7, 7, 170, 7, 7, 171, 7, 7, 170, 7, 7, 70, 7, 17, 147, 7, 32, 170, 7, 33, 78, 8, 8, 90, 8, 8, 78, 8, 9, 79, 9, 9, 164, 9, 9, 83, 9, 9, 85, 9, 9, 79, 9, 26, 164, 9, 8, 78, 10, 10, 90, 10, 10, 78, 10, 1, 65, 11, 11, 157, 11, 11, 165, 12, 12, 172, 12, 12, 2, 12, 12, 1, 12, 12, 165, 12, 0, 172, 12, 5, 78, 13, 13, 90, 13, 13, 78, 13, 24, 86, 14, 14, 156, 14, 14, 152, 14, 14, 86, 14, 22, 157, 15, 15, 65, 15, 15, 157, 15, 31, 65, 16, 16, 157, 16, 16, 86, 17, 17, 156, 17, 17, 152, 17, 17, 86, 17, 21, 156, 17, 7, 79, 18, 18, 164, 18, 18, 83, 18, 18, 85, 18, 18, 79, 18, 28, 164, 18, 19, 78, 19, 19, 90, 19, 19, 78, 19, 18, 65, 20, 20, 157, 20, 20, 165, 21, 21, 172, 21, 21, 2, 21, 21, 1, 21, 21, 165, 21, 6, 172, 21, 17, 165, 22, 22, 172, 22, 22, 2, 22, 22, 1, 22, 22, 165, 22, 24, 172, 22, 14, 86, 23, 23, 156, 23, 23, 152, 23, 23, 86, 23, 26, 79, 24, 24, 164, 24, 24, 83, 24, 24, 85, 24, 24, 79, 24, 22, 164, 24, 13, 78, 25, 25, 90, 25, 25, 78, 25, 6, 165, 26, 26, 172, 26, 26, 2, 26, 26, 1, 26, 26, 165, 26, 9, 172, 26, 23, 86, 27, 27, 156, 27, 27, 152, 27, 27, 86, 27, 28, 165, 28, 28, 172, 28, 28, 2, 28, 28, 1, 28, 28, 165, 28, 18, 172, 28, 27, 65, 29, 29, 157, 29, 29, 65, 30, 30, 157, 30, 30, 71, 31, 31, 94, 31, 31, 89, 31, 31, 71, 31, 15, 94, 31, 34, 61, 32, 32, 128, 32, 32, 148, 32, 32, 61, 32, 7, 128, 32, 35, 148, 32, 36, 84, 33, 33, 169, 33, 33, 84, 33, 7, 8, 34, 34, 95, 34, 34, 8, 34, 31, 95, 34, 37, 42, 35, 35, 42, 35, 32, 62, 36, 36, 62, 36, 32, 9, 37, 37, 98, 37, 37, 9, 37, 34, 98, 37, 38, 12, 38, 38, 12, 38, 37)), ncol=3, byrow=T)
   colnames(ind_a)=c("indf", "ir0", "ic0")
   l$ind_a=ind_a
   
   # vector b
   ind_b=matrix(as.integer(c(83, 1, 457, 835, 85, 1, 444, 837, 83, 2, 834, 458, 85, 2, 143, 1093, 2, 3, 4, 1, 1, 3, 5, 1, 90, 4, 834, 457, 156, 5, 173, 1058, 152, 5, 459, 834, 156, 6, 173, 1081, 152, 6, 836, 457, 83, 7, 834, 460, 85, 7, 150, 1093, 171, 8, 834, 421, 170, 8, 834, 461, 90, 9, 462, 834, 83, 10, 834, 461, 85, 10, 444, 838, 90, 11, 463, 834, 65, 12, 456, 839, 157, 12, 1094, 173, 2, 13, 6, 1, 1, 13, 7, 1, 90, 14, 834, 463, 156, 15, 173, 1062, 152, 15, 836, 463, 65, 16, 456, 840, 65, 17, 456, 841, 157, 17, 1095, 173, 152, 18, 464, 834, 83, 19, 462, 835, 85, 19, 444, 842, 90, 20, 834, 462, 65, 21, 174, 1092, 157, 21, 1096, 173, 2, 22, 8, 1, 1, 22, 9, 1, 2, 23, 10, 1, 1, 23, 11, 1, 156, 24, 173, 1086, 152, 24, 465, 834, 83, 25, 463, 835, 85, 25, 444, 843, 90, 26, 457, 834, 2, 27, 12, 1, 1, 27, 13, 1, 156, 28, 173, 1078, 152, 28, 836, 462, 2, 29, 14, 1, 1, 29, 15, 1, 65, 30, 456, 844, 157, 30, 1097, 173, 65, 31, 175, 1092, 157, 31, 1098, 173, 89, 32, 1039, 173, 169, 34, 1093, 160)), ncol=2+2, byrow=T)
   colnames(ind_b)=c("indf", "irow", paste("indx", seq_len(2), sep=""))
   l$ind_b=ind_b
   
   # jacobian b_x
   imaxprod=seq_len(maxprod)
   ind_bx=c()
   for (ix in imaxprod) {
      i=ind_b[,2+ix]>ba_x # exclude from differentiation plain input entries
      tmp=ind_b[i,,drop=FALSE]
      ind_bx=rbind(ind_bx, tmp[,c(1,2,ix+2,2+imaxprod[-ix])]) # move diff var to ic1 place
   }
   if (length(ind_bx)) {
      colnames(ind_bx)=c("indf", "irow", "ic1", sprintf("indx%d", seq_len(maxprod-1)))
      ind_bx[,"ic1"]=ind_bx[,"ic1"]-ba_x
   }
   l$ind_bx=ind_bx
}
spAbr[[w]]=l

if (TIMEIT) {
   cat("weight 6: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}
w=6
nb_c=5
ba_x=127; # base of cumomer indexes in incu vector
l=new.env()
l$w=w
l$nb_c=nb_c
l$nb_fwrv=nb_fwrv
l$nb_cl=1064 # number of lighter cumomers
maxprod=2
if (nb_c > 0) {
   # matrix a
   ind_a=matrix(as.integer(c(65, 0, 0, 157, 0, 0, 78, 1, 1, 90, 1, 1, 78, 1, 2, 79, 2, 2, 164, 2, 2, 83, 2, 2, 85, 2, 2, 79, 2, 3, 164, 2, 1, 165, 3, 3, 172, 3, 3, 2, 3, 3, 1, 3, 3, 165, 3, 2, 172, 3, 4, 86, 4, 4, 156, 4, 4, 152, 4, 4, 86, 4, 3)), ncol=3, byrow=T)
   colnames(ind_a)=c("indf", "ir0", "ic0")
   l$ind_a=ind_a
   
   # vector b
   ind_b=matrix(as.integer(c(65, 1, 456, 1092, 157, 1, 1184, 173, 90, 2, 834, 834, 83, 3, 834, 835, 85, 3, 444, 1093, 2, 4, 2, 1, 1, 4, 3, 1, 156, 5, 173, 1160, 152, 5, 836, 834)), ncol=2+2, byrow=T)
   colnames(ind_b)=c("indf", "irow", paste("indx", seq_len(2), sep=""))
   l$ind_b=ind_b
   
   # jacobian b_x
   imaxprod=seq_len(maxprod)
   ind_bx=c()
   for (ix in imaxprod) {
      i=ind_b[,2+ix]>ba_x # exclude from differentiation plain input entries
      tmp=ind_b[i,,drop=FALSE]
      ind_bx=rbind(ind_bx, tmp[,c(1,2,ix+2,2+imaxprod[-ix])]) # move diff var to ic1 place
   }
   if (length(ind_bx)) {
      colnames(ind_bx)=c("indf", "irow", "ic1", sprintf("indx%d", seq_len(maxprod-1)))
      ind_bx[,"ic1"]=ind_bx[,"ic1"]-ba_x
   }
   l$ind_bx=ind_bx
}
spAbr[[w]]=l

# weight count
nb_rw=6
# cumomer count by weight
nb_rcumos=c(231, 359, 293, 142, 39, 5)
nbc_cumos=c(0, cumsum(nb_rcumos))
# cumo names
nm_rcumo=c("Fru6P:1", "ICit:32", "Rib5P:2", "Fru6P:4", "Fru6P:2", "FruBP:8", "Gnt6P:2", "Glc6P:4", "Fru6P:32", "Gnt6P:8", "FruBP:2", "PEP:4", "Glc6P:16", "ICit:1", "Glc6P:1", "Rib5P:16", "Suc:1", "ICit:4", "Glc6P:8", "PEP:2", "Gnt6P:32", "FruBP:1", "Rib5P:8", "Glc6P:2", "Rib5P:1", "ICit:16", "PGA:2", "Fru6P:16", "Suc:2", "PGA:4", "Gnt6P:4", "Rib5P:4", "Fru6P:8", "FruBP:4", "Glc6P:32", "Gnt6P:16", "Suc:4", "ICit:2", "FruBP:32", "ICit:8", "Suc:8", "PGA:1", "Gnt6P:1", "PEP:1", "FruBP:16", "CO2:1", "AcCoA:2", "AcCoA:1", "Sed7P:32", "GA3P:1", "GA3P:2", "GA3P:4", "Pyr:1", "Pyr:2", "Sed7P:64", "Pyr:4", "Sed7P:16", "BM_OAA:1", "BM_PEP:1", "OAA:2", "OAA:8", "Ery4P:4", "OAA:1", "Ery4P:8", "Ery4P:2", "OAA:4", "Ery4P:1", "FTHF:1", "PyrCO2:1", "AKG:4", "AKG:1", "AKG:16", "AKG:8", "AKG:2", "BM_Pyr:2", "BM_Pyr:1", "AKV:4", "Lys:1", "Ile:8", "AKV:2", "Lys:2", "Ile:1", "Lys:4", "Leu:8", "Leu:1", "Gly:2", "Gly:1", "BM_Pyr:4", "BM_PEP:2", "BM_Ery4P:1", "Trp:8", "Phe:16", "Phe:1", "Tyr:16", "Tyr:1", "Trp:16", "Phe:32", "Tyr:32", "BM_Ery4P:2", "BM_Ery4P:4", "BM_Ery4P:8", "BM_Rib5P:2", "Sed7P:2", "BM_PEP:4", "BM_Rib5P:16", "Mal:8", "Mal:1", "BM_Rib5P:8", "Sed7P:8", "BM_Rib5P:1", "Sed7P:1", "BM_PGA:2", "Mal:4", "Mal:2", "BM_PGA:4", "BM_Rib5P:4", "Sed7P:4", "BM_PGA:1", "Chor:64", "AKV:16", "BM_OAA:8", "Arg:1", "BM_AcCoA:2", "BM_AcCoA:1", "PyrCO2:2", "PyrCO2:4", "PyrCO2:8", "Thr:1", "Asn:1", "Met:2", "Asp:1", "Chor:128", "DAHP:16", "BM_OAA:2", "BM_OAA:4", "Ser:1", "Met:1", "His:1", "BM_AKG:4", "BM_AKG:1", "BM_AKG:16", "BM_AKG:8", "BM_AKG:2", "AKV:8", "Ala:2", "Lys:16", "AKV:1", "Ala:1", "Lys:8", "Leu:4", "Val:4", "Leu:2", "Val:2", "Ser:4", "Ser:2", "Ala:4", "Lys:32", "Chor:256", "DAHP:32", "DAHP:1", "Chor:16", "Chor:1", "Chor:32", "DAHP:2", "DAHP:4", "DAHP:8", "Trp:512", "His:16", "Chor:512", "DAHP:64", "Trp:64", "His:2", "Trp:128", "His:4", "Trp:1024", "His:32", "Trp:256", "His:8", "Val:16", "Thr:8", "Asn:8", "Met:16", "Asp:8", "Leu:32", "Leu:16", "Ile:2", "Phe:64", "Tyr:64", "Thr:2", "Asn:2", "Met:4", "Asp:2", "Thr:4", "Asn:4", "Met:8", "Asp:4", "Cys:1", "Glu:4", "Glu:1", "Glu:16", "Glu:8", "Glu:2", "Val:8", "Val:1", "Cys:4", "Cys:2", "Phe:128", "Tyr:128", "Trp:32", "Chor:2", "Chor:4", "Chor:8", "Phe:256", "Tyr:256", "Ile:32", "Ile:4", "Ile:16", "Arg:8", "Arg:2", "Arg:32", "Arg:16", "Arg:4", "Trp:1", "Phe:2", "Phe:8", "Tyr:2", "Tyr:8", "Trp:2", "Phe:4", "Tyr:4", "Trp:4", "Rib5P:6", "Rib5P:3", "ICit:33", "ICit:18", "PGA:6", "ICit:17", "Fru6P:6", "Fru6P:3", "Gnt6P:3", "Gnt6P:5", "Glc6P:10", "Rib5P:20", "Gnt6P:10", "Fru6P:36", "FruBP:5", "FruBP:6", "Suc:10", "FruBP:18", "Fru6P:34", "Gnt6P:12", "Glc6P:33", "Fru6P:20", "Gnt6P:6", "Rib5P:5", "ICit:9", "PGA:5", "Suc:5", "ICit:10", "Glc6P:17", "Rib5P:10", "Fru6P:40", "Fru6P:9", "ICit:40", "Glc6P:34", "Fru6P:17", "FruBP:10", "Gnt6P:20", "FruBP:48", "Glc6P:40", "ICit:12", "Glc6P:36", "ICit:5", "Glc6P:20", "Rib5P:12", "Glc6P:5", "Suc:12", "Fru6P:5", "Fru6P:10", "ICit:48", "FruBP:40", "Fru6P:24", "FruBP:3", "Glc6P:3", "Gnt6P:48", "Suc:3", "Gnt6P:36", "ICit:36", "Suc:9", "Glc6P:9", "Gnt6P:24", "Glc6P:18", "Glc6P:48", "Fru6P:48", "FruBP:36", "Fru6P:33", "FruBP:20", "Suc:6", "Glc6P:24", "FruBP:34", "ICit:34", "Gnt6P:34", "Gnt6P:9", "PEP:5", "Rib5P:9", "PEP:6", "Fru6P:18", "FruBP:24", "FruBP:17", "PGA:3", "Gnt6P:18", "Fru6P:12", "Gnt6P:40", "Glc6P:12", "Glc6P:6", "Gnt6P:17", "Rib5P:24", "ICit:3", "Gnt6P:33", "FruBP:12", "ICit:20", "ICit:6", "PEP:3", "FruBP:9", "FruBP:33", "Rib5P:17", "ICit:24", "Rib5P:18", "AcCoA:3", "GA3P:6", "Sed7P:80", "Pyr:5", "Sed7P:48", "Sed7P:96", "GA3P:3", "GA3P:5", "Pyr:3", "Pyr:6", "Ery4P:9", "OAA:6", "OAA:10", "Ery4P:5", "Ery4P:3", "OAA:3", "OAA:5", "Ery4P:6", "Ery4P:10", "Ery4P:12", "OAA:9", "OAA:12", "AKG:10", "AKG:20", "AKG:9", "AKG:17", "AKG:18", "AKG:3", "AKG:6", "AKG:24", "AKG:12", "AKG:5", "BM_Pyr:3", "AKV:6", "Lys:3", "Ile:9", "Lys:5", "Lys:6", "Leu:9", "Gly:3", "BM_Pyr:6", "BM_Pyr:5", "Trp:24", "Phe:48", "Phe:33", "Tyr:48", "Tyr:33", "BM_Ery4P:12", "BM_Ery4P:10", "BM_Ery4P:6", "BM_Rib5P:6", "Sed7P:6", "BM_Rib5P:3", "Sed7P:3", "BM_PGA:6", "BM_Rib5P:20", "Sed7P:20", "Mal:5", "Mal:10", "BM_Rib5P:5", "Sed7P:5", "BM_PGA:5", "BM_Rib5P:10", "Sed7P:10", "BM_Rib5P:12", "Sed7P:12", "Mal:3", "Mal:12", "Mal:9", "Mal:6", "BM_PEP:5", "BM_Rib5P:9", "Sed7P:9", "BM_PEP:6", "BM_PGA:3", "BM_Rib5P:24", "Sed7P:24", "BM_PEP:3", "BM_Rib5P:17", "Sed7P:17", "BM_Rib5P:18", "Sed7P:18", "BM_AcCoA:3", "PyrCO2:10", "PyrCO2:6", "PyrCO2:12", "BM_Ery4P:9", "BM_OAA:6", "BM_OAA:10", "BM_Ery4P:5", "BM_Ery4P:3", "BM_OAA:3", "BM_OAA:5", "BM_OAA:9", "BM_OAA:12", "BM_AKG:10", "BM_AKG:20", "BM_AKG:9", "BM_AKG:17", "BM_AKG:18", "BM_AKG:3", "BM_AKG:6", "BM_AKG:24", "BM_AKG:12", "BM_AKG:5", "AKV:9", "Ala:3", "Lys:24", "Leu:6", "Val:6", "Ser:6", "AKV:24", "Ala:6", "Lys:48", "AKV:17", "Ala:5", "Lys:40", "Chor:48", "Chor:33", "DAHP:12", "DAHP:10", "DAHP:6", "Trp:768", "His:24", "Trp:1536", "His:48", "Trp:320", "His:10", "Trp:1280", "His:40", "Ser:5", "Trp:640", "His:20", "Trp:384", "His:12", "Chor:640", "DAHP:80", "Trp:1152", "His:36", "Chor:768", "DAHP:96", "Ser:3", "Trp:192", "His:6", "Chor:384", "DAHP:48", "Trp:1088", "His:34", "Trp:576", "His:18", "Leu:48", "DAHP:9", "Thr:6", "Asn:6", "Met:12", "Asp:6", "Thr:10", "Asn:10", "Met:20", "Asp:10", "DAHP:5", "DAHP:3", "Lys:12", "Thr:3", "Asn:3", "Met:6", "Asp:3", "Lys:20", "Thr:5", "Asn:5", "Met:10", "Asp:5", "Lys:36", "Thr:9", "Asn:9", "Met:18", "Asp:9", "Thr:12", "Asn:12", "Met:24", "Asp:12", "Glu:10", "Glu:20", "Glu:9", "Glu:17", "Glu:18", "Glu:3", "Glu:6", "Glu:24", "Glu:12", "Glu:5", "Val:9", "Cys:6", "Val:24", "Val:17", "DAHP:33", "Trp:48", "Chor:12", "Chor:10", "Chor:6", "Cys:5", "Phe:320", "Tyr:320", "Chor:80", "Phe:384", "Tyr:384", "Chor:96", "Cys:3", "Phe:192", "Tyr:192", "Chor:9", "Ile:20", "Ile:36", "Chor:5", "Chor:3", "Ile:6", "Ile:18", "Ile:34", "Ile:48", "Arg:20", "Arg:40", "Arg:18", "Arg:34", "Arg:36", "Arg:6", "Arg:12", "Arg:48", "Arg:24", "Arg:10", "Trp:6", "Phe:12", "Phe:6", "Tyr:12", "Tyr:6", "Trp:5", "Phe:10", "Tyr:10", "Trp:3", "Trp:36", "Phe:9", "Phe:18", "Tyr:9", "Tyr:18", "Trp:34", "Phe:5", "Phe:20", "Tyr:5", "Tyr:20", "Trp:33", "Phe:3", "Phe:24", "Tyr:3", "Tyr:24", "Chor:18", "Chor:20", "Chor:24", "DAHP:18", "Trp:9", "DAHP:20", "Trp:10", "DAHP:24", "Trp:12", "Fru6P:19", "Rib5P:26", "FruBP:21", "FruBP:41", "FruBP:56", "Glc6P:11", "FruBP:14", "FruBP:52", "Gnt6P:52", "Gnt6P:38", "ICit:22", "Fru6P:35", "Gnt6P:7", "Fru6P:22", "Gnt6P:35", "FruBP:42", "FruBP:26", "Suc:7", "ICit:41", "FruBP:37", "Fru6P:38", "FruBP:11", "Fru6P:41", "FruBP:49", "Fru6P:44", "FruBP:7", "Fru6P:11", "ICit:42", "ICit:19", "Glc6P:28", "Gnt6P:19", "Gnt6P:44", "ICit:44", "ICit:26", "Gnt6P:25", "Gnt6P:26", "Fru6P:28", "ICit:21", "FruBP:25", "FruBP:19", "Glc6P:56", "Fru6P:42", "Glc6P:35", "Rib5P:25", "Suc:13", "FruBP:28", "Rib5P:21", "Fru6P:14", "Glc6P:14", "FruBP:22", "Glc6P:21", "Fru6P:26", "Glc6P:19", "Gnt6P:49", "ICit:37", "FruBP:50", "Gnt6P:56", "Gnt6P:13", "Gnt6P:50", "Rib5P:14", "Rib5P:13", "Glc6P:26", "Glc6P:42", "ICit:25", "ICit:56", "FruBP:44", "Glc6P:44", "Gnt6P:42", "ICit:38", "Suc:14", "Rib5P:22", "ICit:50", "ICit:7", "Gnt6P:22", "FruBP:38", "Glc6P:22", "Gnt6P:28", "Glc6P:13", "Fru6P:52", "Rib5P:19", "ICit:49", "Glc6P:52", "Glc6P:37", "ICit:35", "Fru6P:13", "ICit:14", "Glc6P:38", "Glc6P:50", "Fru6P:25", "Suc:11", "Fru6P:56", "Fru6P:50", "ICit:52", "Glc6P:7", "Gnt6P:14", "ICit:11", "Gnt6P:21", "Glc6P:25", "Fru6P:7", "Fru6P:49", "Glc6P:41", "Fru6P:21", "Gnt6P:37", "Fru6P:37", "ICit:28", "Rib5P:28", "FruBP:35", "Rib5P:11", "Glc6P:49", "Gnt6P:41", "PEP:7", "Gnt6P:11", "ICit:13", "Rib5P:7", "FruBP:13", "PGA:7", "GA3P:7", "Sed7P:112", "Pyr:7", "Ery4P:14", "Ery4P:7", "OAA:13", "OAA:7", "OAA:11", "Ery4P:11", "Ery4P:13", "OAA:14", "AKG:14", "AKG:11", "AKG:21", "AKG:25", "AKG:28", "AKG:22", "AKG:26", "AKG:19", "AKG:13", "AKG:7", "Lys:7", "BM_Pyr:7", "BM_Ery4P:14", "BM_Rib5P:26", "Sed7P:26", "Mal:14", "Mal:7", "BM_Rib5P:25", "Sed7P:25", "Mal:11", "Mal:13", "BM_Rib5P:21", "Sed7P:21", "BM_Rib5P:14", "Sed7P:14", "BM_Rib5P:13", "Sed7P:13", "BM_Rib5P:22", "Sed7P:22", "BM_Rib5P:19", "Sed7P:19", "BM_Rib5P:28", "Sed7P:28", "BM_Rib5P:11", "Sed7P:11", "BM_PEP:7", "BM_Rib5P:7", "Sed7P:7", "BM_PGA:7", "PyrCO2:14", "BM_Ery4P:7", "BM_OAA:13", "BM_OAA:7", "BM_OAA:11", "BM_Ery4P:11", "BM_Ery4P:13", "BM_OAA:14", "BM_AKG:14", "BM_AKG:11", "BM_AKG:21", "BM_AKG:25", "BM_AKG:28", "BM_AKG:22", "BM_AKG:26", "BM_AKG:19", "BM_AKG:13", "BM_AKG:7", "AKV:25", "Ala:7", "Lys:56", "DAHP:14", "Trp:704", "His:22", "Trp:1216", "His:38", "Trp:1344", "His:42", "Trp:896", "His:28", "Trp:1408", "His:44", "Trp:832", "His:26", "Trp:1600", "His:50", "Trp:448", "His:14", "Trp:1664", "His:52", "Chor:896", "DAHP:112", "Trp:1792", "His:56", "Ser:7", "DAHP:7", "Lys:52", "Thr:13", "Asn:13", "Met:26", "Asp:13", "Lys:28", "Thr:7", "Asn:7", "Met:14", "Asp:7", "Lys:44", "Thr:11", "Asn:11", "Met:22", "Asp:11", "DAHP:11", "DAHP:13", "Thr:14", "Asn:14", "Met:28", "Asp:14", "Glu:14", "Glu:11", "Glu:21", "Glu:25", "Glu:28", "Glu:22", "Glu:26", "Glu:19", "Glu:13", "Glu:7", "Val:25", "Chor:14", "Phe:448", "Tyr:448", "Chor:112", "Cys:7", "Chor:7", "Ile:50", "Ile:22", "Ile:38", "Chor:11", "Chor:13", "Ile:52", "Arg:28", "Arg:22", "Arg:42", "Arg:50", "Arg:56", "Arg:44", "Arg:52", "Arg:38", "Arg:26", "Arg:14", "Trp:7", "Phe:14", "Tyr:14", "Trp:35", "Phe:7", "Phe:28", "Tyr:7", "Tyr:28", "Trp:37", "Phe:11", "Phe:26", "Tyr:11", "Tyr:26", "Trp:38", "Phe:13", "Phe:22", "Tyr:13", "Tyr:22", "Chor:28", "Chor:26", "Chor:22", "DAHP:28", "Trp:14", "DAHP:26", "Trp:13", "DAHP:22", "Trp:11", "Fru6P:46", "FruBP:53", "Fru6P:23", "Glc6P:51", "Fru6P:29", "Fru6P:57", "ICit:30", "ICit:27", "Glc6P:43", "Gnt6P:58", "Glc6P:15", "Glc6P:39", "Gnt6P:29", "ICit:23", "Gnt6P:51", "Gnt6P:60", "Gnt6P:43", "ICit:45", "Fru6P:30", "Gnt6P:15", "Gnt6P:57", "Glc6P:60", "Fru6P:53", "ICit:53", "ICit:60", "FruBP:23", "FruBP:46", "Gnt6P:54", "Suc:15", "Glc6P:57", "Fru6P:51", "Gnt6P:27", "FruBP:30", "FruBP:54", "ICit:57", "Glc6P:23", "FruBP:29", "FruBP:51", "ICit:46", "Glc6P:30", "Glc6P:53", "Fru6P:45", "Gnt6P:23", "ICit:51", "ICit:43", "Glc6P:27", "Fru6P:43", "Rib5P:15", "FruBP:15", "Fru6P:54", "Glc6P:46", "Rib5P:29", "FruBP:43", "Glc6P:45", "FruBP:27", "FruBP:45", "Fru6P:27", "Fru6P:58", "Glc6P:54", "ICit:54", "Gnt6P:53", "FruBP:57", "Fru6P:60", "Gnt6P:30", "Glc6P:58", "Gnt6P:45", "ICit:39", "Rib5P:27", "Glc6P:29", "Fru6P:39", "Rib5P:30", "ICit:58", "FruBP:60", "Gnt6P:39", "FruBP:58", "Rib5P:23", "Fru6P:15", "ICit:29", "FruBP:39", "ICit:15", "Gnt6P:46", "OAA:15", "Ery4P:15", "AKG:23", "AKG:27", "AKG:29", "AKG:15", "AKG:30", "Mal:15", "BM_Rib5P:15", "Sed7P:15", "BM_Rib5P:29", "Sed7P:29", "BM_Rib5P:27", "Sed7P:27", "BM_Rib5P:30", "Sed7P:30", "BM_Rib5P:23", "Sed7P:23", "BM_OAA:15", "BM_Ery4P:15", "BM_AKG:23", "BM_AKG:27", "BM_AKG:29", "BM_AKG:15", "BM_AKG:30", "Trp:1920", "His:60", "Trp:1472", "His:46", "Trp:1728", "His:54", "Trp:960", "His:30", "Trp:1856", "His:58", "Lys:60", "Thr:15", "Asn:15", "Met:30", "Asp:15", "DAHP:15", "Glu:23", "Glu:27", "Glu:29", "Glu:15", "Glu:30", "Ile:54", "Chor:15", "Arg:46", "Arg:54", "Arg:58", "Arg:30", "Arg:60", "Trp:39", "Phe:15", "Phe:30", "Tyr:15", "Tyr:30", "Chor:30", "DAHP:30", "Trp:15", "Fru6P:62", "Fru6P:47", "Glc6P:47", "FruBP:62", "Gnt6P:47", "Gnt6P:62", "Fru6P:31", "Rib5P:31", "FruBP:55", "Fru6P:55", "FruBP:47", "ICit:47", "Glc6P:62", "FruBP:61", "Gnt6P:61", "ICit:59", "ICit:55", "Gnt6P:31", "Fru6P:59", "FruBP:59", "ICit:61", "Glc6P:31", "Glc6P:61", "Gnt6P:55", "Fru6P:61", "FruBP:31", "Glc6P:55", "Gnt6P:59", "Glc6P:59", "ICit:31", "ICit:62", "AKG:31", "BM_Rib5P:31", "Sed7P:31", "BM_AKG:31", "Trp:1984", "His:62", "Glu:31", "Arg:62", "ICit:63", "FruBP:63", "Fru6P:63", "Glc6P:63", "Gnt6P:63")
nm_list$rcumo=nm_rcumo

if (case_i) {
   # check the coherence of metabolites/cumomers
   met_net=unique(matrix(unlist(strsplit(nm_rcumo, ":", fixed=TRUE)), nrow=2)[1,])
   net_pool=sort(setdiff(met_net, names(nm_poolall)))
   if (length(net_pool) > 0) {
      stop_mes("The following metabolites are internal in NETWORK section but not in METABOLITE_POOLS one:\n"%s+%paste(net_pool, collapse="\n"), file=fcerr)
   }
}

nb_exp=1
nm_exp=c("e_coli")
nm_list$nm_exp=nm_exp
# input cumomer vectors
xi=c(1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 1.0)
if (length(xi)) {
   dim(xi)=c(length(xi)/nb_exp, nb_exp)
} else {
   stop_mes("No reduced label entry is defined (may be because no measurement defined in FTBL). Cannot continue.", file=fcerr)
}
nm_xi=c("Gluc_U:63", "Gluc_1:63", "Gluc_U:47", "Gluc_1:47", "Gluc_U:62", "Gluc_1:62", "Gluc_U:31", "Gluc_1:31", "Gluc_U:61", "Gluc_1:61", "Gluc_U:55", "Gluc_1:55", "Gluc_U:59", "Gluc_1:59", "Gluc_U:51", "Gluc_1:51", "Gluc_U:43", "Gluc_1:43", "Gluc_U:15", "Gluc_1:15", "Gluc_U:39", "Gluc_1:39", "Gluc_U:60", "Gluc_1:60", "Gluc_U:57", "Gluc_1:57", "Gluc_U:23", "Gluc_1:23", "Gluc_U:30", "Gluc_1:30", "Gluc_U:53", "Gluc_1:53", "Gluc_U:27", "Gluc_1:27", "Gluc_U:46", "Gluc_1:46", "Gluc_U:45", "Gluc_1:45", "Gluc_U:54", "Gluc_1:54", "Gluc_U:58", "Gluc_1:58", "Gluc_U:29", "Gluc_1:29", "Gluc_U:11", "Gluc_1:11", "Gluc_U:28", "Gluc_1:28", "Gluc_U:56", "Gluc_1:56", "Gluc_U:35", "Gluc_1:35", "Gluc_U:14", "Gluc_1:14", "Gluc_U:21", "Gluc_1:21", "Gluc_U:19", "Gluc_1:19", "Gluc_U:26", "Gluc_1:26", "Gluc_U:42", "Gluc_1:42", "Gluc_U:44", "Gluc_1:44", "Gluc_U:22", "Gluc_1:22", "Gluc_U:13", "Gluc_1:13", "Gluc_U:52", "Gluc_1:52", "Gluc_U:37", "Gluc_1:37", "Gluc_U:38", "Gluc_1:38", "Gluc_U:50", "Gluc_1:50", "Gluc_U:7", "Gluc_1:7", "Gluc_U:25", "Gluc_1:25", "Gluc_U:41", "Gluc_1:41", "Gluc_U:49", "Gluc_1:49", "Gluc_U:10", "Gluc_1:10", "Gluc_U:33", "Gluc_1:33", "Gluc_U:17", "Gluc_1:17", "Gluc_U:34", "Gluc_1:34", "Gluc_U:40", "Gluc_1:40", "Gluc_U:36", "Gluc_1:36", "Gluc_U:20", "Gluc_1:20", "Gluc_U:5", "Gluc_1:5", "Gluc_U:3", "Gluc_1:3", "Gluc_U:9", "Gluc_1:9", "Gluc_U:18", "Gluc_1:18", "Gluc_U:48", "Gluc_1:48", "Gluc_U:24", "Gluc_1:24", "Gluc_U:12", "Gluc_1:12", "Gluc_U:6", "Gluc_1:6", "Gluc_U:4", "Gluc_1:4", "Gluc_U:16", "Gluc_1:16", "Gluc_U:1", "Gluc_1:1", "Gluc_U:8", "Gluc_1:8", "Gluc_U:2", "Gluc_1:2", "Gluc_U:32", "Gluc_1:32")
dimnames(xi)[[1]]=nm_xi
nm_list$xi=nm_xi
nb_xi=length(nm_xi)
nb_f$xi=nb_xi
nb_cumoi=nb_xi
nm_inp=nm_xi
nm_incu=c("one", nm_xi, nm_rcumo)
nm_inlab=nm_incu
spa=spAbr
nm_x=nm_rcumo
nb_x=nb_rcumos
nb_f$rcumos=nb_rcumos
nb_f$cumoi=nb_cumoi
if (emu) {
   nm_emu=c()
   nb_emus=nb_rcumos*(seq_len(nb_rw)+1)
   nb_f$emus=nb_emus
   nm_list$emu=nm_emu
   nm_x=nm_emu
   nb_x=nb_emus
   xiemu=matrix(c(), ncol=nb_exp)
   nm_xiemu=c()
   nm_list$xiemu=nm_xiemu
   dimnames(xiemu)[[1]]=nm_xiemu
   nb_xiemu=length(nm_xiemu)
   nb_f$xiemu=nb_xiemu
   nb_f$xi=nb_xiemu
   nb_xi=nb_xiemu
   nm_inp=nm_xiemu
   xi=xiemu
   nm_inemu=c("one", nm_xiemu, nm_emu)
   nm_inlab=nm_inemu
   spa=spr2emu(spAbr, nm_incu, nm_inemu, nb_f)
}
# reorder indexes to accelerate sparse matrix construction
spa=sparse2spa(spa)
#browser()
# composite labeling vector incu c(1, xi, xc) names
nm_inlab=c("one", nm_inp, nm_x); # the constant 1 has name "one"
nm_list$x=nm_x
nm_list$inp=nm_inp
nb_f$x=nb_x
nm_cumo=NULL

if (TIMEIT) {
   cat("measure : ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}
if (!noscale) {
   # make place for scaling factors
   nb_sc=vector("integer", 1)
# experiment: 1

   # mass
   # initial values for scales are set later
   param=c(param,0, 0, 0, 0, 0, 0, 0, 0, 0)
   nm_par=c(nm_par,c("1:mass;Fru6P;111111;686", "1:mass;FruBP;111111;672", "1:mass;Glc6P;111111;679", "1:mass;Gnt6P;111111;699", "1:mass;ICit;111111;657", "1:mass;PEP;111;664", "1:mass;PGA;111;668", "1:mass;Rib5P;11111;693", "1:mass;Suc;1111;648"))
   names(param)=nm_par

   nb_param=length(param)
   nb_sc[1]=nb_param-nb_ff # at this moment it is cumulated sum. diff() is taken later

   # indices mapping from scaling to measure matrix row
   # c(1,par)[ir2isc[[iexp]]] replicates scale parameters
   # for corresponding rows of measure matrix
   ir2isc=vector("list", 1)

   # 1:mass
   ir2isc[[1]]=c(ir2isc[[1]],c(22, 22, 22, 22, 18, 18, 18, 18, 18, 18, 18, 19, 19, 19, 19, 20, 20, 20, 20, 15, 15, 15, 15, 15, 15, 15, 16, 16, 16, 16, 16, 16, 16, 14, 14, 14, 14, 14, 14, 14, 21, 21, 21, 21, 21, 21, 17, 17, 17, 17, 17, 17, 17))

   # cumulated base for nb_sc
   nb_sc_base=c(0, nb_sc[-nb_exp])
   nb_sc=diff(c(0, nb_sc))
   nb_sc_tot=sum(nb_sc)
   nb_f$nb_sc=nb_sc
   nb_f$nb_sc_tot=nb_sc_tot
   nb_f$nb_sc_base=nb_sc_base
#browser()
} else {
   # no scaling
   ir2isc=list()
   nb_sc=integer(nb_exp)
   nb_sc_tot=0
}
nb_f$nb_sc=nb_sc
nb_f$nb_sc_tot=nb_sc_tot
nm_list$par=nm_par

# make a list of sparse measurement matrices
# measmat*xr+memaone gives a vector of simulated not-yet-pooled and not-yet-scaled measurements
# all but 0. Coefficients of 0-cumomers (by defenition equal to 1)
# are all regrouped in the memaone.
nm_measmat=nm_meas=nb_meas=nb_measmat=measmat=memaone=measvec=measdev=ipooled=vector("list", 1)

nm_measmat[[1]]=c("m:Suc:1,2,3,4:1:648", "m:Suc:1,2,3,4:2:649", "m:Suc:1,2,3,4:3:650", "m:Suc:1,2,3,4:4:651", "m:ICit:1,2,3,4,5,6:0:657", "m:ICit:1,2,3,4,5,6:1:658", "m:ICit:1,2,3,4,5,6:2:659", "m:ICit:1,2,3,4,5,6:3:660", "m:ICit:1,2,3,4,5,6:4:661", "m:ICit:1,2,3,4,5,6:5:662", "m:ICit:1,2,3,4,5,6:6:663", "m:PEP:1,2,3:0:664", "m:PEP:1,2,3:1:665", "m:PEP:1,2,3:2:666", "m:PEP:1,2,3:3:667", "m:PGA:1,2,3:0:668", "m:PGA:1,2,3:1:669", "m:PGA:1,2,3:2:670", "m:PGA:1,2,3:3:671", "m:FruBP:1,2,3,4,5,6:0:672", "m:FruBP:1,2,3,4,5,6:1:673", "m:FruBP:1,2,3,4,5,6:2:674", "m:FruBP:1,2,3,4,5,6:3:675", "m:FruBP:1,2,3,4,5,6:4:676", "m:FruBP:1,2,3,4,5,6:5:677", "m:FruBP:1,2,3,4,5,6:6:678", "m:Glc6P:1,2,3,4,5,6:0:679", "m:Glc6P:1,2,3,4,5,6:1:680", "m:Glc6P:1,2,3,4,5,6:2:681", "m:Glc6P:1,2,3,4,5,6:3:682", "m:Glc6P:1,2,3,4,5,6:4:683", "m:Glc6P:1,2,3,4,5,6:5:684", "m:Glc6P:1,2,3,4,5,6:6:685", "m:Fru6P:1,2,3,4,5,6:0:686", "m:Fru6P:1,2,3,4,5,6:1:687", "m:Fru6P:1,2,3,4,5,6:2:688", "m:Fru6P:1,2,3,4,5,6:3:689", "m:Fru6P:1,2,3,4,5,6:4:690", "m:Fru6P:1,2,3,4,5,6:5:691", "m:Fru6P:1,2,3,4,5,6:6:692", "m:Rib5P:1,2,3,4,5:0:693", "m:Rib5P:1,2,3,4,5:1:694", "m:Rib5P:1,2,3,4,5:2:695", "m:Rib5P:1,2,3,4,5:3:696", "m:Rib5P:1,2,3,4,5:4:697", "m:Rib5P:1,2,3,4,5:5:698", "m:Gnt6P:1,2,3,4,5,6:0:699", "m:Gnt6P:1,2,3,4,5,6:1:700", "m:Gnt6P:1,2,3,4,5,6:2:701", "m:Gnt6P:1,2,3,4,5,6:3:702", "m:Gnt6P:1,2,3,4,5,6:4:703", "m:Gnt6P:1,2,3,4,5,6:5:704", "m:Gnt6P:1,2,3,4,5,6:6:705")
nm_meas[[1]]=c("m:Suc:1,2,3,4:1:648", "m:Suc:1,2,3,4:2:649", "m:Suc:1,2,3,4:3:650", "m:Suc:1,2,3,4:4:651", "m:ICit:1,2,3,4,5,6:0:657", "m:ICit:1,2,3,4,5,6:1:658", "m:ICit:1,2,3,4,5,6:2:659", "m:ICit:1,2,3,4,5,6:3:660", "m:ICit:1,2,3,4,5,6:4:661", "m:ICit:1,2,3,4,5,6:5:662", "m:ICit:1,2,3,4,5,6:6:663", "m:PEP:1,2,3:0:664", "m:PEP:1,2,3:1:665", "m:PEP:1,2,3:2:666", "m:PEP:1,2,3:3:667", "m:PGA:1,2,3:0:668", "m:PGA:1,2,3:1:669", "m:PGA:1,2,3:2:670", "m:PGA:1,2,3:3:671", "m:FruBP:1,2,3,4,5,6:0:672", "m:FruBP:1,2,3,4,5,6:1:673", "m:FruBP:1,2,3,4,5,6:2:674", "m:FruBP:1,2,3,4,5,6:3:675", "m:FruBP:1,2,3,4,5,6:4:676", "m:FruBP:1,2,3,4,5,6:5:677", "m:FruBP:1,2,3,4,5,6:6:678", "m:Glc6P:1,2,3,4,5,6:0:679", "m:Glc6P:1,2,3,4,5,6:1:680", "m:Glc6P:1,2,3,4,5,6:2:681", "m:Glc6P:1,2,3,4,5,6:3:682", "m:Glc6P:1,2,3,4,5,6:4:683", "m:Glc6P:1,2,3,4,5,6:5:684", "m:Glc6P:1,2,3,4,5,6:6:685", "m:Fru6P:1,2,3,4,5,6:0:686", "m:Fru6P:1,2,3,4,5,6:1:687", "m:Fru6P:1,2,3,4,5,6:2:688", "m:Fru6P:1,2,3,4,5,6:3:689", "m:Fru6P:1,2,3,4,5,6:4:690", "m:Fru6P:1,2,3,4,5,6:5:691", "m:Fru6P:1,2,3,4,5,6:6:692", "m:Rib5P:1,2,3,4,5:0:693", "m:Rib5P:1,2,3,4,5:1:694", "m:Rib5P:1,2,3,4,5:2:695", "m:Rib5P:1,2,3,4,5:3:696", "m:Rib5P:1,2,3,4,5:4:697", "m:Rib5P:1,2,3,4,5:5:698", "m:Gnt6P:1,2,3,4,5,6:0:699", "m:Gnt6P:1,2,3,4,5,6:1:700", "m:Gnt6P:1,2,3,4,5,6:2:701", "m:Gnt6P:1,2,3,4,5,6:3:702", "m:Gnt6P:1,2,3,4,5,6:4:703", "m:Gnt6P:1,2,3,4,5,6:5:704", "m:Gnt6P:1,2,3,4,5,6:6:705")
nb_meas[[1]]=length(nm_meas[[1]])
nb_measmat[[1]]=length(nm_measmat[[1]])
measmat[[1]]=simple_triplet_zero_matrix(nrow=nb_measmat[[1]], ncol=1069)
dimnames(measmat[[1]])=list(nm_measmat[[1]], nm_x)
memaone[[1]]=numeric(nb_measmat[[1]])
measvec[[1]]=c(0.371605319, 0.360829749, 0.208425325, 0.059139607, 0.131864539419667, 0.225857638569, 0.256421170949333, 0.209230210478667, 0.116863585449667, 0.0457727744643333, 0.0139900806697867, 0.421359839367667, 0.358998301162333, 0.0348521859365667, 0.184789673534, 0.434335785072667, 0.352829683224667, 0.0323479804176, 0.180486551285333, 0.0738121029259333, 0.454450017158667, 0.160823529969333, 0.0944468077710667, 0.105281338489667, 0.0155016033633, 0.0956846003217333, 0.0160587173349, 0.673510772480667, 0.0930110047641, 0.0280359937297, 0.0397315614067667, 0.0145524520950667, 0.135099498189, 0.0235029951295, 0.624253565357667, 0.113068441282333, 0.0456605631765, 0.0516089447155667, 0.0185881765378333, 0.123317313800333, 0.341615670498667, 0.25454117519, 0.159027180368333, 0.113789577528667, 0.0615266612553333, 0.0694997351590667, 0.0249552273874, 0.672556163913, 0.0866890773125333, 0.0313987199704333, 0.0314691889898667, 0.0138168327362333, 0.139114789690333)
measdev[[1]]=c(0.01, 0.01, 0.01, 0.01, 0.02, 0.02, 0.02, 0.02, 0.02, 0.02, 0.02, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01)
names(measvec[[1]])=nm_meas[[1]]
names(measdev[[1]])=nm_meas[[1]]
ipooled[[1]]=list(ishort=pmatch(nm_meas[[1]], nm_measmat[[1]]))

nm_meas_tot=unlist(nm_meas)
nb_meas=unlist(nb_meas)
nb_meas_cumo=c(0., cumsum(nb_meas[-nb_exp]))
iexp_meas=lapply(seq_len(nb_exp), function(iexp) seq_len(nb_meas[iexp])+nb_meas_cumo[iexp])
nm_list$meas=nm_meas
nm_list$measmat=nm_measmat
nm_list$meas_tot=nm_meas_tot
nb_f$nb_meas=nb_meas

names(measvec)=names(measdev)=nm_exp

if (!noscale) {
   for (iexp in seq_len(nb_exp))
      ir2isc[[iexp]]=ir2isc[[iexp]][ipooled[[iexp]]$ishort]

   # prepare indexes of dispatching scale params in jacobian
   if (nb_sc_tot > 0) {
      nb_f$is2m=vector("list", nb_exp)
      for (iexp in seq_len(nb_exp)) {
         ipaire=matrix(0, nrow=0, ncol=2)
         tmp=lapply(seq_len(nb_sc[[iexp]]), function(isc) {
            i=which(ir2isc[[iexp]]==isc+nb_sc_base[iexp]+1+nb_ff)
            ipaire <<- rbind(ipaire, cbind(i, isc+nb_sc_base[iexp]))
            return(NULL)
         })
         nb_f$is2m[[iexp]]=ipaire
         # place holder for scale part of jacobian
         jx_f$dr_dsc[[iexp]]=simple_triplet_zero_matrix(nrow=length(ir2isc[[iexp]]), ncol=nb_sc_tot)
      }
   }
}
# prepare measmat indexes and values : ir, ic, val

ind_mema=matrix(c(
1, 17, 1, 1, 608, 3, 1, 680, 3, 1, 635, 3, 1, 286, -2, 1, 258, -2, 1, 289, -2, 1, 912, -4, 1, 29, 1, 1, 660, 3, 1, 298, -2, 1, 248, -2, 1, 37, 1, 1, 277, -2, 1, 41, 1,
2, 286, 1, 2, 912, 6, 2, 608, -3, 2, 680, -3, 2, 258, 1, 2, 635, -3, 2, 298, 1, 2, 660, -3, 2, 289, 1, 2, 248, 1, 2, 277, 1,
3, 608, 1, 3, 912, -4, 3, 680, 1, 3, 635, 1, 3, 660, 1,
4, 912, 1,
5, 318, 1, 5, 273, 1, 5, 322, 1, 5, 256, 1, 5, 259, 1, 5, 271, 1, 5, 963, 1, 5, 237, 1, 5, 235, 1, 5, 321, 1, 5, 897, 1, 5, 327, 1, 5, 891, 1, 5, 961, 1, 5, 890, 1, 5, 234, 1, 5, 301, 1, 5, 288, 1, 5, 950, 1, 5, 264, 1, 5, 928, 1, 5, 901, 1, 5, 922, 1, 5, 280, 1, 5, 927, 1, 5, 907, 1, 5, 943, 1, 5, 918, 1, 5, 955, 1, 5, 908, 1, 5, 1065, 1, 5, 14, -1, 5, 38, -1, 5, 18, -1, 5, 663, -1, 5, 40, -1, 5, 686, -1, 5, 703, -1, 5, 676, -1, 5, 26, -1, 5, 619, -1, 5, 628, -1, 5, 601, -1, 5, 654, -1, 5, 624, -1, 5, 695, -1, 5, 1055, -1, 5, 2, -1, 5, 674, -1, 5, 645, -1, 5, 659, -1, 5, 609, -1, 5, 618, -1, 5, 623, -1, 5, 1037, -1, 5, 671, -1, 5, 662, -1, 5, 683, -1, 5, 1042, -1, 5, 655, -1, 5, 1041, -1, 5, 1046, -1, 5, 1056, -1,
6, 14, 1, 6, 663, 3, 6, 686, 3, 6, 703, 3, 6, 619, 3, 6, 628, 3, 6, 654, 3, 6, 1055, 5, 6, 674, 3, 6, 645, 3, 6, 609, 3, 6, 1037, 5, 6, 671, 3, 6, 1042, 5, 6, 1041, 5, 6, 1046, 5, 6, 318, -2, 6, 273, -2, 6, 256, -2, 6, 963, -4, 6, 237, -2, 6, 897, -4, 6, 891, -4, 6, 961, -4, 6, 234, -2, 6, 950, -4, 6, 928, -4, 6, 901, -4, 6, 927, -4, 6, 907, -4, 6, 918, -4, 6, 1065, -6, 6, 38, 1, 6, 676, 3, 6, 601, 3, 6, 624, 3, 6, 659, 3, 6, 618, 3, 6, 662, 3, 6, 1056, 5, 6, 322, -2, 6, 259, -2, 6, 235, -2, 6, 890, -4, 6, 301, -2, 6, 922, -4, 6, 943, -4, 6, 955, -4, 6, 18, 1, 6, 695, 3, 6, 623, 3, 6, 683, 3, 6, 271, -2, 6, 321, -2, 6, 288, -2, 6, 908, -4, 6, 40, 1, 6, 655, 3, 6, 327, -2, 6, 264, -2, 6, 26, 1, 6, 280, -2, 6, 2, 1,
7, 318, 1, 7, 963, 6, 7, 897, 6, 7, 891, 6, 7, 950, 6, 7, 928, 6, 7, 927, 6, 7, 1065, 15, 7, 663, -3, 7, 686, -3, 7, 619, -3, 7, 1055, -10, 7, 674, -3, 7, 1037, -10, 7, 1042, -10, 7, 1041, -10, 7, 273, 1, 7, 961, 6, 7, 901, 6, 7, 907, 6, 7, 703, -3, 7, 628, -3, 7, 645, -3, 7, 1046, -10, 7, 322, 1, 7, 890, 6, 7, 922, 6, 7, 943, 6, 7, 676, -3, 7, 601, -3, 7, 659, -3, 7, 1056, -10, 7, 256, 1, 7, 918, 6, 7, 654, -3, 7, 609, -3, 7, 259, 1, 7, 955, 6, 7, 624, -3, 7, 618, -3, 7, 271, 1, 7, 908, 6, 7, 695, -3, 7, 623, -3, 7, 237, 1, 7, 671, -3, 7, 235, 1, 7, 662, -3, 7, 321, 1, 7, 683, -3, 7, 327, 1, 7, 655, -3, 7, 234, 1, 7, 301, 1, 7, 288, 1, 7, 264, 1, 7, 280, 1,
8, 663, 1, 8, 1055, 10, 8, 1037, 10, 8, 1042, 10, 8, 963, -4, 8, 897, -4, 8, 950, -4, 8, 1065, -20, 8, 686, 1, 8, 1041, 10, 8, 891, -4, 8, 928, -4, 8, 703, 1, 8, 1046, 10, 8, 961, -4, 8, 901, -4, 8, 676, 1, 8, 1056, 10, 8, 890, -4, 8, 922, -4, 8, 619, 1, 8, 927, -4, 8, 628, 1, 8, 907, -4, 8, 601, 1, 8, 943, -4, 8, 654, 1, 8, 918, -4, 8, 624, 1, 8, 955, -4, 8, 695, 1, 8, 908, -4, 8, 674, 1, 8, 645, 1, 8, 659, 1, 8, 609, 1, 8, 618, 1, 8, 623, 1, 8, 671, 1, 8, 662, 1, 8, 683, 1, 8, 655, 1,
9, 963, 1, 9, 1065, 15, 9, 1055, -5, 9, 1037, -5, 9, 897, 1, 9, 1042, -5, 9, 891, 1, 9, 1041, -5, 9, 961, 1, 9, 1046, -5, 9, 890, 1, 9, 1056, -5, 9, 950, 1, 9, 928, 1, 9, 901, 1, 9, 922, 1, 9, 927, 1, 9, 907, 1, 9, 943, 1, 9, 918, 1, 9, 955, 1, 9, 908, 1,
10, 1055, 1, 10, 1065, -6, 10, 1037, 1, 10, 1042, 1, 10, 1041, 1, 10, 1046, 1, 10, 1056, 1,
11, 1065, 1,
12, 323, 1, 12, 304, 1, 12, 306, 1, 12, 44, -1, 12, 20, -1, 12, 12, -1, 12, 701, -1,
13, 44, 1, 13, 701, 3, 13, 323, -2, 13, 304, -2, 13, 20, 1, 13, 306, -2, 13, 12, 1,
14, 323, 1, 14, 701, -3, 14, 304, 1, 14, 306, 1,
15, 701, 1,
16, 310, 1, 16, 257, 1, 16, 236, 1, 16, 42, -1, 16, 27, -1, 16, 30, -1, 16, 706, -1,
17, 42, 1, 17, 706, 3, 17, 310, -2, 17, 257, -2, 17, 27, 1, 17, 236, -2, 17, 30, 1,
18, 310, 1, 18, 706, -3, 18, 257, 1, 18, 236, 1,
19, 706, 1,
20, 283, 1, 20, 246, 1, 20, 247, 1, 20, 324, 1, 20, 267, 1, 20, 320, 1, 20, 932, 1, 20, 309, 1, 20, 249, 1, 20, 297, 1, 20, 909, 1, 20, 308, 1, 20, 938, 1, 20, 920, 1, 20, 916, 1, 20, 325, 1, 20, 300, 1, 20, 295, 1, 20, 962, 1, 20, 281, 1, 20, 936, 1, 20, 939, 1, 20, 910, 1, 20, 269, 1, 20, 921, 1, 20, 885, 1, 20, 917, 1, 20, 945, 1, 20, 958, 1, 20, 956, 1, 20, 1066, 1, 20, 22, -1, 20, 11, -1, 20, 34, -1, 20, 616, -1, 20, 6, -1, 20, 612, -1, 20, 705, -1, 20, 597, -1, 20, 45, -1, 20, 630, -1, 20, 593, -1, 20, 640, -1, 20, 629, -1, 20, 607, -1, 20, 636, -1, 20, 1051, -1, 20, 39, -1, 20, 697, -1, 20, 610, -1, 20, 665, -1, 20, 594, -1, 20, 606, -1, 20, 656, -1, 20, 1036, -1, 20, 614, -1, 20, 646, -1, 20, 598, -1, 20, 1034, -1, 20, 595, -1, 20, 1045, -1, 20, 1039, -1, 20, 1029, -1,
21, 22, 1, 21, 616, 3, 21, 612, 3, 21, 705, 3, 21, 630, 3, 21, 593, 3, 21, 629, 3, 21, 1051, 5, 21, 697, 3, 21, 610, 3, 21, 594, 3, 21, 1036, 5, 21, 614, 3, 21, 1034, 5, 21, 1045, 5, 21, 1039, 5, 21, 283, -2, 21, 246, -2, 21, 324, -2, 21, 932, -4, 21, 309, -2, 21, 909, -4, 21, 938, -4, 21, 920, -4, 21, 325, -2, 21, 962, -4, 21, 936, -4, 21, 939, -4, 21, 921, -4, 21, 885, -4, 21, 945, -4, 21, 1066, -6, 21, 11, 1, 21, 597, 3, 21, 640, 3, 21, 607, 3, 21, 665, 3, 21, 606, 3, 21, 646, 3, 21, 1029, 5, 21, 247, -2, 21, 267, -2, 21, 249, -2, 21, 916, -4, 21, 300, -2, 21, 910, -4, 21, 917, -4, 21, 958, -4, 21, 34, 1, 21, 636, 3, 21, 656, 3, 21, 598, 3, 21, 320, -2, 21, 297, -2, 21, 295, -2, 21, 956, -4, 21, 6, 1, 21, 595, 3, 21, 308, -2, 21, 281, -2, 21, 45, 1, 21, 269, -2, 21, 39, 1,
22, 283, 1, 22, 932, 6, 22, 909, 6, 22, 938, 6, 22, 962, 6, 22, 936, 6, 22, 921, 6, 22, 1066, 15, 22, 616, -3, 22, 612, -3, 22, 630, -3, 22, 1051, -10, 22, 697, -3, 22, 1036, -10, 22, 1034, -10, 22, 1045, -10, 22, 246, 1, 22, 920, 6, 22, 939, 6, 22, 885, 6, 22, 705, -3, 22, 593, -3, 22, 610, -3, 22, 1039, -10, 22, 247, 1, 22, 916, 6, 22, 910, 6, 22, 917, 6, 22, 597, -3, 22, 640, -3, 22, 665, -3, 22, 1029, -10, 22, 324, 1, 22, 945, 6, 22, 629, -3, 22, 594, -3, 22, 267, 1, 22, 958, 6, 22, 607, -3, 22, 606, -3, 22, 320, 1, 22, 956, 6, 22, 636, -3, 22, 656, -3, 22, 309, 1, 22, 614, -3, 22, 249, 1, 22, 646, -3, 22, 297, 1, 22, 598, -3, 22, 308, 1, 22, 595, -3, 22, 325, 1, 22, 300, 1, 22, 295, 1, 22, 281, 1, 22, 269, 1,
23, 616, 1, 23, 1051, 10, 23, 1036, 10, 23, 1034, 10, 23, 932, -4, 23, 909, -4, 23, 962, -4, 23, 1066, -20, 23, 612, 1, 23, 1045, 10, 23, 938, -4, 23, 936, -4, 23, 705, 1, 23, 1039, 10, 23, 920, -4, 23, 939, -4, 23, 597, 1, 23, 1029, 10, 23, 916, -4, 23, 910, -4, 23, 630, 1, 23, 921, -4, 23, 593, 1, 23, 885, -4, 23, 640, 1, 23, 917, -4, 23, 629, 1, 23, 945, -4, 23, 607, 1, 23, 958, -4, 23, 636, 1, 23, 956, -4, 23, 697, 1, 23, 610, 1, 23, 665, 1, 23, 594, 1, 23, 606, 1, 23, 656, 1, 23, 614, 1, 23, 646, 1, 23, 598, 1, 23, 595, 1,
24, 932, 1, 24, 1066, 15, 24, 1051, -5, 24, 1036, -5, 24, 909, 1, 24, 1034, -5, 24, 938, 1, 24, 1045, -5, 24, 920, 1, 24, 1039, -5, 24, 916, 1, 24, 1029, -5, 24, 962, 1, 24, 936, 1, 24, 939, 1, 24, 910, 1, 24, 921, 1, 24, 885, 1, 24, 917, 1, 24, 945, 1, 24, 958, 1, 24, 956, 1,
25, 1051, 1, 25, 1066, -6, 25, 1036, 1, 25, 1034, 1, 25, 1045, 1, 25, 1039, 1, 25, 1029, 1,
26, 1066, 1,
27, 284, 1, 27, 276, 1, 27, 315, 1, 27, 290, 1, 27, 242, 1, 27, 314, 1, 27, 894, 1, 27, 260, 1, 27, 292, 1, 27, 274, 1, 27, 919, 1, 27, 299, 1, 27, 929, 1, 27, 952, 1, 27, 923, 1, 27, 252, 1, 27, 265, 1, 27, 272, 1, 27, 895, 1, 27, 270, 1, 27, 892, 1, 27, 937, 1, 27, 934, 1, 27, 293, 1, 27, 887, 1, 27, 924, 1, 27, 942, 1, 27, 913, 1, 27, 948, 1, 27, 905, 1, 27, 1068, 1, 27, 15, -1, 27, 24, -1, 27, 8, -1, 27, 684, -1, 27, 19, -1, 27, 596, -1, 27, 668, -1, 27, 639, -1, 27, 13, -1, 27, 643, -1, 27, 641, -1, 27, 666, -1, 27, 688, -1, 27, 652, -1, 27, 620, -1, 27, 1047, -1, 27, 35, -1, 27, 633, -1, 27, 673, -1, 27, 677, -1, 27, 691, -1, 27, 653, -1, 27, 657, -1, 27, 1028, -1, 27, 699, -1, 27, 678, -1, 27, 672, -1, 27, 1052, -1, 27, 631, -1, 27, 1054, -1, 27, 1048, -1, 27, 1038, -1,
28, 15, 1, 28, 684, 3, 28, 596, 3, 28, 668, 3, 28, 643, 3, 28, 641, 3, 28, 688, 3, 28, 1047, 5, 28, 633, 3, 28, 673, 3, 28, 691, 3, 28, 1028, 5, 28, 699, 3, 28, 1052, 5, 28, 1054, 5, 28, 1048, 5, 28, 284, -2, 28, 276, -2, 28, 290, -2, 28, 894, -4, 28, 260, -2, 28, 919, -4, 28, 929, -4, 28, 952, -4, 28, 252, -2, 28, 895, -4, 28, 892, -4, 28, 937, -4, 28, 887, -4, 28, 924, -4, 28, 913, -4, 28, 1068, -6, 28, 24, 1, 28, 639, 3, 28, 666, 3, 28, 652, 3, 28, 677, 3, 28, 653, 3, 28, 678, 3, 28, 1038, 5, 28, 315, -2, 28, 242, -2, 28, 292, -2, 28, 923, -4, 28, 265, -2, 28, 934, -4, 28, 942, -4, 28, 948, -4, 28, 8, 1, 28, 620, 3, 28, 657, 3, 28, 672, 3, 28, 314, -2, 28, 274, -2, 28, 272, -2, 28, 905, -4, 28, 19, 1, 28, 631, 3, 28, 299, -2, 28, 270, -2, 28, 13, 1, 28, 293, -2, 28, 35, 1,
29, 284, 1, 29, 894, 6, 29, 919, 6, 29, 929, 6, 29, 895, 6, 29, 892, 6, 29, 887, 6, 29, 1068, 15, 29, 684, -3, 29, 596, -3, 29, 643, -3, 29, 1047, -10, 29, 633, -3, 29, 1028, -10, 29, 1052, -10, 29, 1054, -10, 29, 276, 1, 29, 952, 6, 29, 937, 6, 29, 924, 6, 29, 668, -3, 29, 641, -3, 29, 673, -3, 29, 1048, -10, 29, 315, 1, 29, 923, 6, 29, 934, 6, 29, 942, 6, 29, 639, -3, 29, 666, -3, 29, 677, -3, 29, 1038, -10, 29, 290, 1, 29, 913, 6, 29, 688, -3, 29, 691, -3, 29, 242, 1, 29, 948, 6, 29, 652, -3, 29, 653, -3, 29, 314, 1, 29, 905, 6, 29, 620, -3, 29, 657, -3, 29, 260, 1, 29, 699, -3, 29, 292, 1, 29, 678, -3, 29, 274, 1, 29, 672, -3, 29, 299, 1, 29, 631, -3, 29, 252, 1, 29, 265, 1, 29, 272, 1, 29, 270, 1, 29, 293, 1,
30, 684, 1, 30, 1047, 10, 30, 1028, 10, 30, 1052, 10, 30, 894, -4, 30, 919, -4, 30, 895, -4, 30, 1068, -20, 30, 596, 1, 30, 1054, 10, 30, 929, -4, 30, 892, -4, 30, 668, 1, 30, 1048, 10, 30, 952, -4, 30, 937, -4, 30, 639, 1, 30, 1038, 10, 30, 923, -4, 30, 934, -4, 30, 643, 1, 30, 887, -4, 30, 641, 1, 30, 924, -4, 30, 666, 1, 30, 942, -4, 30, 688, 1, 30, 913, -4, 30, 652, 1, 30, 948, -4, 30, 620, 1, 30, 905, -4, 30, 633, 1, 30, 673, 1, 30, 677, 1, 30, 691, 1, 30, 653, 1, 30, 657, 1, 30, 699, 1, 30, 678, 1, 30, 672, 1, 30, 631, 1,
31, 894, 1, 31, 1068, 15, 31, 1047, -5, 31, 1028, -5, 31, 919, 1, 31, 1052, -5, 31, 929, 1, 31, 1054, -5, 31, 952, 1, 31, 1048, -5, 31, 923, 1, 31, 1038, -5, 31, 895, 1, 31, 892, 1, 31, 937, 1, 31, 934, 1, 31, 887, 1, 31, 924, 1, 31, 942, 1, 31, 913, 1, 31, 948, 1, 31, 905, 1,
32, 1047, 1, 32, 1068, -6, 32, 1028, 1, 32, 1052, 1, 32, 1054, 1, 32, 1048, 1, 32, 1038, 1,
33, 1068, 1,
34, 239, 1, 34, 278, 1, 34, 238, 1, 34, 263, 1, 34, 279, 1, 34, 312, 1, 34, 960, 1, 34, 266, 1, 34, 307, 1, 34, 253, 1, 34, 886, 1, 34, 282, 1, 34, 940, 1, 34, 888, 1, 34, 902, 1, 34, 296, 1, 34, 250, 1, 34, 245, 1, 34, 953, 1, 34, 262, 1, 34, 930, 1, 34, 925, 1, 34, 884, 1, 34, 294, 1, 34, 914, 1, 34, 906, 1, 34, 933, 1, 34, 889, 1, 34, 941, 1, 34, 946, 1, 34, 1067, 1, 34, 1, -1, 34, 5, -1, 34, 4, -1, 34, 689, -1, 34, 33, -1, 34, 617, -1, 34, 675, -1, 34, 638, -1, 34, 28, -1, 34, 591, -1, 34, 692, -1, 34, 604, -1, 34, 679, -1, 34, 642, -1, 34, 627, -1, 34, 1032, -1, 34, 9, -1, 34, 602, -1, 34, 694, -1, 34, 611, -1, 34, 613, -1, 34, 632, -1, 34, 615, -1, 34, 1027, -1, 34, 690, -1, 34, 682, -1, 34, 669, -1, 34, 1035, -1, 34, 681, -1, 34, 1044, -1, 34, 1050, -1, 34, 1026, -1,
35, 1, 1, 35, 689, 3, 35, 617, 3, 35, 675, 3, 35, 591, 3, 35, 692, 3, 35, 679, 3, 35, 1032, 5, 35, 602, 3, 35, 694, 3, 35, 613, 3, 35, 1027, 5, 35, 690, 3, 35, 1035, 5, 35, 1044, 5, 35, 1050, 5, 35, 239, -2, 35, 278, -2, 35, 263, -2, 35, 960, -4, 35, 266, -2, 35, 886, -4, 35, 940, -4, 35, 888, -4, 35, 296, -2, 35, 953, -4, 35, 930, -4, 35, 925, -4, 35, 914, -4, 35, 906, -4, 35, 889, -4, 35, 1067, -6, 35, 5, 1, 35, 638, 3, 35, 604, 3, 35, 642, 3, 35, 611, 3, 35, 632, 3, 35, 682, 3, 35, 1026, 5, 35, 238, -2, 35, 279, -2, 35, 307, -2, 35, 902, -4, 35, 250, -2, 35, 884, -4, 35, 933, -4, 35, 941, -4, 35, 4, 1, 35, 627, 3, 35, 615, 3, 35, 669, 3, 35, 312, -2, 35, 253, -2, 35, 245, -2, 35, 946, -4, 35, 33, 1, 35, 681, 3, 35, 282, -2, 35, 262, -2, 35, 28, 1, 35, 294, -2, 35, 9, 1,
36, 239, 1, 36, 960, 6, 36, 886, 6, 36, 940, 6, 36, 953, 6, 36, 930, 6, 36, 914, 6, 36, 1067, 15, 36, 689, -3, 36, 617, -3, 36, 591, -3, 36, 1032, -10, 36, 602, -3, 36, 1027, -10, 36, 1035, -10, 36, 1044, -10, 36, 278, 1, 36, 888, 6, 36, 925, 6, 36, 906, 6, 36, 675, -3, 36, 692, -3, 36, 694, -3, 36, 1050, -10, 36, 238, 1, 36, 902, 6, 36, 884, 6, 36, 933, 6, 36, 638, -3, 36, 604, -3, 36, 611, -3, 36, 1026, -10, 36, 263, 1, 36, 889, 6, 36, 679, -3, 36, 613, -3, 36, 279, 1, 36, 941, 6, 36, 642, -3, 36, 632, -3, 36, 312, 1, 36, 946, 6, 36, 627, -3, 36, 615, -3, 36, 266, 1, 36, 690, -3, 36, 307, 1, 36, 682, -3, 36, 253, 1, 36, 669, -3, 36, 282, 1, 36, 681, -3, 36, 296, 1, 36, 250, 1, 36, 245, 1, 36, 262, 1, 36, 294, 1,
37, 689, 1, 37, 1032, 10, 37, 1027, 10, 37, 1035, 10, 37, 960, -4, 37, 886, -4, 37, 953, -4, 37, 1067, -20, 37, 617, 1, 37, 1044, 10, 37, 940, -4, 37, 930, -4, 37, 675, 1, 37, 1050, 10, 37, 888, -4, 37, 925, -4, 37, 638, 1, 37, 1026, 10, 37, 902, -4, 37, 884, -4, 37, 591, 1, 37, 914, -4, 37, 692, 1, 37, 906, -4, 37, 604, 1, 37, 933, -4, 37, 679, 1, 37, 889, -4, 37, 642, 1, 37, 941, -4, 37, 627, 1, 37, 946, -4, 37, 602, 1, 37, 694, 1, 37, 611, 1, 37, 613, 1, 37, 632, 1, 37, 615, 1, 37, 690, 1, 37, 682, 1, 37, 669, 1, 37, 681, 1,
38, 960, 1, 38, 1067, 15, 38, 1032, -5, 38, 1027, -5, 38, 886, 1, 38, 1035, -5, 38, 940, 1, 38, 1044, -5, 38, 888, 1, 38, 1050, -5, 38, 902, 1, 38, 1026, -5, 38, 953, 1, 38, 930, 1, 38, 925, 1, 38, 884, 1, 38, 914, 1, 38, 906, 1, 38, 933, 1, 38, 889, 1, 38, 941, 1, 38, 946, 1,
39, 1032, 1, 39, 1067, -6, 39, 1027, 1, 39, 1035, 1, 39, 1044, 1, 39, 1050, 1, 39, 1026, 1,
40, 1067, 1,
41, 233, 1, 41, 255, 1, 41, 232, 1, 41, 305, 1, 41, 261, 1, 41, 275, 1, 41, 931, 1, 41, 326, 1, 41, 328, 1, 41, 243, 1, 41, 959, 1, 41, 317, 1, 41, 951, 1, 41, 935, 1, 41, 954, 1, 41, 25, -1, 41, 3, -1, 41, 32, -1, 41, 704, -1, 41, 23, -1, 41, 698, -1, 41, 651, -1, 41, 650, -1, 41, 16, -1, 41, 670, -1, 41, 637, -1, 41, 661, -1, 41, 634, -1, 41, 592, -1, 41, 696, -1, 41, 1033, -1,
42, 25, 1, 42, 704, 3, 42, 698, 3, 42, 651, 3, 42, 670, 3, 42, 637, 3, 42, 634, 3, 42, 1033, 5, 42, 233, -2, 42, 255, -2, 42, 305, -2, 42, 931, -4, 42, 326, -2, 42, 959, -4, 42, 951, -4, 42, 935, -4, 42, 3, 1, 42, 650, 3, 42, 661, 3, 42, 592, 3, 42, 232, -2, 42, 261, -2, 42, 328, -2, 42, 954, -4, 42, 32, 1, 42, 696, 3, 42, 275, -2, 42, 243, -2, 42, 23, 1, 42, 317, -2, 42, 16, 1,
43, 233, 1, 43, 931, 6, 43, 959, 6, 43, 951, 6, 43, 704, -3, 43, 698, -3, 43, 670, -3, 43, 1033, -10, 43, 255, 1, 43, 935, 6, 43, 651, -3, 43, 637, -3, 43, 232, 1, 43, 954, 6, 43, 650, -3, 43, 661, -3, 43, 305, 1, 43, 634, -3, 43, 261, 1, 43, 592, -3, 43, 275, 1, 43, 696, -3, 43, 326, 1, 43, 328, 1, 43, 243, 1, 43, 317, 1,
44, 704, 1, 44, 1033, 10, 44, 931, -4, 44, 959, -4, 44, 698, 1, 44, 951, -4, 44, 651, 1, 44, 935, -4, 44, 650, 1, 44, 954, -4, 44, 670, 1, 44, 637, 1, 44, 661, 1, 44, 634, 1, 44, 592, 1, 44, 696, 1,
45, 931, 1, 45, 1033, -5, 45, 959, 1, 45, 951, 1, 45, 935, 1, 45, 954, 1,
46, 1033, 1,
47, 240, 1, 47, 241, 1, 47, 254, 1, 47, 303, 1, 47, 244, 1, 47, 251, 1, 47, 903, 1, 47, 316, 1, 47, 311, 1, 47, 268, 1, 47, 926, 1, 47, 291, 1, 47, 915, 1, 47, 896, 1, 47, 947, 1, 47, 319, 1, 47, 302, 1, 47, 287, 1, 47, 957, 1, 47, 313, 1, 47, 900, 1, 47, 949, 1, 47, 964, 1, 47, 285, 1, 47, 898, 1, 47, 944, 1, 47, 911, 1, 47, 904, 1, 47, 893, 1, 47, 899, 1, 47, 1069, 1, 47, 43, -1, 47, 7, -1, 47, 31, -1, 47, 603, -1, 47, 10, -1, 47, 702, -1, 47, 648, -1, 47, 685, -1, 47, 36, -1, 47, 621, -1, 47, 687, -1, 47, 664, -1, 47, 625, -1, 47, 626, -1, 47, 667, -1, 47, 1043, -1, 47, 21, -1, 47, 605, -1, 47, 693, -1, 47, 600, -1, 47, 700, -1, 47, 658, -1, 47, 622, -1, 47, 1030, -1, 47, 644, -1, 47, 649, -1, 47, 599, -1, 47, 1049, -1, 47, 647, -1, 47, 1053, -1, 47, 1040, -1, 47, 1031, -1,
48, 43, 1, 48, 603, 3, 48, 702, 3, 48, 648, 3, 48, 621, 3, 48, 687, 3, 48, 625, 3, 48, 1043, 5, 48, 605, 3, 48, 693, 3, 48, 700, 3, 48, 1030, 5, 48, 644, 3, 48, 1049, 5, 48, 1053, 5, 48, 1040, 5, 48, 240, -2, 48, 241, -2, 48, 303, -2, 48, 903, -4, 48, 316, -2, 48, 926, -4, 48, 915, -4, 48, 896, -4, 48, 319, -2, 48, 957, -4, 48, 900, -4, 48, 949, -4, 48, 898, -4, 48, 944, -4, 48, 904, -4, 48, 1069, -6, 48, 7, 1, 48, 685, 3, 48, 664, 3, 48, 626, 3, 48, 600, 3, 48, 658, 3, 48, 649, 3, 48, 1031, 5, 48, 254, -2, 48, 244, -2, 48, 311, -2, 48, 947, -4, 48, 302, -2, 48, 964, -4, 48, 911, -4, 48, 893, -4, 48, 31, 1, 48, 667, 3, 48, 622, 3, 48, 599, 3, 48, 251, -2, 48, 268, -2, 48, 287, -2, 48, 899, -4, 48, 10, 1, 48, 647, 3, 48, 291, -2, 48, 313, -2, 48, 36, 1, 48, 285, -2, 48, 21, 1,
49, 240, 1, 49, 903, 6, 49, 926, 6, 49, 915, 6, 49, 957, 6, 49, 900, 6, 49, 898, 6, 49, 1069, 15, 49, 603, -3, 49, 702, -3, 49, 621, -3, 49, 1043, -10, 49, 605, -3, 49, 1030, -10, 49, 1049, -10, 49, 1053, -10, 49, 241, 1, 49, 896, 6, 49, 949, 6, 49, 944, 6, 49, 648, -3, 49, 687, -3, 49, 693, -3, 49, 1040, -10, 49, 254, 1, 49, 947, 6, 49, 964, 6, 49, 911, 6, 49, 685, -3, 49, 664, -3, 49, 600, -3, 49, 1031, -10, 49, 303, 1, 49, 904, 6, 49, 625, -3, 49, 700, -3, 49, 244, 1, 49, 893, 6, 49, 626, -3, 49, 658, -3, 49, 251, 1, 49, 899, 6, 49, 667, -3, 49, 622, -3, 49, 316, 1, 49, 644, -3, 49, 311, 1, 49, 649, -3, 49, 268, 1, 49, 599, -3, 49, 291, 1, 49, 647, -3, 49, 319, 1, 49, 302, 1, 49, 287, 1, 49, 313, 1, 49, 285, 1,
50, 603, 1, 50, 1043, 10, 50, 1030, 10, 50, 1049, 10, 50, 903, -4, 50, 926, -4, 50, 957, -4, 50, 1069, -20, 50, 702, 1, 50, 1053, 10, 50, 915, -4, 50, 900, -4, 50, 648, 1, 50, 1040, 10, 50, 896, -4, 50, 949, -4, 50, 685, 1, 50, 1031, 10, 50, 947, -4, 50, 964, -4, 50, 621, 1, 50, 898, -4, 50, 687, 1, 50, 944, -4, 50, 664, 1, 50, 911, -4, 50, 625, 1, 50, 904, -4, 50, 626, 1, 50, 893, -4, 50, 667, 1, 50, 899, -4, 50, 605, 1, 50, 693, 1, 50, 600, 1, 50, 700, 1, 50, 658, 1, 50, 622, 1, 50, 644, 1, 50, 649, 1, 50, 599, 1, 50, 647, 1,
51, 903, 1, 51, 1069, 15, 51, 1043, -5, 51, 1030, -5, 51, 926, 1, 51, 1049, -5, 51, 915, 1, 51, 1053, -5, 51, 896, 1, 51, 1040, -5, 51, 947, 1, 51, 1031, -5, 51, 957, 1, 51, 900, 1, 51, 949, 1, 51, 964, 1, 51, 898, 1, 51, 944, 1, 51, 911, 1, 51, 904, 1, 51, 893, 1, 51, 899, 1,
52, 1043, 1, 52, 1069, -6, 52, 1030, 1, 52, 1049, 1, 52, 1053, 1, 52, 1040, 1, 52, 1031, 1,
53, 1069, 1,

NULL), ncol=3, byrow=T); # close ind_mema creation
measmat[[1]][ind_mema[,1:2,drop=FALSE]]=ind_mema[,3]
memaone[[1]]=c(0.0, 0.0, 0.0, 0.0, 1, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1, 0.0, 0.0, 0.0, 1, 0.0, 0.0, 0.0, 1, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1, 0.0, 0.0, 0.0, 0.0, 0.0, 1, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0)

pwe=ipwe=ip2ipwe=pool_factor=ijpwef=dp_ones=meas2sum=dpw_dpf=ipf_in_ppw=vector("list", nb_exp)
mets_in_res=vector("list", nb_exp)
for (iexp in seq_len(nb_exp)) {
   names(memaone[[iexp]])=nm_measmat[[iexp]]

   # prepare weights of label data for pooled metabs
   # prepare ipwe and ip2ipwe such that pwe[ipwe]=pool[ip2ipwe]
   # gives a good base for weight sum and normalization
   pwe[[iexp]]=double(nb_measmat[[iexp]])+1.
   mets_in_res[[iexp]]=sapply(nm_measmat[[iexp]], function(m) strsplit(m, ":")[[1L]][2L])
   for (po in names(ipooled[[iexp]])) {
      if (po == "ishort") next
      nm_sum=strsplit(po, ":")[[1L]][2L]
      mets=strsplit(nm_sum, "\\+")[[1L]]
      irpo=ipooled[[iexp]][[po]]
      ipwe[[iexp]]=c(ipwe[[iexp]], irpo) # where weighting is
      i=pmatch(mets, names(nm_poolf))
      if (any(!is.na(i))) {
         for (ir in i) {
            if (is.na(ir)) next
            ijpwef[[iexp]]=rbind(ijpwef[[iexp]], cbind(irpo, ir)) # where free pools matter
         }
      }
      ip2ipwe[[iexp]]=c(ip2ipwe[[iexp]], pmatch(mets, names(nm_poolall)))
      mets_in_res[[iexp]][irpo]=mets
   }
   # order ijpwef for sparse matrix ordering
   if (!is.null(ijpwef[[iexp]])) {
      o=order(ijpwef[[iexp]][,2L], ijpwef[[iexp]][,1L])
      ijpwef[[iexp]]=ijpwef[[iexp]][o,,drop=FALSE]
   }
   pool_factor[[iexp]]=as.factor(nm_measmat[[iexp]])
   # free pool in principal pool weight
   ipf_in_ppw[[iexp]]=apply(outer(mets_in_res[[iexp]], names(nm_poolf), "=="), 1, function(v) if(length(w <-which(v))) w else NA)
   ipf_in_ppw[[iexp]][is.na(ipf_in_ppw[[iexp]])]=0L
   dp_ones[[iexp]]=matrix(0., nb_measmat[[iexp]], nb_poolf)
   dp_ones[[iexp]][cbind(ipwe[[iexp]], ipf_in_ppw[[iexp]][ipwe[[iexp]]])]=1.
   
   # matrix for summing weighted measurements
   meas2sum[[iexp]]=simple_triplet_zero_matrix(length(ipooled[[iexp]]$ishort), nb_measmat[[iexp]])
   meas2sum[[iexp]][cbind(pmatch(nm_measmat[[iexp]], nm_measmat[[iexp]][ipooled[[iexp]]$ishort], dup=T),       seq_len(nb_measmat[[iexp]]))]=1.
   dimnames(meas2sum[[iexp]])=list(nm_meas[[iexp]], nm_measmat[[iexp]])
   
   # dpw_dpf - matrix for derivation of pool weights by free pools
   if (nb_poolf > 0L && length(ijpwef[[iexp]]) > 0) {
      # indeed, we'll have to do weight derivation by free pools
      dpw_dpf[[iexp]]=simple_triplet_zero_matrix(nb_measmat[[iexp]], nb_poolf)
      dpw_dpf[[iexp]][ijpwef[[iexp]]]=1.
   }
}


# prepare flux measurements
nm_fmn=nm_net[c("out_Ac")]
nm_list$fmn=nm_fmn
nb_fmn=length(nm_fmn)
nb_f$nb_fmn=nb_fmn

# measured values
fmn=c(0.213)

# SD for flux measurements
fmndev=c(0.0001)
if (nb_fmn)
   names(fmndev)=names(fmn)=nm_fmn

# indices for measured fluxes
# fallnx[ifmn]=>fmn, here fallnx is complete net|xch flux vector
# combining unknown (dependent), free, constrainded and groth fluxes
ifmn=match(nm_fmn, nm_fallnx)

if (TIMEIT) {
   cat("ineq    : ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}
# prepare mi matrix and li vector
# such that mi*fallnx>=li corresponds
# to the inequalities given in ftbl file
nb_ineq=6
mi=matrix(0., nrow=nb_ineq, ncol=nb_fallnx)
li=numeric(nb_ineq)
nm_i=c(c("n:1<=pyk", "n:0.0001<=edd", "n:0.0001<=gnd", "n:0.0001<=zwf", "n:0.0001<=ppc", "n:0.0001<=mae"), c())
dimnames(mi)=list(nm_i, nm_fallnx)
mi[1, nm_net[c("pyk")]]=c(1.0)
li[1]=1
mi[2, nm_net[c("edd")]]=c(1.0)
li[2]=0.0001
mi[3, nm_net[c("gnd")]]=c(1.0)
li[3]=0.0001
mi[4, nm_net[c("zwf")]]=c(1.0)
li[4]=0.0001
mi[5, nm_net[c("ppc")]]=c(1.0)
li[5]=0.0001
mi[6, nm_net[c("mae")]]=c(1.0)
li[6]=0.0001

# add standard limits on [df].xch [0;cupx]
nb_tmp=nrow(mi)
nb_fx=nb_flx+nb_ffx
if (nb_fx) {
   mi=rbind(mi, matrix(0, nrow=2*nb_fx, ncol=nb_fallnx))
   if (nb_flx)
      nm_i=c(nm_i, paste(nm_flx, ">=0", sep=""))
   if (nb_ffx)
      nm_i=c(nm_i, paste(nm_ffx, ">=0", sep=""))
   if (nb_flx)
      nm_i=c(nm_i, paste(nm_flx, "<=", cupx, sep=""))
   if (nb_ffx)
      nm_i=c(nm_i, paste(nm_ffx, "<=", cupx, sep=""))
   li=c(li, rep(0, nb_fx), rep(-cupx, nb_fx))
   mi[nb_tmp+(1:nb_fx),c(nm_flx, nm_ffx)]=diag(1., nb_fx)
   mi[nb_tmp+nb_fx+(1:nb_fx),c(nm_flx, nm_ffx)]=diag(-1., nb_fx)
}

nm_inout=grep("^[^c]\\.", nm_net[c("bs_pga3_aux", "bs_rib5p1_aux", "bs_pep5", "bs_accoa_aux", "bs_akg4_aux", "Glucupt_1", "bs_pga1_aux", "bs_oaa5_aux", "bs_pep3_aux", "bs_pep6_aux", "bs_oaa7_aux", "bs_glc6P", "bs_akg2", "bs_pep4_aux", "bs_akg3", "bs_oaa6_aux", "bs_DHAP", "bs_oaa2_aux", "bs_pyr1_aux", "bs_pga2_aux", "Glucupt_U", "bs_oaa4", "bs_oaa3_aux", "bs_oaa1_aux", "bs_rib5p2", "out_FTHF", "bs_pyr4_aux", "out_co2", "out_Ac", "bs_pga_aux", "bs_pyr3_aux", "bs_fru6P")], v=T) # strip out constrained fluxes
nb_inout=length(nm_inout)
if (nb_inout > 0) {
   # add cinout low limits on inout net fluxes
   nb_tmp=nrow(mi)
   # explicit inequalities take precedence over generic ones
   # so eliminate inout fluxes which are already in inequalities
   nm_itmp=paste("n:.+<=", substring(nm_inout, 5), sep="")
   i=sapply(1:length(nm_itmp), function(k) {
      j=grep(nm_itmp[k], nm_i)
      #cat(nm_itmp[k], "->", nm_i[j], "\n", file=fclog)
      if (length(j)==0) {
         return(0)
      } else {
         return(k)
      }
   })
   i=i[i!=0]
   if (length(i) > 0) {
      nm_tmp=nm_inout[-i]
   } else {
      nm_tmp=nm_inout
   }
   len_tmp=length(nm_tmp)
   if (len_tmp > 0) {
      mi=rbind(mi, matrix(0, nrow=len_tmp, ncol=nb_fallnx))
      nm_i=c(nm_i, paste("inout ", nm_tmp, ">=", cinout, sep=""))
      mi[nb_tmp+(1:len_tmp), nm_tmp]=diag(1., len_tmp)
      li=c(li, rep(cinout, len_tmp))
   }
}
if (clownr!=0.) {
   # add low limits on net >= clownr for not reversible reactions
   nb_tmp=nrow(mi)
   nm_tmp=nm_net[c("bs_pyr1", "bs_pga3_aux", "bs_oaa2", "bs_pep5", "bs_rib5p1", "citsynth", "bs_pyr4", "bs_rib5p1_aux", "bs_accoa", "bs_e4p", "bs_pep", "idh", "bs_accoa_aux", "gnd", "bs_pga2", "bs_akg1", "bs_akg4_aux", "Glucupt_1", "bs_oaa3b", "bs_akg4", "bs_pga1_aux", "mae", "bs_oaa5_aux", "bs_pep6_aux", "bs_pep3_aux", "bs_oaa7_aux", "bs_pep2", "bs_pep3a", "bs_glc6P", "bs_pep3b", "bs_akg", "bs_akg2", "bs_pep4_aux", "bs_pep1", "bs_oaa7", "bs_akg3", "bs_pyr", "bs_pyr3", "bs_oaa", "bs_oaa2_aux", "bs_DHAP", "bs_oaa6_aux", "bs_pyr1_aux", "bs_oaa3a", "bs_pga2_aux", "pfk", "bs_oaa5", "akgdh", "bs_pep4a", "bs_pep4b", "Glucupt_U", "bs_oaa3_aux", "bs_oaa4", "bs_oaa1_aux", "bs_rib5p2", "bs_pyr2", "bs_rib5p", "bs_pep6", "out_FTHF", "bs_pga1", "bs_pyr4_aux", "out_co2", "out_Ac", "bs_pga", "zwf", "bs_pep7", "edd", "bs_pga_aux", "bs_pyr3_aux", "bs_oaa6", "bs_fru6P", "bs_oaa1")]
   # explicit inequalities take precedence over generic ones
   # so eliminate notrev fluxes which are already in inequalities
   nm_itmp=paste("n:.+<=", substring(nm_tmp, 5), sep="")
   i=sapply(1:length(nm_itmp), function(k) {
      j=grep(nm_itmp[k], nm_i)
      #cat(nm_itmp[k], "->", nm_i[j], "\n", file=fclog)
      if (length(j)==0) {
         return(0)
      } else {
         return(k)
      }
   })
   i=i[i!=0]
   if (length(i) > 0) {
      nm_tmp=nm_tmp[-i]
   }
   # search for inout too
   nm_itmp=paste("inout ", nm_tmp, ">=", sep="")
   i=sapply(1:length(nm_itmp), function(k) {
      j=grep(nm_itmp[k], nm_i, fix=T)
      #cat(nm_itmp[k], "->", nm_i[j], "\n", file=fclog)
      if (length(j)==0) {
         return(0)
      } else {
         return(k)
      }
   })
   i=i[i!=0]
   if (length(i) > 0) {
      nm_tmp=nm_tmp[-i]
   }

   len_tmp=length(nm_tmp)
   if (len_tmp > 0) {
      mi=rbind(mi, matrix(0, nrow=len_tmp, ncol=nb_fallnx))
      nm_i=c(nm_i, paste(nm_tmp, ">=", clownr, sep=""))
      mi[nb_tmp+(1:len_tmp), nm_tmp]=diag(1., len_tmp)
      li=c(li, rep(clownr, len_tmp))
   }
}
nb_fn=nb_fln+nb_ffn
if (cupn != 0 && nb_fn > 0) {
   # add upper limits on [df].net <= cupn for net fluxes
   # explicit inequalities take precedence over generic ones
   # so eliminate net fluxes which are already in inequalities
   nm_tmp=c(nm_ffn, nm_fln) # all not fixed net fluxes
   nm_itmp=paste("n:.+>=", substring(nm_tmp, 5), sep="")
   i=sapply(seq(along=nm_itmp), function(k) {
      j=grep(nm_itmp[k], nm_i)
      #cat(nm_itmp[k], "->", nm_i[j], "\n", file=fclog)
      if (length(j)==0) {
         return(0)
      } else {
         return(k)
      }
   })
   i=i[i!=0]
   if (length(i) > 0) {
      nm_tmp=nm_tmp[-i]
   }
   len_tmp=length(nm_tmp)
   if (len_tmp > 0) {
      nb_tmp=nrow(mi)
      mi=rbind(mi, matrix(0, nrow=len_tmp, ncol=nb_fallnx))
      nm_i=c(nm_i, paste(nm_tmp, "<=", cupn, sep=""))
      li=c(li, rep(-cupn, len_tmp))
      mi[nb_tmp+(1:len_tmp),nm_tmp]=diag(-1., len_tmp)
   }
}

nb_ineq=NROW(li);

dimnames(mi)=list(nm_i, nm_fallnx)
names(li)=nm_i
# prepare ui matrix and ci vector for optimisation
# ui%*%param-ci>=0
# it is composed of explicite inequalities from ftbl
# and permanent inequalities 0<=xch<=0.999 and scale>=0

# constraints such that ui%*%param-ci>=0
# first flux part
ui=mi%*%(md%*%invAfl%stm%p2bfl+mf)
mic=(md%*%invAfl%*%(c2bfl%stm%fc+cnst2bfl) + mc%*%fc)
ci=as.numeric(li-mi%*%mic)

# finaly, metab part
uip=matrix(0., 0, ncol=nb_poolf)
colnames(uip)=nm_poolf
cip=c()
# ind: irow, metab, coef, rhs, name
uip_ind=c(

)
if (length(uip_ind) > 0) {
   uip_ind=matrix(uip_ind, byrow=T, ncol=5L)
} else {
   uip_ind=matrix(0, 0L, 5L)
}
colnames(uip_ind)=c("irow", "metab", "coef", "rhs", "name")


if (nrow(uip_ind) > 0) {
   # rhs are summed up for the same irow by aggregate()
   irow=as.integer(uip_ind[,"irow"])
   cip=aggregate(as.double(uip_ind[,"rhs"]), by=list(irow), sum)[,"x"]
   for (i in seq_len(nrow(uip_ind))) {
      row=uip_ind[i,]
      if (nchar(row["metab"])==0) {
         next
      }
      uip[irow[i], nm_poolf[row["metab"]]]=as.double(row["coef"])
   }
   if (nrow(uip) > 0) {
      rownames(uip)=paste("m:", uip_ind[pmatch(seq_len(nrow(uip)), irow),"name"], sep="")
   }
}
names(cip)=rownames(uip)

#browser() # before null inequality removing
# remove all zero rows in ui (constrained fluxes with fixed values)
# find zero indexes
#print(dim(ui))
if (ncol(ui)) {
   zi=apply(ui,1,function(v){return(max(abs(v))<=1.e-14)})
} else {
   # remove all flux inequalities as there is no free fluxe
   zi=rep(TRUE, nrow(ui))
}

if (!all(ci[zi]<=1.e-10)) {
   cat("The following constant inequalities are not satisfied:\n", file=fcerr)
   cat(nm_i[zi][ci[zi]>1.e-10], sep="\n", file=fcerr)
   cat("They are simply ignored.\n", file=fcerr)
   #stop_mes("", file=fcerr)
}
ui=ui[!zi,,drop=FALSE]
ci=ci[!zi]
nm_i=nm_i[!zi]

# complete ui by zero columns corresponding to scale params
if (nb_sc_tot) {
   ui=cBind(as.matrix(ui), matrix(0., NROW(ui), nb_sc_tot))
   # complete ui by scales >=0
   ui=rBind(ui, cBind(matrix(0, nb_sc_tot, nb_ff), diag(1, nb_sc_tot)))
   ci=c(ci,rep(0., nb_sc_tot))
   nm_i=c(nm_i, paste(nm_par[nb_ff+seq_len(nb_sc_tot)], ">=0", sep=""))
   rownames(ui)=nm_i
   names(ci)=nm_i
}

# remove redundant inequalities
#browser()
nb_i=nrow(ui)
ired=c()
if (nb_i > 1L) {
   for (i in 1L:(nb_i-1L)) {
      nmref=nm_i[i]
      for (j in setdiff((i+1L):nb_i, ired)) {
         if (all(ui[j,]==ui[i,]) && ci[i]==ci[j]) {
            # redundancy
            cat("inequality '", nm_i[j], "' redundant with '", nmref, "' is removed.
", sep="", file=fclog)
            ired=c(ired, j)
         }
      }
   }
}
if (!is.null(ired)) {
   # remove all ired inequalities
   ui=ui[-ired,,drop=FALSE]
   ci=ci[-ired]
   nm_i=nm_i[-ired]
}

# metabolite equalities
ep=matrix(0., 0, ncol=nb_poolf)
cp=c()
colnames(ep)=nm_poolf
# ind: irow, metab, coef, rhs, name
ep_ind=c(

)
if (length(ep_ind) > 0) {
   ep_ind=matrix(ep_ind, byrow=T, ncol=5L)
} else {
   ep_ind=matrix(0, 0L, 5L)
}
colnames(ep_ind)=c("irow", "metab", "coef", "rhs", "name")


if (nrow(ep_ind) > 0) {
   # rhs are summed up for the same irow by aggregate
   irow=as.integer(ep_ind[,"irow"])
   cp=aggregate(as.double(ep_ind[,"rhs"]), by=list(irow))[,"x"]
   for (i in seq_len(nrow(ep_ind))) {
      row=ep_ind[i,]
      if (nchar(row["metab"])==0) {
         next
      }
      ep[irow[i], nm_poolf[row["metab"]]]=as.double(row["coef"])
   }
   if (nrow(ep) > 0) {
      rownames(ep)=paste("m:", ep_ind[pmatch(seq_len(nrow(ep)), irow),"name"], sep="")
   }
}
ep=as.matrix(ep)
names(cp)=rownames(ep)

nb_sys=list(
   reactions=list(
      reversible=14,
      non_reversible=72
   ),
   fluxes=list(
      free=12,
      dependent=55,
      constrained=105
   ),
   metabolites=list(
      input=2,
      output=30,
      intra=49
   ),
   measurements=list(
      flux=1,
      mass=53,
      peak=0,
      label=0,
      metab=0
   ),
   equations=list(
      equalities=6,
      inequalities=6
   ),
   label_variables=list(
      full=c(0,0,0,0,0,0,0,0,0,0,0),
      reduced_cumomers=c(231,359,293,142,39,5)
   ),
   parallel_experiments=1
)
if (sum(nb_sys$label_variables$full)==0) {
   nb_sys$label_variables$full=NULL
}
if (emu) {
   x=nb_sys$label_variables$reduced_cumomers
   nb_sys$label_variables$reduced_cumomers=NULL
   nb_sys$label_variables$emu=paste(x, "*", seq_len(length(x)), "=", x*seq_len(length(x)))
}

#browser()

# extend param vector by free pools
if (nb_poolf > 0) {
   param=c(param, poolf)
   nm_par=c(nm_par, nm_poolf)
   nb_param=length(param)
}
nm_list$par=nm_par

#browser()
if (nb_poolf > 0) {
   # extend inequalities ui, ci by uip, cip
   nb_row=nrow(ui)
   nb_col=ncol(ui)
   ui=cbind(ui, matrix (0., nrow=nb_row, ncol=nb_poolf)) # add 0-columns
   ui=rbind(ui, cbind(matrix(0., nrow(uip), ncol=nb_col), uip))
   ci=c(ci, cip)
   
   # extend inequalities ui, ci by cupp>= poolf >= clowp
   # but exclude metabolites that are individually set in the uip (FTBL)
   met_low=met_up=c()
   if (nrow(uip) > 0) {
      # number of non zero entries per row in uip
      i_nz=rowSums(abs(uip) != 0.)
      # number of positive coeffs for alone metabs (i.e. low limit is set)
      i_pos=colSums(uip[i_nz > 0,,drop=FALSE] > 0)
      met_low=nm_poolf[i_pos > 0]
      # number of negative coeffs for alone metabs (i.e. upper limit is set)
      i_neg=colSums(uip[i_nz > 0,,drop=FALSE] < 0)
      met_up=nm_poolf[i_neg > 0]
   }

   # add low limit
   nb_add=nb_poolf-length(met_low)
   if (nb_add > 0) {
      nm_add=nm_poolf[!nm_poolf %in% met_low]
      ui_add=matrix(0., nrow=nb_add, ncol=ncol(ui))
      ui_add[,nb_col+pmatch(nm_add, nm_poolf)]=diag(1., nb_add)
      rownames(ui_add)=paste(nm_add, ">=", clowp, sep="")
      if (nrow(ui)) {
         ui=rbind(ui, ui_add)
      } else {
         ui=ui_add
      }
      ci=c(ci, rep(clowp, nb_add))
   }

   # add upper limit
   nb_add=nb_poolf-length(met_up)
   if (nb_add > 0) {
      nm_add=nm_poolf[!nm_poolf %in% met_up]
      ui_add=matrix(0., nrow=nb_add, ncol=ncol(ui))
      ui_add[,nb_col+pmatch(nm_add, nm_poolf)]=diag(-1., nb_add)
      rownames(ui_add)=paste(nm_add, "<=", cupp, sep="")
      ui=rbind(ui, ui_add)
      ci=c(ci, rep(-cupp, nb_add))
   }

   nm_i=names(ci)=rownames(ui)
   colnames(ui)=nm_par
}
# extend the matrix of metabolite equalities
ep=cbind(matrix(0., nrow(ep), nb_param-nb_poolf), ep)
colnames(ep)=nm_par

# prepare metabolite pools measurements
nb_poolm=0
nb_f$nb_poolm=nb_poolm
nm_poolm=c()
nm_list$poolm=nm_poolm

# measured values
vecpoolm=c()
names(vecpoolm)=nm_poolm

# inverse of variance for pool measurements
poolmdev=c()
names(poolmdev)=nm_poolm

# simulated metabolite measurements are calculated as
# measmatpool*poolall=>poolm
measmatpool=matrix(0., nrow=nb_poolm, ncol=length(poolall))
dimnames(measmatpool)=list(nm_poolm, nm_poolall)
i=matrix(1+c(), ncol=2, byrow=T)
measmatpool[i]=1.


# gather all measurement information
measurements=list(
   vec=list(labeled=measvec, flux=fmn, pool=vecpoolm, kin=if (case_i) measvecti else NULL),
   dev=list(labeled=measdev, flux=fmndev, pool=poolmdev, kin=if (case_i) rep(measdev, nb_ti-1) else NULL),
   mat=list(labeled=measmat, flux=ifmn, pool=measmatpool),
   one=list(labeled=memaone)
)
nm_resid=c(if (case_i) unlist(lapply(seq_len(nb_exp), function(iexp) paste(iexp, outer(nm_meas[[iexp]], ti[[iexp]][-1L], paste, sep=", t="), sep=":"))) else unlist(lapply(seq_len(nb_exp), function(iexp) paste(iexp, nm_meas[[iexp]], sep=":"))), nm_fmn, nm_poolm)
nm_list$resid=nm_resid

if (TIMEIT) {
   cat("preopt  : ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}
#browser()
names(param)=nm_par
# prepare series of starting points
if (nchar(fseries) > 0) {
   pstart=as.matrix(read.table(fseries, header=T, row.n=1, sep="\t"))
   # skip parameters (rows) who's name is not in nm_par
   i=rownames(pstart) %in% nm_par
   if (!any(i)) {
      stop_mes("Option --fseries is used but no free parameter with known name is found.\n")
   }
   pstart=pstart[i,,drop=FALSE]
   cat("Using starting values form '", fseries, "' for the following free parameters:\n", paste(rownames(pstart), collapse="\n"), "\n", sep="", file=fclog)
   nseries=ncol(pstart)
   if (initrand) {
      # fill the rest of rows with random values
      i=nm_par %in% rownames(pstart)
      n=sum(!i)
      pstart=rbind(pstart, matrix(runif(n*nseries), n, nseries))
      rownames(pstart)=c(rownames(pstart)[seq_len(nb_param-n)], nm_par[!i])
   }
   if (nchar(iseries) > 0) {
      iseries=unique(as.integer(eval(parse(t="c("%s+%iseries%s+%")"))))
      iseries=iseries[iseries<=nseries]
      # subsample
      pstart=pstart[,iseries, drop=FALSE]
      nseries=ncol(pstart)
   } else {
      iseries=seq_len(nseries)
   }
} else if (nchar(iseries) > 0) {
   # first construct pstart then if needed fill it with random values
   # and only then subsample
   iseries=unique(as.integer(eval(parse(t="c("%s+%iseries%s+%")"))))
   nseries=max(iseries)
   pstart=matrix(rep(param, nseries), nrow=nb_param, ncol=nseries)
   dimnames(pstart)=list(nm_par, paste("V", seq_len(nseries), sep=""))
   if (initrand) {
      # fill pstart with random values
      pstart[]=runif(length(pstart))
   }
   # subsample
   pstart=pstart[,iseries, drop=FALSE]
   nseries=ncol(pstart)
} else {
   iseries=1L
   pstart=as.matrix(param)
   nseries=1L
   if (initrand) {
      # fill pstart with random values
      pstart[]=runif(length(pstart))
   }
}
nm_pseries=rownames(pstart)

if (is.null(nseries) || nseries==0) {
   stop_mes(sprintf("No starting values in the series file '%s' or --iseries is empty.", fseries),  file=fcerr)
}

pres=matrix(NA, nb_param, nseries)
rownames(pres)=nm_par
colnames(pres)=colnames(pstart)
costres=rep.int(NA, nseries)

# prepare flux index conversion
ifwrv=1:nb_fwrv
names(ifwrv)=nm_fwrv
ifl_in_fw=if (nb_fln) ifwrv[paste("fwd", substring(c(nm_fln, nm_flx), 4), sep="")] else integer(0)
iff_in_fw=if (nb_ff > 0) ifwrv[paste("fwd", substring(c(nm_ffn, nm_ffx), 4), sep="")] else integer(0)
ifg_in_fw=if (nb_fgr > 0) ifwrv[paste("fwd", substring(nm_fgr, 4), sep="")] else integer(0)

# index couples for jacobian df_dfl, df_dffd
cfw_fl=crv_fl=cbind(ifl_in_fw, seq_len(nb_fl))
cfw_ff=crv_ff=cbind(iff_in_fw, seq_len(nb_ff))
cfw_fg=crv_fg=cbind(ifg_in_fw, nb_ff+seq_len(nb_fgr))
crv_fl[,1L]=(nb_fwrv/2)+crv_fl[,1L]
crv_ff[,1L]=(nb_fwrv/2)+crv_ff[,1L]
crv_fg[,1L]=(nb_fwrv/2)+crv_fg[,1L]

# store it in nb_f
nb_f=append(nb_f, list(cfw_fl=cfw_fl, crv_fl=crv_fl, cfw_ff=cfw_ff,
   crv_ff=crv_ff, cfw_fg=cfw_fg, crv_fg=crv_fg))
nb_f=as.environment(nb_f)

nbc_x=c(0, cumsum(nb_x))
nb_f$nbc_x=nbc_x

# fixed part of jacobian (unreduced by SD)
# measured fluxes
dufm_dp=cbind(dufm_dff(nb_f, nm_list), matrix(0, nrow=nb_fmn, ncol=nb_sc_tot+nb_poolf))
dimnames(dufm_dp)=list(nm_fmn, nm_par)

# measured pools
dupm_dp=matrix(0., nb_poolm, nb_ff+nb_sc_tot)
if (nb_poolf > 0L) {
   dupm_dp=cbind(dupm_dp, measurements$mat$pool[,nm_list$poolf, drop=FALSE])
}
dimnames(dupm_dp)=list(rownames(measurements$mat$pool), nm_par)

#browser()
# prepare argument list for passing to label simulating functions
nm_labargs=c("jx_f", "nb_f", "nm_list", "nb_x", "invAfl", "p2bfl", "g2bfl", "bp", "fc", "xi", "spa", "emu", "pool", "measurements", "ipooled", "ir2isc",  "nb_w", "nbc_x", "measmat", "memaone", "dufm_dp", "dupm_dp", "pwe", "ipwe", "ip2ipwe", "pool_factor", "ijpwef", "ipf_in_ppw", "meas2sum", "dp_ones", "clen", "dirr", "dirw", "baseshort", "case_i", "nb_exp", "noscale", "dpw_dpf")

if (TIMEIT) {
   cat("labargs : ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}
labargs=new.env()
tmp=lapply(nm_labargs, function(nm) assign(nm, get(nm), labargs))
#for (nm in nm_labargs) {
#   labargs[[nm]]=get(nm)
#}
labargs[["nm"]]=labargs[["nm_list"]]

# prepare labargs2 if time_order includes 2
if (case_i && (time_order == "2" || time_order == "1,2")) {
   labargs2=as.environment(as.list(labargs))
   labargs2$nb_f=as.environment(as.list(labargs$nb_f))
   labargs2$tifull=tifull2
   labargs2$jx_f=new.env()
   labargs2$nb_f$ipf2ircumo=nb_f$ipf2ircumo2
   labargs2$nb_f$tifu=nb_f$tifu2
   labargs[["labargs2"]]=labargs2
}

# formated output in kvh file
fkvh_saved=file.path(dirw, sprintf("%s_res.kvh", baseshort))

control_ftbl=list()

retcode=numeric(nseries)
cl_type="PSOCK"
cl=NULL
if ((case_i && (time_order %in% c("1,2", "2"))) || sensitive == "mc") {
   if (np > 1L) {
      # prepare cluster
      nodes=if (sensitive == "mc") np else 2

      # prepare cluster
      cl=makeCluster(nodes, cl_type) #, outfile="cl.log")
#cat("make cluster=")
#print(cl[[1]])
      labargs[["cl"]]=cl
      nodes=length(cl)
      if (TIMEIT) {
         cat("cl expor: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
      }
      clusterExport(cl, c("lsi_fun", "df_dffp", "lab_sim", "is.diff", "lab_resid", "ui", "ci", "ep", "cp", "control_ftbl", "method", "sln", "labargs", "dirr", "emu", "%stm%", "case_i", "time_order"))
      if (TIMEIT) {
         cat("cl sourc: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
      }
      clusterEvalQ(cl, {
         #idth=myinfo$id
         suppressPackageStartupMessages(library(nnls))
         suppressPackageStartupMessages(library(slam)) # for quick sparse matrices
         suppressPackageStartupMessages(library(Rcpp))
         suppressPackageStartupMessages(library(RcppArmadillo))
         suppressPackageStartupMessages(library(rmumps))
         suppressPackageStartupMessages(library(arrApply)) # for fast apply() on arrays
         suppressPackageStartupMessages(library(multbxxc))
         compiler::enableJIT(0)
         source(file.path(dirr, "tools_ssg.R"))
         source(file.path(dirr, "nlsic.R"))
         source(file.path(dirr, "opt_cumo_tools.R"))
         source(file.path(dirr, "opt_icumo_tools.R"))
         #loadcmp(file.path(dirr, "tools_ssg.Rc"))
         #loadcmp(file.path(dirr, "nlsic.Rc"))
         #loadcmp(file.path(dirr, "opt_cumo_tools.Rc"))
         #loadcmp(file.path(dirr, "opt_icumo_tools.Rc"))
         labargs$spa=sparse2spa(labargs$spa)
         if (case_i && (time_order == "2" || time_order == "1,2")) {
            labargs$labargs2$spa=labargs$spa
         }
#cat("evalQ idth=", idth, "\n")
#print(labargs)
#print(labargs$labargs2)
#print(labargs$spa)
#print(labargs$labargs2$spa)
         NULL
      })
      clusterSetRNGStream(cl)
      # set worker id
      idw=parLapply(cl, seq_along(cl), function(i) assign("idw", i, envir=.GlobalEnv))
   } else {
      labargs$cl=NULL
   }
}
for (irun in seq_len(nseries)) {
   if (TIMEIT) {
      cat(sprintf("run %4d: %s cpu=%g\n", irun, format(Sys.time()), proc.time()[1], "\n", sep=""), file=fclog)
   }
   param[nm_pseries]=pstart[nm_pseries, irun]
#browser()
   # prepare kvh file name
   if (nseries > 1) {
      runsuf="." %s+% colnames(pstart)[irun]
   } else {
      runsuf=""
   }
   if (length(nseries) > 0) {
      cat("Starting point", runsuf, "\n", sep="", file=fclog)
   }
   fkvh=file(substring(fkvh_saved, 1, nchar(fkvh_saved)-4) %s+% runsuf %s+% ".kvh", "w");

   # remove zc inequalities from previous runs
   izc=grep("^zc ", nm_i)
   if (length(izc)) {
      ui=ui[-izc,,drop=FALSE]
      ci=ci[-izc]
      nm_i=rownames(ui)
   }
   # check if initial approximation is feasible
   ineq=as.numeric(ui%*%param-ci)
   names(ineq)=rownames(ui)
   if (any(ineq <= -1.e-10)) {
      cat("The following ", sum(ineq<= -1.e-10), " ineqalities are not respected at starting point", runsuf, ":\n", sep="", file=fclog)
      i=ineq[ineq<= -1.e-10]
      cat(paste(names(i), i, sep="\t", collapse="\n"), "\n", sep="", file=fclog)
      # put them inside
      capture.output(pinside <- put_inside(param, ui, ci), file=fclog)
      if (any(is.na(pinside))) {
         if (!is.null(attr(pinside, "err")) && attr(pinside, "err")!=0) {
            # fatal error occured
            cat("put_inside", runsuf, ": ", attr(pinside, "mes"), "\n",
               file=fcerr, sep="")
            close(fkvh)
            retcode[irun]=attr(pinside, "err")
            next;
         }
      } else if (!is.null(attr(pinside, "err")) && attr(pinside, "err")==0) {
         # non fatal problem
         cat(paste("put_inside: ", attr(pinside, "mes"), collapse=""), "\n", file=fcerr)
      }
      param[]=pinside
   }

   # prepare zero crossing strategy
   # inequalities to keep sens of net flux on first call to opt_wrapper()
   # if active they are removed on the second call to opt_wrapper()
   # and finaly all zc constraints are relaxed on the last call to opt_wrapper()
   fallnx=param2fl(param, labargs)$fallnx
   mi_zc=NULL
   li_zc=NULL
   if (zerocross && length(grep("^[df]\\.n\\.", nm_fallnx))>0) {
      if (TIMEIT) {
         cat("zc ineq : ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
      }
#browser()
      # prepare fluxes that are already in inequalities in alone mode
      ige=names(which(apply(mi, 1L, function(v) diff(range(v))==1 && sum(v)==1) & li>=0))
      ige=nm_dfn[unique(c(
         sub("^n:.+<=(.+)$", "\\1", grep("^n:.+<=.+$", ige, v=T)),
         sub("^[df]\\.n\\.(.+)>=.+$", "\\1", grep("^[df]\\.n\\..+>=.+$", ige, v=T)),
         sub("^inout [df]\\.n\\.(.+)>=.+$", "\\1", grep("^inout [df]\\.n\\..+>=.+$", ige, v=T))
      ))]
      ile=which(apply(mi, 1L, function(v) diff(range(v))==1 && sum(v)==-1)&li>=0)
      ile=nm_dfn[unique(c(
         sub("^n:.+<=(.+)$", "\\1", grep("^n:.+<=.+$", ile, v=T)),
         sub("^[df]\\.n\\.(.+)>=.+$", "\\1", grep("^[df]\\.n\\..+>=.+$", ile, v=T)),
         sub("^inout [df]\\.n\\.(.+)>=.+$", "\\1", grep("^inout [df]\\.n\\..+>=.+$", ile, v=T))
      ))]
      # add lower limits on [df].net >= zc for positive net fluxes
      # and upper limits on [df].net <= -zc for negative net fluxes
      nm_izc=c()
      ipos=setdiff(names(which(fallnx[grep("^[df]\\.n\\.", nm_fallnx)]>=0.)), ige)
      ineg=setdiff(names(which(fallnx[grep("^[df]\\.n\\.", nm_fallnx)]<0.)), ile)
      mi_zc=matrix(0, nrow=length(ipos)+length(ineg), ncol=nb_fallnx)
      colnames(mi_zc)=nm_fallnx
      if (length(ipos)) {
         nm_izc=c(nm_izc, paste("zc ", ipos, ">=", zc, sep=""))
         mi_zc[(1:length(ipos)),ipos]=diag(1., length(ipos))
      }
      if (length(ineg)) {
         nm_izc=c(nm_izc, paste("zc ", ineg, "<=", -zc, sep=""))
         mi_zc[length(ipos)+(1:length(ineg)),ineg]=diag(-1., length(ineg))
      }
      rownames(mi_zc)=nm_izc
      li_zc=rep(zc, length(nm_izc)) # that's ok for both pos and neg constraints
      ui_zc=cbind(mi_zc%*%(md%*%invAfl%stm%p2bfl+mf),
         matrix(0., nrow=nrow(mi_zc), ncol=nb_sc_tot))
      if (nb_fgr > 0) {
         ui_zc=cbind(ui_zc, mi_zc%*%((md%*%invAfl%stm%g2bfl)+mg*nb_f$mu))
      } else if (nb_poolf > 0) {
         ui_zc=cbind(ui_zc, matrix(0., nrow=nrow(mi_zc), ncol=nb_poolf))
      }
      ci_zc=li_zc-mi_zc%*%mic
      # remove constant inequalities
      if (ncol(ui_zc)) {
         zi=apply(ui_zc,1,function(v){return(max(abs(v))<=1.e-14)})
      } else {
         # remove all flux inequalities as there is no free params
         zi=rep(TRUE, nrow(ui_zc))
      }

      inotsat=ci_zc[zi]>1.e-10
      if (any(inotsat)) {
         cat("Warning: The following constant zc inequalities are not satisfied:\n", file=fcerr)
         cat(nm_izc[zi][inotsat], sep="\n", file=fcerr)
      }
      ui_zc=ui_zc[!zi,,drop=FALSE]
      ci_zc=ci_zc[!zi]
      nm_izc=nm_izc[!zi]
      mi_zc=mi_zc[!zi,,drop=FALSE]

      # remove redundant/contradictory inequalities
      nb_zc=nrow(ui_zc)
      nb_i=nrow(ui)
      ired=c()
      tui=t(ui)
      uzcd=sapply(seq_len(nb_zc), function(i) apply(abs(tui-ui_zc[i,]), 2L, max))
      uzcs=sapply(seq_len(nb_zc), function(i) apply(abs(tui+ui_zc[i,]), 2L, max))
      czcd=abs(outer(abs(ci), abs(ci_zc), "-"))
      ired=which(apply((uzcd < 1.e-10 | uzcs < 1.e-10) & czcd <= 1.e-2, 2, any))
      
      if (length(ired) > 0L) {
         # remove all ired inequalities
         cat("The following ", length(ired), " zerocross inequalities are redundant and are removed:\n", paste(nm_izc[ired], collapse="\n"), "\n", sep="", file=fclog)
         ui_zc=ui_zc[-ired,,drop=FALSE]
         ci_zc=ci_zc[-ired]
         nm_izc=nm_izc[-ired]
         mi_zc=mi_zc[-ired,,drop=FALSE]
      }
      if (nrow(ui_zc)) {
         # add zc inequalities
         ui=rbind(ui, ui_zc)
         ci=c(ci, ci_zc)
         nm_i=c(nm_i, nm_izc)
      }
      rm(ui_zc, ci_zc, uzcd, uzcs, czcd)
   }
   rres=NULL

   # set initial scale values to sum(measvec*simlab/dev**2)/sum(simlab**2/dev**2)
   # for corresponding measurements
   if (nb_sc_tot > 0) {
      if (optimize) {
         if (TIMEIT) {
            cat("res esti: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
         }
         capture.output(rres <- lab_resid(param, cjac=FALSE, labargs), file=fclog)
         if (!is.null(rres$err) && rres$err) {
            cat("lab_resid", runsuf, ": ", rres$mes, "\n", file=fcerr, sep="")
            close(fkvh)
            retcode[irun]=rres$err
            next
         }
         if (sum(is.infinite(rres$res))) {
            cat("Infinite values appeared in residual vector (at init scale values)", file=fcerr)
            retcode[irun]=1
            close(fkvh)
            next
         }
         for (iexp in seq_len(nb_exp)) {
            simlab=jx_f$usimlab[[iexp]]
            measinvvar=1./measurements$dev$labeled[[iexp]]**2
            ms=measvec[[iexp]]*simlab*measinvvar
            ss=simlab*simlab*measinvvar
            # get only valid measurements
            iva=!is.na(ms)
            for (i in nb_ff+nb_sc_base[iexp]+seq_len(nb_sc[[iexp]])) {
               im=(ir2isc[[iexp]]==(i+1)) & iva
               if (sum(im) < 2) {
                  mes=sprintf("scaling: no sufficient valid data for scaling factor '%s'\n", nm_par[i])
                  stop_mes(mes, fcerr)
               }
               param[i]=sum(ms[im])/sum(ss[im])
            }
         }
      } else {
         # if no optimization, set all scaling params to 1.
         param[nb_ff+seq_len(nb_sc_tot)]=1.
      }
   }

   # see if there are any active inequalities at starting point
   ineq=as.numeric(ui%*%param-ci)
   names(ineq)=rownames(ui)
   if (any(abs(ineq)<=1.e-10)) {
      cat("The following ", sum(abs(ineq)<=1.e-10), " ineqalitie(s) are active at starting point", runsuf, ":\n",
         paste(names(ineq[abs(ineq)<=1.e-10]), collapse="\n"), "\n", sep="", file=fclog)
   }

   if (TIMEIT) {
      cat("kvh init: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
   }

   cat("influx\n", file=fkvh)
   cat("\tversion\t", vernum, "\n", file=fkvh, sep="")
   cat("\tlabeling\t", if (case_i) "instationary" else "stationary", "\n", file=fkvh, sep="")
   # save options of command line
   cat("\truntime options\n", file=fkvh)
   cat("\t\tTIMEIT=TRUE\n", file=fkvh)
   
   obj2kvh(R.Version(), "R.Version", fkvh, indent=1)
   cat("\tR command line\n", file=fkvh)
   obj2kvh(opts, "opts", fkvh, indent=2)
   cat("\t\texecution date	", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fkvh)

   # resume system sizes
   obj2kvh(nb_sys, "system sizes", fkvh)

   # save initial param
   cat("starting point\n", file=fkvh)
   names(param)=nm_par
   obj2kvh(param, "starting free parameters", fkvh, indent=1)
#browser()
   if (!length(rres)) {
      capture.output(rres <- lab_resid(param, cjac=FALSE, labargs), file=fclog)
      if (!is.null(rres$err) && rres$err) {
         cat("lab_resid", runsuf, ": ", rres$mes, "\n", file=fcerr, sep="")
         close(fkvh)
         retcode[irun]=rres$err
         next
      }
      if (sum(is.infinite(rres$res))) {
         cat("Infinite values appeared in residual vector (at starting point)", file=fcerr)
         retcode[irun]=1
         close(fkvh)
         next
      }
   }
   rcost=if (length(rres$res) && !all(ina <- is.na(rres$res))) sum(crossprod(rres$res[!ina])) else NA
   obj2kvh(rcost, "starting cost value", fkvh, indent=1)

   obj2kvh(Afl, "flux system (Afl)", fkvh, indent=1)
   fg=numeric(nb_f$nb_fgr)
   names(fg)=nm_list$fgr
   if (nb_f$nb_fgr > 0) {
      fg[paste("g.n.", substring(nm_list$poolf, 4), "_gr", sep="")]=nb_f$mu*param[nm_list$poolf]
   }
   btmp=as.numeric(p2bfl%stm%param[seq_len(nb_f$nb_ff)]+bp+g2bfl%stm%fg)
   names(btmp)=dimnames(Afl)[[1]]
   obj2kvh(btmp, "flux system (bfl)", fkvh, indent=1)

   #cat("mass vector:\n", file=fclog)
   #print_mass(x)

   names(param)=nm_par

#browser()
   if (optimize && nb_ff+nb_poolf > 0L) {
      if (!(least_norm || sln || method!="nlsic")) {
         # check if at starting position all fluxes can be resolved
         if (TIMEIT) {
            cat("check ja: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
         }
         rres=lab_resid(param, cjac=TRUE, labargs)
         if (sum(is.infinite(rres$res))) {
            cat("Infinite values appeared in residual vector (at identifiability check)", file=fcerr)
            retcode[irun]=1
            close(fkvh)
            next
         }
         if (sum(is.infinite(rres$jacobian))) {
            cat("Infinite values appeared in Jacobian (at identifiability check)", file=fcerr)
            retcode[irun]=1
            close(fkvh)
            next
         }
         qrj=qr(jx_f$dr_dff, LAPACK=T)
         d=diag(qrj$qr)
         qrj$rank=sum(abs(d)>abs(d[1])*1.e-10)
         if (is.na(qrj$rank)) {
            cat("Rank of starting jacobian could not be estimated.", file=fcerr)
            retcode[irun]=1
            close(fkvh)
            next
         }
         if (qrj$rank) {
            nm_uns=nm_ff[qrj$pivot[-(1:qrj$rank)]]
         } else {
            nm_uns=nm_ff
         }
         if (qrj$rank < nb_ff) {
            # Too bad. The jacobian of free fluxes is not of full rank.
            dimnames(jx_f$dr_dff)[[2]]=c(nm_ffn, nm_ffx)
            fname="dbg_dr_dff_singular" %s+% runsuf %s+% ".csv"
            cat(sprintf("Provided measurements (labeling and fluxes) are not sufficient to resolve all free fluxes.\nUnsolvable fluxes may be:\n%s\nJacobian dr_dff is written in the result kvh file.\n",
               paste(nm_uns, sep=", ", collapse=", ")),
               file=fcerr)
            obj2kvh(jx_f$dr_dff, "Jacobian dr_dff", fkvh, indent=0)
            close(fkvh)
            retcode[irun]=1
            next
         }
      }
      if (TIMEIT) {
         cat("optim   : ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
      }
      # pass control to the chosen optimization method
      if (time_order=="1,2")
         labargs$time_order="1" # start with order 1, later continue with 2
      capture.output(res <- opt_wrapper(param, measurements, jx_f, labargs), file=fclog)
      if ((!is.null(res$err) && res$err) || is.null(res$par)) {
         cat("first optimization pass", runsuf, ": ", res$mes, "\n", sep="", file=fcerr)
         res$par=rep(NA, length(param))
         res$cost=NA
      } else if (!is.null(res$mes) && nchar(res$mes)) {
         cat("first optimization pass", runsuf, ": ", res$mes, "\n", sep="", file=fcerr)
      }
      if (any(is.na(res$par))) {
         res$retres$jx_f=NULL # to avoid writing of huge data
         obj2kvh(res, "failed first pass optimization process information", fkvh)
         cat("Optimization failed", runsuf, "\n", file=fcerr, sep="")
         close(fkvh)
         retcode[irun]=max(res$err, 1)
         next
      }
      param=res$par
#browser()
      if (zerocross && !is.null(mi_zc)) {
         if (TIMEIT) {
            cat("secondzc: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
         }
         # inverse active "zc" inequalities
         nm_inv=names(which((ui%*%res$par-ci)[,1]<=1.e-10))
         i=grep("^zc ", nm_inv, v=T)
         if (length(i) > 0) {
            i=str2ind(i, nm_i)
            cat("The following inequalities are active after first pass
of zero crossing strategy and will be inverted", runsuf, ":\n", paste(nm_i[i], collapse="\n"), "\n", sep="", file=fclog)
            ipos=grep(">=", nm_i[i], v=T)
            ineg=grep("<=", nm_i[i], v=T)
            ui[i,]=-ui[i,,drop=FALSE]
            if (length(ipos)) {
               ipzc=str2ind(ipos, nm_izc)
               ipos=str2ind(ipos, nm_i)
               ci[ipos]=as.numeric(zc+mi_zc[ipzc,,drop=FALSE]%*%mic)
               nm_i[ipos]=sub(">=", "<=-", nm_i[ipos])
            }
            if (length(ineg)) {
               inzc=str2ind(ineg, nm_izc)
               ineg=str2ind(ineg, nm_i)
               ci[ineg]=as.numeric(zc+mi_zc[inzc,,drop=FALSE]%*%mic)
               nm_i[ineg]=sub("<=-", ">=", nm_i[ineg])
            }
            rownames(ui)=nm_i
            names(ci)=nm_i
            # enforce new inequalities
            reopt=TRUE
            capture.output(pinside <- put_inside(res$par, ui, ci), file=fclog)
            if (any(is.na(pinside))) {
               if (!is.null(attr(pinside, "err")) && attr(pinside, "err")!=0) {
                  # fatal error occured, don't reoptimize
                  cat(paste("put_inside", runsuf, ": ", attr(pinside, "mes"), "\n", collapse=""), file=fcerr)
                  reopt=FALSE
               }
            } else if (!is.null(attr(pinside, "err")) && attr(pinside, "err")==0){
               # non fatal problem
               cat(paste("put_inside", runsuf, ": ", attr(pinside, "mes"), "\n", collapse=""), file=fcerr)
            }
            # reoptimize
            if (reopt) {
               cat("Second zero crossing pass", runsuf, "\n", sep="", file=fclog)
               capture.output(reso <- opt_wrapper(pinside, measurements, new.env(), labargs), file=fclog)
               if (reso$err || is.null(reso$par)) {
                  cat("second zero crossing pass: ", reso$mes, "\n", sep="", file=fcerr)
               } else if (!is.null(reso$mes) && nchar(reso$mes)) {
                  cat("second zero crossing pass", runsuf, ": ", reso$mes, "\n", sep="", file=fcerr)
               }
               if(!reso$err && !is.null(reso$par) && !any(is.na(reso$par))) {
                  param=reso$par
                  res=reso
                  jx_f=labargs$jx_f
               }
               if (any(is.na(reso$par))) {
                  reso$retres$jx_f=NULL # to avoid writing of huge data
                  obj2kvh(reso, "failed second pass optimization process information", fkvh)
                  cat("Second zero crossing pass failed. Keep free parameters from previous pass", runsuf, "\n", file=fcerr, sep="")
               }
            }
            # last pass, free all zc constraints
            i=grep("^zc ", nm_i)
            if (length(i) > 0) {
               if (TIMEIT) {
                  cat("last zc : ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
               }
               ui=ui[-i,,drop=FALSE]
               ci=ci[-i]
               nm_i=nm_i[-i]
               cat("Last zero crossing pass (free of zc constraints)", runsuf, "\n", sep="", file=fclog)
               capture.output(reso <- opt_wrapper(param, measurements, new.env(), labargs), file=fclog)
               if (reso$err || is.null(reso$par) || (!is.null(res$mes) && nchar(res$mes))) {
                  cat("last zero crossing (free of zc)", runsuf, ": ", reso$mes, "\n", sep="", file=fcerr)
               }
               if(!reso$err && !is.null(reso$par) && !any(is.na(reso$par))) {
                  param=reso$par
                  res=reso
                  jx_f=labargs$jx_f
               }
               if (any(is.na(res$par))) {
                  res$retres$jx_f=NULL # to avoid writing of huge data
                  obj2kvh(res, "failed last pass optimization process information", fkvh)
                  cat("Last zero crossing pass failed. Keep free parameters from previous passes", runsuf, "\n", file=fcerr, sep="")
               }
            }
         } else {
            cat("After the first optimization, no zero crossing inequality was activated. So no reoptimization", runsuf, "\n", sep="", file=fclog)
         }
      } # end if zero crossing
      param=res$par
      names(param)=nm_par
      if (excl_outliers != F) {
         # detect outliers
         if (TIMEIT) {
            cat("outliers: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
         }
         iva=!is.na(res$res)
         zpval=rz.pval.bi(res$res)
         iout=which(zpval <= excl_outliers & iva)
         #cat("iout=", iout, "\n", file=fclog)
         if (length(iout)) {
            measurements$outlier=iout
            outtab=cbind(residual=res$res[iout], `p-value`=zpval[iout])
            row.names(outtab)=nm_resid[iout]
            cat("Excluded outliers at p-value ", excl_outliers, ":\n", sep="", file=fclog)
            write.table(outtab, file=fclog, append=TRUE, quote=FALSE, sep="\t", col.names=FALSE)
            
            capture.output(reso <- opt_wrapper(param, measurements, new.env(), labargs), file=fclog)
            if (reso$err || is.null(reso$par) || (!is.null(reso$mes) && nchar(reso$mes))) {
               cat("wo outliers: ", reso$mes, "\n", sep="", file=fcerr)
            }
            if (any(is.na(reso$par))) {
               cat("Optimization with outliers excluded has failed, run= ", runsuf, "\n", file=fcerr, sep="")
               # continue without outlier exclusion
               measurements$outlier=NULL
            } else {
               res=reso
               param=reso$par
               names(param)=nm_par
               jx_f=labargs$jx_f
               labargs$measurements=measurements # store outliers
               obj2kvh(outtab, "excluded outliers", fkvh)
            }
         } else {
            cat("Outlier exclusion at p-value "%s+%excl_outliers%s+%" has been requested but no outlier was detected at this level.", "\n", sep="", file=fcerr)
         }
      }
      if (case_i && time_order=="1,2") {
         if (TIMEIT) {
            cat("order 2 : ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
         }
         labargs$time_order="2" # continue with the 2-nd order
         capture.output(reso <- opt_wrapper(param, measurements, new.env(), labargs), file=fclog)
         if (reso$err || is.null(reso$par) || (!is.null(reso$mes) && nchar(reso$mes))) {
            cat("order2: ", reso$mes, "\n", sep="", file=fcerr)
         }
         if (any(is.na(reso$par))) {
            cat("Optimization time_order 2 (in '1,2' suite) has failed, run=", runsuf, "\n", file=fcerr, sep="")
         } else {
            res=reso
            param=reso$par
            names(param)=nm_par
            jx_f=labargs$jx_f
         }
      }
#browser()
      optinfo=list(
         "fitted parameters"=param,
         "last increment before backtracking"=res$lastp,
         "last increment after backtracking"=res$laststep,
         "iteration number"=res$it,
         "convergence history"=res$hist,
         "exit message"=res$mes
      )
      obj2kvh(optinfo, "optimization process information", fkvh)
      rres=res$retres
   } else {
      rres=lab_resid(param, TRUE, labargs)
   }
   if (TIMEIT) {
      cat("postopt : ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
   }
   # active constraints
   ine=as.numeric(abs(ui%*%param-ci))<1.e-10
   if (any(ine)) {
      obj2kvh(nm_i[ine], "active inequality constraints", fkvh)
   }
   poolall[nm_poolf]=param[nm_poolf]

#browser()
   if (is.null(jx_f$jacobian)) {
      # final jacobian calculation
      capture.output(rres <- lab_resid(param, cjac=TRUE, labargs), file=fclog)
      if (!is.null(rres$err) && rres$err) {
         cat("lab_resid", runsuf, ": ", rres$mes, "\n", file=fcerr, sep="")
         close(fkvh)
         retcode[irun]=rres$err
         next
      }
   }
   rcost=cumo_cost(param, labargs, rres)
   pres[,irun]=param
   costres[irun]=rcost
   obj2kvh(rcost, "final cost", fkvh)
#browser()
   # get z p-values on residual vector
   zpval=rz.pval.bi(rres$res)
   resid=list()
   if (sum(nb_meas)) {
      resid[["labeled data"]]=lapply(seq_len(nb_exp), function(iexp) if (is.matrix(jx_f$reslab[[iexp]])) jx_f$reslab[[iexp]] else cbind(residual=jx_f$reslab[[iexp]], `p-value`=zpval[seq_along(jx_f$reslab[[iexp]])]))
      names(resid[["labeled data"]])=nm_exp
   
      if (case_i) {
         resid[["labeled data p-value"]]=vector("list", nb_exp)
         names(resid[["labeled data p-value"]])=nm_exp
         for (iexp in seq_len(nb_exp)) {
            mtmp=zpval[seq_along(jx_f$reslab[[iexp]])]
            dim(mtmp)=dim(jx_f$reslab[[iexp]])
            dimnames(mtmp)=dimnames(jx_f$reslab[[iexp]])
            resid[["labeled data p-value"]][[iexp]]=mtmp
            rm(mtmp)
         }
      }
   }
   nb_reslab_tot=sum(sapply(jx_f$reslab, length))
   if (length(jx_f$resflu))
      resid[["measured fluxes"]]=cbind(residual=jx_f$resflu, `p-value`=zpval[nb_reslab_tot+seq_along(jx_f$resflu)])
   if (length(jx_f$respool))
      resid[["measured pools"]]=cbind(residual=if (is.matrix(jx_f$respool)) jx_f$respool[,1] else jx_f$respool, `p-value`=zpval[nb_reslab_tot+length(jx_f$resflu)+seq_along(jx_f$respool)])
   obj2kvh(resid, "(simulated-measured)/sd_exp", fkvh)
   rm(resid, zpval)

   # simulated measurements -> kvh
   simul=list()
#browser()
   if (case_i) {
      if (sum(nb_meas)) {
         if (addnoise) {
            simul[["labeled data"]]=lapply(seq_len(nb_exp), function(iexp) jx_f$usm[[iexp]]+rnorm(length(jx_f$usm[[iexp]]))*measurements$dev$labeled[[iexp]])
            names(simul[["labeled data"]])=nm_exp
         } else {
            simul[["labeled data"]]=jx_f$usm
         }
      }
   } else {
      if (sum(nb_meas)) {
         if (addnoise) {
            simlab=lapply(seq_len(nb_exp), function(iexp) jx_f$simlab[[iexp]]+rnorm(length(jx_f$simlab[[iexp]]))*measurements$dev$labeled[[iexp]])
            names(simlab)=nm_exp
         } else {
            simlab=jx_f$simlab
         }
         if (nb_sc_tot > 0) {
            simul[["labeled data (unscaled)"]]=jx_f$usimlab
            simul[["labeled data (scaled)"]]=simlab
         } else {
            simul[["labeled data"]]=simlab
         }
      }
   }
   if (nb_fmn) {
      if (addnoise)
         simul[["measured fluxes"]]=jx_f$simfmn+rnorm(length(jx_f$simfm))*measurements$dev$flux
      else
         simul[["measured fluxes"]]=jx_f$simfmn
   }
   if (nb_poolm) {
      if (addnoise)
         simul[["measured pools"]]=jx_f$simpool+rnorm(length(jx_f$simpool))*measurements$dev$pool
      else
         simul[["measured pools"]]=jx_f$simpool
   }
   obj2kvh(simul, "simulated measurements", fkvh)
   
   # SD -> kvh
   # get index of non null components
   iget=sapply(names(measurements$dev), function(nm) !is.null(measurements$dev[[nm]]) & nm %in% c("labeled", "flux", "pool"))
   obj2kvh(measurements$dev[iget], "measurement SD", fkvh)

   # gradient -> kvh
   if (length(jx_f$res) && !all(ina <- is.na(jx_f$res))) {
      if (any(ina)) {
         gr=2*as.numeric(crossprod(jx_f$res[!ina], jx_f$jacobian[!ina,,drop=FALSE]))
      } else {
         gr=2*as.numeric(crossprod(jx_f$res, jx_f$jacobian))
      }
      names(gr)=nm_par
      obj2kvh(gr, "gradient vector", fkvh)
   }
   colnames(jx_f$udr_dp)=nm_par
   obj2kvh(jx_f$udr_dp, "jacobian dr_dp (without 1/sd_exp)", fkvh)
   # generalized inverse of non reduced jacobian
   svj=svd(jx_f$udr_dp)
   invj=svj$v%*%(t(svj$u)/svj$d)
   dimnames(invj)=rev(dimnames(jx_f$udr_dp))
   obj2kvh(invj, "generalized inverse of jacobian dr_dp (without 1/sd_exp)", fkvh)

   labargs$getx=TRUE
   labargs$labargs2getx=TRUE
   if (fullsys) {
      nm_flist=nm_list
      nm_flist$rcumo=nm_cumo
      nm_flist$rcumo_in_cumo=match(nm_rcumo, nm_cumo)
      nb_f$cumos=nb_cumos
      nm_xi_f=c()
      xi_f=matrix(c(), ncol=nb_exp)
      dimnames(xi_f)[[1]]=nm_xi_f
      nm_flist$xi=nm_xi_f
      labargs$emu=F
      v=lab_sim(param, cjac=FALSE, labargs)
      labargs$emu=emu
      x=if (case_i) v$xf else v$x
   } else {
      v=lab_sim(param, cjac=FALSE, labargs)
      x=if (case_i) v$xf else v$x
   }

   # write some info in result kvh
   mid=cumo2mass(x)
   if (case_i) {
      mid=lapply(mid, function(m) m[sort(rownames(m)),,drop=FALSE])
   } else if (length(mid)) {
      mid=mid[sort(rownames(mid)),,drop=FALSE]
   }
   obj2kvh(mid, "MID vector", fkvh)
   
   # constrained fluxes to kvh
   obj2kvh(fallnx[nm_fc], "constrained net-xch01 fluxes", fkvh)

   fwrv=v$lf$fwrv
   fallnx=v$lf$fallnx
   flnx=v$lf$flnx
   fgr=fallnx[nm_fgr]

   # keep last jx_f in jx_f_last
#browser()
   while (sensitive=="mc") {
      if (TIMEIT) {
         cat("monte-ca: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
      }
      if (set_seed) {
         set.seed(seed)
      }
      # reference simulation corresponding to the final param
      refsim=new.env()
      for (nm_it in c("simlab", "simfmn", "simpool", "usm")) {
         assign(nm_it, jx_f[[nm_it]], envir=refsim)
      }
      # Monte-Carlo simulation in parallel way (if asked and possible)
      if (np > 1L) {
         spli=splitIndices(nmc, nodes);
         clusterExport(cl, c("param", "refsim", "runsuf", "spli"))
         #clusterEvalQ(cl, labargs$spa[[1]]$a <- NULL) # to rebuild sparse matrices on cores ## now, they are build once, at the cluster init
         cl_res=clusterEvalQ(cl, {mc_iter=TRUE; labargs$getx=FALSE; mc_res=lapply(spli[[idw]], mc_sim); rm(mc_iter); mc_res})
         mc_res=vector(nmc, mode="list")
         for (i in seq(nodes))
            mc_res[spli[[i]]]=cl_res[[i]]
         #mc_res=parLapplyLB(cl, seq_len(nmc), function(imc) cl_worker(funth=mc_sim, argth=list(imc)))
      } else {
         mc_res=lapply(seq_len(nmc), function(imc) cl_worker(funth=mc_sim, argth=list(imc)))
      }
      free_mc=sapply(mc_res, function(l) {if (class(l)=="character" || is.null(l) || is.na(l$cost) || l$err) { ret=rep(NA, nb_param+3) } else { ret=c(l$cost, l$it, l$normp, l$par) }; ret })
      if (length(free_mc)==0) {
         cat("Parallel exectution of Monte-Carlo simulations has failed.", "\n", sep="", file=fcerr)
         free_mc=matrix(NA, nb_param+2, 0)
      }
      cost_mc=free_mc[1,]
      nmc_real=nmc-sum(is.na(free_mc[4,]))
      cat("monte-carlo\n", file=fkvh)
      indent=1
      obj2kvh(cl_type, "cluster type", fkvh, indent)
      obj2kvh(avaco, "detected cores", fkvh, indent)
      avaco=max(1, avaco, na.rm=T)
      obj2kvh(min(avaco, np, na.rm=T), "used cores", fkvh, indent)
      cat("\tfitting samples\n", file=fkvh)
      indent=2
      obj2kvh(nmc, "requested number", fkvh, indent)
      obj2kvh(nmc_real, "calculated number", fkvh, indent)
      obj2kvh(nmc-nmc_real, "failed to calculate", fkvh, indent)
      # convergence section in kvh
      indent=1
      mout=rbind(round(free_mc[1:2,,drop=FALSE], 2),
         format(free_mc[3,,drop=FALSE], di=2, sci=T))
      dimnames(mout)=list(c("cost", "it.numb", "normp"), seq_len(ncol(free_mc)))
      obj2kvh(mout, "convergence per sample", fkvh, indent)
      # remove failed m-c iterations
      free_mc=free_mc[-(1:3),,drop=FALSE]
      ifa=which(is.na(free_mc[1,]))
      if (length(ifa)) {
         if (ncol(free_mc) > length(ifa)) {
            cat("Some Monte-Carlo iterations failed.", "\n", sep="", file=fcerr)
         }
         free_mc=free_mc[,-ifa,drop=FALSE]
         cost_mc=cost_mc[-ifa]
      }
      if (nmc_real <= 1) {
         cat("No sufficient Monter-Carlo samples were successfully calculated to do any statistics.", "\n", sep="", file=fcerr)
         retcode[irun]=1
         break
      }
#browser()
      rownames(free_mc)=nm_par
      
      # cost section in kvh
      cat("\tcost\n", file=fkvh)
      indent=2
      obj2kvh(mean(cost_mc), "mean", fkvh, indent)
      obj2kvh(median(cost_mc), "median", fkvh, indent)
      obj2kvh(sd(cost_mc), "sd", fkvh, indent)
      obj2kvh(sd(cost_mc)*100/mean(cost_mc), "rsd (%)", fkvh, indent)
      obj2kvh(quantile(cost_mc, c(0.025, 0.95, 0.975)), "ci", fkvh, indent)
      
      # free parameters section in kvh
      cat("\tStatistics\n", file=fkvh)
      mout=c()
      indent=2
      # param stats
      # mean
      parmean=apply(free_mc, 1, mean)
      # median
      parmed=apply(free_mc, 1, median)
#browser()
      # covariance matrix
      covmc=cov(t(free_mc))
      obj2kvh(covmc, "covariance", fkvh, indent)
      # sd
      sdmc=sqrt(diag(covmc))
      # confidence intervals
      ci_mc=t(apply(free_mc, 1, quantile, probs=c(0.025, 0.975)))
      ci_mc=cbind(ci_mc, t(diff(t(ci_mc))))
      colnames(ci_mc)=c("CI 2.5%", "CI 97.5%", "CI length")
      mout=cbind(mout, mean=parmean, median=parmed, sd=sdmc,
         "rsd (%)"=sdmc*100/abs(parmean), ci_mc)
      obj2kvh(mout, "free parameters", fkvh, indent)

      # net-xch01 stats
      fallnx_mc=apply(free_mc, 2, function(p)param2fl(p, labargs)$fallnx)
      fallnx=param2fl(param, labargs)$fallnx
      if (length(fallnx_mc)) {
         dimnames(fallnx_mc)[[1]]=nm_fallnx
         # form a matrix output
         fallout=matrix(0, nrow=nrow(fallnx_mc), ncol=0)
         # mean
#browser()
         parmean=apply(fallnx_mc, 1, mean)
         # median
         parmed=apply(fallnx_mc, 1, median)
         # covariance matrix
         covmc=cov(t(fallnx_mc))
         dimnames(covmc)=list(nm_fallnx, nm_fallnx)
         # sd
         sdmc=sqrt(diag(covmc))
         # confidence intervals
         ci_mc=t(apply(fallnx_mc, 1, quantile, probs=c(0.025, 0.975)))
         ci_mc=cbind(ci_mc, t(diff(t(ci_mc))))
         ci_mc=cbind(ci_mc, ci_mc[,3]*100/abs(parmean))
         colnames(ci_mc)=c("CI 2.5%", "CI 97.5%", "CI 95% length", "relative CI (%)")
         fallout=cbind(fallout, mean=parmean, median=parmed, sd=sdmc,
            "rsd (%)"=sdmc*100/abs(fallnx), ci_mc)
         o=order(nm_fallnx)
         obj2kvh(fallout[o,,drop=FALSE], "all net-xch01 fluxes", fkvh, indent)
         obj2kvh(covmc[o,o], "covariance of all net-xch01 fluxes", fkvh, indent)

         # fwd-rev stats
         fwrv_mc=apply(free_mc, 2, function(p)param2fl(p, labargs)$fwrv)
         dimnames(fwrv_mc)[[1]]=nm_fwrv
         fallout=matrix(0, nrow=nrow(fwrv_mc), ncol=0)
         # mean
         parmean=apply(fwrv_mc, 1, mean)
         # median
         parmed=apply(fwrv_mc, 1, median)
         # covariance matrix
         covmc=cov(t(fwrv_mc))
         dimnames(covmc)=list(nm_fwrv, nm_fwrv)
         # sd
         sdmc=sqrt(diag(covmc))
         # confidence intervals
         ci_mc=t(apply(fwrv_mc, 1, quantile, probs=c(0.025, 0.975)))
         ci_mc=cbind(ci_mc, t(diff(t(ci_mc))))
         ci_mc=cbind(ci_mc, ci_mc[,3]*100/abs(fwrv))
         dimnames(ci_mc)[[2]]=c("CI 2.5%", "CI 97.5%", "CI 95% length", "relative CI (%)")
         fallout=cbind(fallout, mean=parmean, median=parmed, sd=sdmc,
            "rsd (%)"=sdmc*100/abs(parmean), ci_mc)
         o=order(nm_fwrv)
         obj2kvh(fallout[o,,drop=FALSE], "forward-reverse fluxes", fkvh, indent)
         obj2kvh(covmc[o,o], "covariance of forward-reverse fluxes", fkvh, indent)
      }
      break
   }
#browser()
   if (length(sensitive) && nchar(sensitive) && sensitive != "mc") {
      cat(paste("Unknown sensitivity '", sensitive, "' method chosen.", sep=""), "\n", sep="", file=fcerr)
      retcode[irun]=1
   }

   if (TIMEIT) {
      cat("linstats: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
   }
   # Linear method based on jacobian x_f
   # reset fluxes and jacobians according to param
   if (is.null(jx_f$jacobian)) {
      capture.output(rres <- lab_resid(param, cjac=TRUE, labargs), file=fclog)
      if (!is.null(rres$err) && rres$err) {
         cat("lab_resid", runsuf, ": ", rres$mes, "\n", file=fcerr, sep="")
         close(fkvh)
         retcode[irun]=rres$err
         next
      }
   } # else use the last calculated jacobian

   # covariance matrix of free fluxes
   svj=svd(jx_f$jacobian)
   if (svj$d[1] == 0.) {
      i=rep(TRUE, length(svj$d))
   } else {
      i=svj$d/svj$d[1]<1.e-10
      if (all(!i) && svj$d[1]<1.e-10) {
         # we could not find very small d, take just the last
         i[length(i)]=TRUE
      }
   }
   ibad=apply(svj$v[, i, drop=FALSE], 2, which.contrib)
   ibad=unique(unlist(ibad))
   if (length(ibad) > 0) {
      cat(paste(if (nchar(runsuf)) runsuf%s+%": " else "", "Inverse of covariance matrix is numerically singular.\nStatistically undefined parameter(s) seems to be:\n",
         paste(sort(nm_par[ibad]), collapse="\n"), "\nFor more complete list, see sd columns in '/linear stats'\nin the result file.", sep=""), "\n", sep="", file=fcerr)
   }
   # "square root" of covariance matrix (to preserve numerical positive definitness)
   rtcov=(svj$u)%*%(t(svj$v)/svj$d)
   # standart deviations of free fluxes
   cat("linear stats\n", file=fkvh)

   # sd free+dependent+growth net-xch01 fluxes
   nm_flfd=c(nm_ff, nm_fgr, nm_fl)
   if (nb_ff > 0 || nb_fgr > 0) {
      i=1:nb_param
      i=c(head(i, nb_ff), tail(i, nb_fgr))
      covfl=crossprod(rtcov[, i, drop=FALSE]%mmt%(rbind(diag(nb_ff+nb_fgr), dfl_dffg)%mrv%c(rep.int(1., nb_ff), fgr)))
      dimnames(covfl)=list(nm_flfd, nm_flfd)
      sdfl=sqrt(diag(covfl))
   } else {
      sdfl=rep(0., nb_fl)
      covfl=matrix(0., nb_fl, nb_fl)
   }
   fl=c(head(param, nb_ff), fgr, flnx)
   stats_nx=cbind("value"=fl, "sd"=sdfl, "rsd"=sdfl/abs(fl))
   rownames(stats_nx)=nm_flfd
   o=order(nm_flfd)
   obj2kvh(stats_nx[o,,drop=FALSE], "net-xch01 fluxes (sorted by name)", fkvh, indent=1)
   obj2kvh(covfl[o, o], "covariance net-xch01 fluxes", fkvh, indent=1)

   # sd of all fwd-rev
   if (nb_ff > 0 || nb_fgr > 0) {
      i=1:nb_param
      i=c(head(i, nb_ff), tail(i, nb_fgr))
      covf=crossprod(tcrossprod_simple_triplet_matrix(rtcov[,i, drop=FALSE], jx_f$df_dffp%mrv%c(rep.int(1., nb_ff), head(poolall[nm_poolf], nb_fgr))))
      dimnames(covf)=list(nm_fwrv, nm_fwrv)
      sdf=sqrt(diag(covf))
   } else {
      sdf=rep(0., length(fwrv))
   }
   mtmp=cbind(fwrv, sdf, sdf/abs(fwrv))
   dimnames(mtmp)[[2]]=c("value", "sd", "rsd")
   o=order(nm_fwrv)
   obj2kvh(mtmp[o,], "fwd-rev fluxes (sorted by name)", fkvh, indent=1)
   if (nb_ff > 0 || nb_fgr > 0) {
      obj2kvh(covf, "covariance fwd-rev fluxes", fkvh, indent=1)
   }
   # pool -> kvh
   sdpf=poolall
   sdpf[]=0.

   if (nb_poolf > 0) {
      # covariance matrix of free pools
      # "square root" of covariance matrix (to preserve numerical positive definitness)
      poolall[nm_poolf]=param[nm_poolf]
      # cov poolf
      covpf=crossprod(rtcov[,nb_ff+nb_sc_tot+seq_len(nb_poolf), drop=FALSE])
      dimnames(covpf)=list(nm_poolf, nm_poolf)
      sdpf[nm_poolf]=sqrt(diag(covpf))
   }
   if (length(poolall) > 0) {
      mtmp=cbind("value"=poolall, "sd"=sdpf, "rsd"=sdpf/poolall)
      rownames(mtmp)=nm_poolall
      o=order(nm_poolall)
      obj2kvh(mtmp[o,,drop=FALSE], "metabolite pools (sorted by name)", fkvh, indent=1)
      if (nb_poolf > 0) {
         o=order(nm_poolf)
         obj2kvh(covpf[o, o], "covariance free pools", fkvh, indent=1)
      }
   }

   # khi2 test for goodness of fit
   # goodness of fit (khi2 test)
   if (length(jx_f$res)) {
      nvres=sum(!is.na(jx_f$res))
      if (nvres >= nb_param) {
         khi2test=list("khi2 value"=rcost, "data points"=nvres,
            "fitted parameters"=nb_param, "degrees of freedom"=nvres-nb_param)
         khi2test$`khi2 reduced value`=khi2test$`khi2 value`/khi2test$`degrees of freedom`
         khi2test$`p-value, i.e. P(X^2<=value)`=pchisq(khi2test$`khi2 value`, df=khi2test$`degrees of freedom`)
         khi2test$conclusion=if (khi2test$`p-value, i.e. P(X^2<=value)` > 0.95) "At level of 95% confidence, the model does not fit the data good enough with respect to the provided measurement SD" else "At level of 95% confidence, the model fits the data good enough with respect to the provided measurement SD"
         obj2kvh(khi2test, "goodness of fit (khi2 test)", fkvh, indent=1)
      } else {
         cat(sprintf("khi2: Measurement number %d is lower than parameter number %d. Khi2 test cannot be done.\n", nvres, nb_param), sep="", file=fcerr)
      }
   }
   if (prof) {
      Rprof(NULL)
   }
   close(fkvh)
   # write edge.netflux property
   fedge=file(file.path(dirw, sprintf("edge.netflux.%s%s.attrs", baseshort,  runsuf)), "w")
   cat("netflux (class=Double)\n", sep="", file=fedge)
   nm_edge=names(edge2fl)
   cat(paste(nm_edge, fallnx[edge2fl], sep=" = "), sep="\n" , file=fedge)
   close(fedge)

   # write edge.xchflux property
   fedge=file(file.path(dirw, sprintf("edge.xchflux.%s%s.attrs", baseshort,  runsuf)), "w")
   flxch=paste(".x", substring(edge2fl, 4), sep="")
   ifl=charmatch(flxch, substring(names(fallnx), 2))
   cat("xchflux (class=Double)\n", sep="", file=fedge)
   cat(paste(nm_edge, fallnx[ifl], sep=" = "), sep="\n" , file=fedge)
   close(fedge)

   # write node.log2pool property
   if (length(poolall)> 0) {
      fnode=file(file.path(dirw, sprintf("edge.xchflux.%s%s.attrs", baseshort,  runsuf)), "w")
      cat("log2pool (class=Double)\n", sep="", file=fnode)
      nm_node=substring(names(poolall), 4)
      cat(paste(nm_node, log2(poolall), sep=" = "), sep="\n" , file=fnode)
      close(fnode)
   }
}
if (!is.null(cl)) {
   stopCluster(cl)
   labargs$cl=cl=NULL
}

pres=rbind(cost=costres, pres)
fco=file(file.path(dirw, sprintf("%s.pres.csv", baseshort)), open="w")
cat("row_col	", file=fco)
write.table(file=fco, pres, row.n=T, quot=F, sep="\t")
close(fco)
if (TIMEIT) {
   cat("rend    : ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}

# source files from FTBL/posttreat_R
postlist=strsplit("save_all.R", " *; *")[[1]]
for (post in postlist) {
   fpostR=file.path(dirw, post)
   if (file.exists(fpostR) && !isTRUE(file.info(fpostR)$isdir)) {
      source(fpostR)
   } else {
      # not found in 'dirw', try 'dirr'
      fpostR=file.path(dirr, post)
      if (file.exists(fpostR) && !isTRUE(file.info(fpostR)$isdir)) {
         source(fpostR)
      } else {
         cat(sprintf("Posttreatment R file '%s' does not exist in ftbl directory neither in influx_si one. Ignored.\n", post), file=fcerr)
      }
   }
}
xgc=gc(verbose=FALSE) # to avoid the message "Error in (function (x)  : tentative d'appliquer un objet qui n'est pas une fonction"
close(fclog)
close(fcerr)
retcode=max(retcode)
if (format(parent.frame()) == format(.GlobalEnv)) {
   q("no", status=retcode)
}
